SystemOrganization addCategory: #'Xpf-Client-ProjectTalk'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-AdminTool'!
SystemOrganization addCategory: #'Xpf-Client-Models'!
SystemOrganization addCategory: #'Xpf-Client-Proxies'!
SystemOrganization addCategory: #'Xpf-Client-Widgets'!
SystemOrganization addCategory: #'Xpf-Client'!
SystemOrganization addCategory: #'Xpf-Client-Rfb'!
SystemOrganization addCategory: #'Xpf-Client-Taskbar'!
SystemOrganization addCategory: #'Xpf-Client-ProjectTalk-New'!
SystemOrganization addCategory: #'Xpf-Client-ProjectTalk-Animations'!

!Time methodsFor: '*xpf-client' stamp: 'mt 4/29/2009 11:54'!
print24WithoutSeconds
	"Return as 8-digit string 'hh:mm', with leading zeros if needed"

	^ String streamContents:
		[ :aStream | self print24: true showSeconds: false on: aStream ]! !

RestPrefetchProxyObject subclass: #XpfProxyObject
	instanceVariableNames: 'updateCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyObject methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:47'!
currentUser

	^ self repository currentUser! !

!XpfProxyObject methodsFor: 'updating' stamp: 'cs 5/15/2009 15:04'!
needsUpdate

	| needsUpdate |
	self isDeleted ifTrue: [^ false].
	self updateCounter: self updateCounter - 1.
	needsUpdate := self updateCounter = 0.
	self updateCounter <= 0 ifTrue: [self updateCounter: self updateInterval].
	^ needsUpdate! !

!XpfProxyObject methodsFor: 'helping' stamp: 'cs 4/17/2009 16:52'!
parseJsonKey: key value: value

	^ key = 'timestamp'
		ifTrue: [key -> (TimeStamp fromString: value)]
		ifFalse: [super parseJsonKey: key value: value].! !

!XpfProxyObject methodsFor: 'printing' stamp: 'cs 4/17/2009 13:11'!
printString

	(self includesProperty: #title) ifTrue: [^ self title].
	(self includesProperty: #userName) ifTrue: [^ self userName].
	^ super printString! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:55'!
properties: aDictionary 

	| wasLoaded |
	wasLoaded := self isLoaded and: [self isDeleted not].
	super properties: aDictionary.
	self updateCounter: self updateInterval.
	(wasLoaded and: [self isDeleted]) ifTrue: [self delete].! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'mig 4/3/2009 15:29'!
revision

	^ properties isNil
		ifTrue: [nil]
		ifFalse: [super revision]! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:38'!
updateCounter

	^ updateCounter ifNil: [0]! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:34'!
updateCounter: anObject

	updateCounter := anObject.! !

TextMorph subclass: #XpfOverlayMessage
	instanceVariableNames: 'delta maxDelta stepSize isDisappearing hand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-Animations'!

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:18'!
contents: aString

	^ self new contents: aString! !

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:18'!
show: aString at: aPoint

	(self contents: aString)
		position: aPoint;
		openInWorld;
		disappear.! !

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 14:49'!
show: aString atHand: aHand

	| msg |
	msg := self contents: aString.
	msg topLeft: aHand topLeft + (16 @ 0).
	msg hand: aHand.
	msg openInWorld.
	msg disappear.! !

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'mt 11/7/2009 12:20'!
showAtAllHands: aString

	World hands do: [:hand |
		hand submorphs do: [:m | (m isKindOf: XpfOverlayMessage)
			ifTrue: [m delete]].
		self show: aString atHand: hand].! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 12/30/2009 14:49'!
delta

	^ delta ifNil: [delta := 0]! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:01'!
delta: anObject

	delta := anObject.! !

!XpfOverlayMessage methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:14'!
disappear

	self isDisappearing: true.! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:24'!
hand

	^ hand! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:23'!
hand: anObject

	hand := anObject.! !

!XpfOverlayMessage methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:06'!
initialize

	super initialize.
	self stopStepping.! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:07'!
isDisappearing

	^ isDisappearing ifNil: [isDisappearing := false]! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:07'!
isDisappearing: anObject

	isDisappearing := anObject.! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:02'!
maxDelta

	^ maxDelta ifNil: [maxDelta := 20]! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:01'!
maxDelta: anObject

	maxDelta := anObject.! !

!XpfOverlayMessage methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:30'!
step

	self isDisappearing
		ifFalse: [^ self].

	self delta >= self maxDelta
		ifTrue: [self delete. ^ self].

	self delta: self delta + self stepSize.

	self hand
		ifNil: [self y: self y + self stepSize]
		ifNotNil: [self topLeft: self hand topLeft + (16 @ self delta)].
		
	self textColor: (self textColor alpha: (self textColor alpha - 0.05)).
	! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:03'!
stepSize

	^ stepSize ifNil: [stepSize := 1]! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:03'!
stepSize: anObject

	stepSize := anObject.! !

!XpfOverlayMessage methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:09'!
stepTime

	^ 50! !

TextMorph subclass: #XpfPluggableTextMorph
	instanceVariableNames: 'model getTextSelector isTruncatedWithEllipsis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 20:18'!
on: model getTextSelector: selector

	^ self new
		model: model;
		getTextSelector: selector;
		yourself
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 20:18'!
changed

	super changed.
	(self model notNil and: [self getTextSelector notNil])
		ifTrue: [
			self update: self getTextSelector.
			self font: XpfClient sansFont].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector

	^ getTextSelector
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector: anObject

	getTextSelector := anObject.
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 15:53'!
isTruncatedWithEllipsis
	"Discard all linebreaks and show first line with ellipsis according to extent."

	isTruncatedWithEllipsis ifNil: [self isTruncatedWithEllipsis: false].
	^ isTruncatedWithEllipsis! !

!XpfPluggableTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 15:52'!
isTruncatedWithEllipsis: aBoolean

	isTruncatedWithEllipsis := aBoolean! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model

	^ model
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 16:00'!
modelData

	^ (self model perform: self getTextSelector) ifNil: ['']! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 11:39'!
update: aSymbol

	aSymbol = self getTextSelector ifTrue: [
		self isTruncatedWithEllipsis
			ifFalse: [self updateContents]
			ifTrue: [self updateContentsTruncated]].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 16:00'!
updateContents

	self contentsWrapped: self modelData.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 11:36'!
updateContentsTruncated

	self contents: (self modelData asString withoutLineEndingsTruncatedTo: 20).! !

!TimeStamp methodsFor: '*xpf-client' stamp: 'mt 4/29/2009 11:54'!
printRelativeTimeStamp

	^ (self date printRelativeDate, ', ', self time print24WithoutSeconds)! !

PanelMorph subclass: #XpfDeveloperListEntryMorph
	instanceVariableNames: 'user onlineIcon userNameText connectDisconnectButton clientTunnel rfbClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfDeveloperListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 13:57'!
forUser: anXpfUser

	^ self new
		user: anXpfUser! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 7/8/2009 18:46'!
connect

	| forwardedVncClienPort |
	forwardedVncClienPort := 15000.
	clientTunnel := SSHTunnel new
							isLocalTunnel: true;
							localPort: forwardedVncClienPort;
							remotePort: self user sharingPort;
							server: self user repository url authority.
	clientTunnel execute.
	
	(0 to: 10) 
		do: [:ignore | (Delay forMilliseconds: 600) wait]
		displayingProgress: 'Giving SSH connection some time...'.

	rfbClient := RFBClient open.
	rfbClient xpfUserId: ActiveHand login.
	rfbClient connectToRfbHub: forwardedVncClienPort.! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'mt 5/6/2009 10:54'!
connectDisconnect

	self isConnected 
		ifFalse: [
			self connectDisconnectButton labelGraphic: MenuIcons xpfScreenDisconnect.
			self connect] 
		ifTrue: [
			self connectDisconnectButton labelGraphic: MenuIcons xpfScreenIndicatedShared.
			self disconnect].! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:22'!
connectDisconnectButton

	connectDisconnectButton ifNil: 
		[ self connectDisconnectButton: ((IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfScreenIndicatedShared;
			actionSelector: #connectDisconnect;
			setBalloonText: '')
			visible: self user sharingPort notNil)].	
	^ connectDisconnectButton! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:40'!
connectDisconnectButton: anObject 

	connectDisconnectButton := anObject! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'mt 4/27/2009 13:42'!
connectDisconnectLabel

	^ MenuIcons xpfScreenIndicatedShared asMorph! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 4/27/2009 21:08'!
disconnect

	rfbClient ifNotNil: [
		rfbClient disconnectFromRfbHub.
		rfbClient close.
		rfbClient := nil].
	
	clientTunnel ifNotNil: [
		clientTunnel terminate.
		clientTunnel := nil].! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/5/2009 10:40'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		listCentering: #center;
		hResizing: #spaceFill;
		vResizing: #rigid;
		width: XpfDeveloperListWidget defaultExtent x;
		height: 20;
		cellInset: 4.! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 14:02'!
initializeUserInterface

	self
		removeAllMorphs;
		addMorphBack: self onlineIcon;
		addMorphBack: self userNameText;
		addMorphBack: self connectDisconnectButton.! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 4/27/2009 18:59'!
isConnected
	
	^ clientTunnel notNil! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:59'!
onlineIcon

	onlineIcon ifNil: [self onlineIcon:
		(XpfPluggableImageMorph
			formOn: MenuIcons xpfDeveloperIsOnline
			formOff: MenuIcons xpfDeveloperIsOffline
			model: self user
			getOnOffSelector: #isOnline)].
	^ onlineIcon! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:35'!
onlineIcon: anObject

	onlineIcon := anObject.! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 16:54'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #sharingPort ifTrue: [
		self changed: #connectDisconnectLabel.
		self connectDisconnectButton visible: self user sharingPort notNil.
		self connectDisconnectButton setBalloonText: self user sharingPort asString].! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:57'!
user

	^ user! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:02'!
user: anXpfUser

	user ifNotNil: [user removeDependent: self].
	user := anXpfUser.
	user ifNotNil: [user addDependent: self].
	
	self initializeUserInterface.! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'cs 5/15/2009 13:22'!
userNameText

	userNameText ifNil: [self userNameText:
		((XpfPluggableTextMorph
			on: self user
			getTextSelector: #userName)
			lock;
			hResizing: #spaceFill)].
	^ userNameText! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:57'!
userNameText: anObject

	userNameText := anObject.! !

PanelMorph subclass: #XpfElementListMorph
	instanceVariableNames: 'model scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:34'!
defaultExtent

	^ self defaultWidth @ self defaultHeight.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	self subclassResponsibility.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:32'!
defaultWidth

	self subclassResponsibility.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:43'!
for: anXpfIteration

	^self new model: anXpfIteration! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:38'!
buildList

	self submorphsDelete! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:32'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		listDirection: #topToBottom;
		fillStyle: Color transparent;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 2.! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'SR 4/11/2009 21:13'!
model

	^ model! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 13:39'!
model: anXpfIteration

	self model ifNotNil: [
		self model removeDependent: self.
		self model userStories ifNotNil: [self model userStories removeDependent: self]].
	
	model := anXpfIteration.
	self buildList.
	
	2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"
	
	self model ifNotNil: [
		self model addDependent: self.
		self model userStories ifNotNil: [self model userStories addDependent: self]].! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 16:20'!
scrollPane

	^ scrollPane ifNil: [scrollPane := GeneralScrollPane new]! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:01'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:38'!
submorphsDelete

	submorphs ifNotNilDo: [:s | s do: [:m | m delete]].! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:36'!
withScrollBars

	self 		
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self scrollPane
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent;
		borderWidth: 0;
		scrollTarget: self.
	^ self scrollPane! !

XpfElementListMorph subclass: #XpfTaskListMorph2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListMorph2 class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	^ 500! !

!XpfTaskListMorph2 class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:31'!
defaultWidth 

	^ 180! !

!XpfTaskListMorph2 methodsFor: 'updating' stamp: 'cs 6/11/2009 14:57'!
buildList

	| filter |
	super buildList.
	self model ifNil: [^self].
	self model userStories
		do: [:us | us tasks isLoaded ifFalse: [us tasks reloadDepth: 3]]
		displayingProgress: 'Loading...'.

	filter := XpfTaskWidgetFilter new name: 'My';
		filterBlock: [:task | task responsibleDeveloper = self model currentUser & task isDone not].
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Related';
		filterBlock: [:task | (task developers includes: self model currentUser) & task isDone not]).
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Open';
		filterBlock: [:task | task isDone not]).
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Finished').
	self model userStories do: [:us |
		us tasks
			do: [:task | filter process: task];			
			addDependent: self].
	
	filter createMorphListIn: self.! !

!XpfTaskListMorph2 methodsFor: 'updating' stamp: 'mt 5/14/2009 13:39'!
update: aSymbol

	aSymbol = #requestSorting | (aSymbol = #tasksLoaded) | (aSymbol = #userStoriesLoaded) ifTrue: [
		self buildList].
	super update: aSymbol.! !

XpfElementListMorph subclass: #XpfUserStoryListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	^ 500! !

!XpfUserStoryListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:31'!
defaultWidth 

	^ 200! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'cs 6/11/2009 14:50'!
buildList
	super buildList.
	self model ifNil: [ ^ self ].
	self model userStories isLoaded ifFalse: [ self model userStories reloadDepth: 4 ].
	self model userStories do: [ :each | self addMorphBack: (XpfUserStoryListEntryMorph for: each) ]! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:39'!
update: aSymbol

	aSymbol = #userStoriesLoaded ifTrue: [
		self buildList].
	super update: aSymbol.! !

PanelMorph subclass: #XpfEntityMorph
	instanceVariableNames: 'model inEditMode inZoomMode zoomContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEntityMorph class methodsFor: 'as yet unclassified' stamp: 'mt 3/13/2009 13:49'!
defaultColor

	^ self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
acceptChanges
	self acceptSubmorphs.
	self switchToViewMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'cs 4/14/2009 18:28'!
acceptSubmorphs

	self model deferCommit: [
		self submorphsDo: [:m | m allMorphsDo: [:contentMorph |
			contentMorph isEntityMorphContent ifTrue: [contentMorph accept]]]].! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 6/29/2009 13:38'!
buildContent
	self createMainContent! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
cancelChanges
	self cancelSubmorphs.
	self switchToViewMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'mt 4/28/2009 10:31'!
cancelSubmorphs

	self submorphsDo: [:m | m allMorphsDo: [:contentMorph |	
		contentMorph isEntityMorphContent ifTrue: [contentMorph cancel]]].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
click: evt

	evt yellowButtonPressed 
		ifTrue: [
			self openContextPopupMenu.
			evt wasHandled: true].
	
	(self inEditMode & evt redButtonPressed)
		ifTrue: [
			self cancelChanges.
			evt wasHandled: true].! !

!XpfEntityMorph methodsFor: 'private' stamp: 'SR 7/22/2009 11:28'!
createEstimateEdit
	| edit |
	edit := XpfCardEdit new
		convertTo: LargePositiveInteger;
		alwaysAccept: true;
		on: self
		text: #timeEstimated
		accept: #timeEstimated:
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: #inEditMode;
		font: self theme textFont;
		cornerStyle: nil;
		hResizing: #rigid;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		hideScrollBarsIndefinitely;
		extent: 24@(self theme textFont height + 4);
		setBalloonText: nil.
	edit textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	edit maxLength: 2;
		  borderWidth: 0;
		  color: Color transparent.
	^edit! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 6/17/2009 10:43'!
createMainContent
	self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/22/2009 22:43'!
detailContentMorphs

	|morphs|
	
	(self hasProperty: #XpfTaskDetails) ifFalse: [
		morphs := self createDetailContentMorphs.
		morphs do: [:morph | self addMorphBack: morph].
		self setProperty: #XpfTaskDetails toValue: morphs ].
	
	^ self valueOfProperty: #XpfTaskDetails
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:08'!
doubleClick: evt

	(evt redButtonPressed and: [self inEditMode not]) 
		ifTrue: [
			self switchToEditMode.
			evt wasHandled: true.
			].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:08'!
handlesMouseDown: evt

	^ true! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 19:58'!
hideDetailContent

	self detailContentMorph hide! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:56'!
inEditMode

	^ inEditMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/16/2009 23:01'!
inEditMode: anObject

	inEditMode := anObject.
	self update: #inEditMode.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:30'!
inZoomMode

	^ inZoomMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:30'!
inZoomMode: anObject

	inZoomMode := anObject.! !

!XpfEntityMorph methodsFor: 'initialization' stamp: 'mt 10/30/2009 13:47'!
initialize
	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		inEditMode: false;
		inZoomMode: false;
		borderWidth: 1;
		fillStyle: Color transparent; " self class defaultColor;"
		enableDragNDrop;
		buildContent
	"layoutInset: 2;"! !

!XpfEntityMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^true! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mt 3/13/2009 13:54'!
model

	^ model! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 10/6/2009 18:46'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model ifNotNil: [self model addDependent: self].
	
	self updateContentModel.
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 6/29/2009 17:48'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 5.
	
	self comeToFront.! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 19:58'!
showDetailContent

	self detailContentMorph show.! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:39'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 7/1/2009 20:56'!
switchToEditMode
	
	self toggleEditMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 7/1/2009 20:56'!
switchToViewMode
	
	self toggleEditMode.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 7/8/2009 19:15'!
timeEstimated
	^ self model timeEstimated ifNil: [0].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:49'!
timeEstimated: aPositiveInteger
	^ self model timeEstimated: aPositiveInteger! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'SR 4/18/2009 11:26'!
toggleEditMode
	
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [m toggleEditMode]].	
	self inEditMode: self inEditMode not.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 6/17/2009 10:03'!
toggleZoomMode
	
	self inEditMode ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	self inZoomMode
		ifTrue: [
			self hideDetailContent.
			self inZoomMode: false.
			self changed: #zoomOut]
		ifFalse: [
			self showDetailContent.
			self inZoomMode: true.
			self changed: #zoomIn].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 6/12/2009 13:25'!
update: aSymbol
	
	aSymbol = #accepted ifTrue: [
		self acceptChanges].
	
	aSymbol = #cancelled ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	aSymbol = #toggleZoom ifTrue: [self toggleZoomMode].
	aSymbol = #enterEditMode ifTrue: [self toggleEditMode].
	super update: aSymbol.

	! !

!XpfEntityMorph methodsFor: 'private' stamp: 'SR 4/18/2009 11:26'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [m model: self model]].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 4/18/2009 11:09'!
zoomContent

	zoomContent ifNil: [
		self zoomContent: (XpfZoomButtonContent forModel: self model).
		self zoomContent addDependent: self.
		self addDependent: self zoomContent].
	^ zoomContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:14'!
zoomContent: anObject

	zoomContent := anObject.! !

XpfEntityMorph subclass: #XpfTaskMorph
	instanceVariableNames: 'actionsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'cs 5/13/2009 15:57'!
defaultColor

	^ Color lightRed alpha: 0.85! !

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'cs 5/13/2009 15:57'!
defaultDoneColor

	^ Color lightGreen alpha: 0.85! !

!XpfTaskMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/20/2009 11:23'!
forTask: anXpfTask

	^ self basicNew
		model: anXpfTask;
		initialize;
		update: anXpfTask! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:10'!
actionsMorph

	actionsMorph ifNil: [
		actionsMorph := (XpfTaskActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'bs 6/17/2009 10:12'!
createDetailContentMorphs

	^ {XpfSimpleTaskWidgetActionsContent forModel: self model.
		XpfTaskDeveloperContent forModel: self model}! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'bs 6/22/2009 22:39'!
createMainContent
	
	self layoutPolicy: TableLayout new.
	self
		addMorph: ((self theme 
				newRowIn: self
				for: { 
						(XpfTaskTitleContent forModel: self model).
						(self actionsMorph)
					 })
				layoutInset: 0;
				cellInset: 2;
				hResizing: #shrinkWrap);
		addMorphBack: ((self theme 
				newRowIn: self
				for: { 
						(self zoomContent).
						(XpfTaskProgressEstimationSliderContent withModel: self model)
					 })
				layoutInset: 0;
				cellInset: 5;
				hResizing: #shrinkWrap)! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 3/13/2009 14:50'!
isTaskMorph

	^ true! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'mfp 3/20/2009 11:21'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Status'.
	menu add: 'Done' target: self model selector: #isDone: argument: true.
	menu addLine.
	menu add: 'Open' target: self model selector: #isDone: argument: false.
	menu popUpInWorld.
! !

!XpfTaskMorph methodsFor: 'event handling' stamp: 'cs 5/13/2009 15:55'!
update: aSymbol

	super update: aSymbol.

	self model isDone
		ifTrue: [self color: self class defaultDoneColor]
		ifFalse: [self color: self class defaultColor]! !

!XpfTaskMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 14:42'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsTasks! !

XpfEntityMorph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'actionsMorph card cancelButton acceptButton deleteButton historyButton actionHalosMorph progressBar showOcclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mfp 3/17/2009 15:34'!
defaultColor
	
	^	Color white.! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mt 9/11/2009 10:35'!
defaultHeight
	
	^ 120! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mt 9/11/2009 10:35'!
defaultWidth
	
	^ 180! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/17/2009 16:04'!
forUserStory: anXpfUserStory

	^ self basicNew
		model: anXpfUserStory;
		initialize! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:22'!
acceptButton

	^ acceptButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:21'!
acceptButton: anObject

	acceptButton := anObject.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:41'!
actionHalosMorph

	^ actionHalosMorph! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:41'!
actionHalosMorph: anObject

	^ actionHalosMorph := anObject! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:10'!
actionsMorph

	actionsMorph ifNil: [
		actionsMorph := (XpfUserStoryActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mt 10/30/2009 15:07'!
buildContent

	self
		borderWidth: 0;
		color: Color transparent;
		createMainContent;
		createActionHalosMorph;
		createZoomContent;
		createDetailContentMorph.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateEstimationSumForAllTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateEstimationSumForCompletedTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateProgressBarValue

	^ self model 
		ifNotNil: [ self calculateEstimationSumForAllTasks = 0.0 
			ifTrue: [ 0.0 ]
			ifFalse: [self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks]]! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:22'!
cancelButton

	^ cancelButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:20'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/30/2009 17:46'!
cardMorph
	^ card! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 20:18'!
color

	^ self cardMorph color! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/8/2009 22:12'!
color: aColor
	super color: aColor.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:25'!
createAcceptButton

	self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes').
	^ self acceptButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'mt 10/30/2009 13:35'!
createActionHalosMorph

	self createDeleteButton.
	self createHistoryButton.
	self createCancelButton.
	self createAcceptButton.
	
	self actionHalosMorph: (self newColumnFor: {}).
	self addMorphBack: self actionHalosMorph.
	self actionHalosMorph 
		extent: 20 @ self height;
		position: self width @ 0;
		hide.
	
	self actionHalosMorph addMorphBack: self deleteButton.
	self actionHalosMorph addMorphBack: self historyButton.
	
	^ self actionHalosMorph! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:23'!
createCancelButton

	self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes').
	^ self cancelButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'mt 12/8/2009 15:35'!
createDeleteButton

	self deleteButton: (IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfDeleteIcon;
		actionSelector: #deleteStory;
		setBalloonText: 'Delete this user story').
	^ self deleteButton! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'topa 10/8/2009 14:55'!
createDetailContentMorph

	| yOffset |
"	self assert: self zoomContent notNil description: 'zoomContent must not be nil. it has to be created before detailContent is built'.
"
	self zoomContent ifNil: [self createZoomContent].
	yOffset := self height + self zoomContent height.
	self detailContentMorph: (XpfTasksContent forModel: self model tasks).
	self addMorphBack: self detailContentMorph.
	^ self detailContentMorph 
		position: 0 @ yOffset;
		hide;
		yourself! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 17:54'!
createEstimationCircleMorph
	|circle segment radius iterationUnits storyCosts gamma vertices deltaY deltaX offset segmentColor |
	
	radius := 30.
	iterationUnits := 60 * 100.
	storyCosts := self timeEstimated * 100.
	
	circle := CircleMorph new.
	circle extent: (2*radius)@(2*radius);
						 borderWidth: 0;
						 color: Color veryVeryLightGray.

	(storyCosts > 0) ifTrue: [
	gamma := 360 / iterationUnits.
	vertices := OrderedCollection new.
	vertices addAll: {0@0. radius@0}.

	1 to: storyCosts do: [:i |
		deltaY := (gamma*i) degreeSin * radius.
		deltaX := ((radius*radius) - (deltaY*deltaY)) sqrt.
		vertices add: (deltaX rounded * (gamma*i+90) degreeSin sign)@(deltaY rounded).
	].
	segmentColor := Color r: 1.0 g: 0.725 b: 0.482.
	segment := (PolygonMorph vertices: vertices color: segmentColor borderWidth: 0 borderColor: nil).
	
	offset := circle extent - segment extent.
	circle addMorph: segment.
	segment position: offset.
	].
	^ circle.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 21:53'!
createHistoryButton

	self historyButton: (IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfHistory;
		actionSelector: #showHistory;
		setBalloonText: 'Show history of this user story').
	^ self historyButton! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'bs 6/17/2009 10:42'!
createLayoutContainer
	| container estimationCircle |
	container := Morph new.
	container
		extent: 170 @ 100;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self addMorph: container.
	estimationCircle := self createEstimationCircleMorph.
	estimationCircle center: 140 @ 70.
	self addMorphBack: estimationCircle.
	^ container! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/21/2009 08:26'!
createMainContent
	| content estimationCircle |
	
	card := Morph new.
	card
		color: Color white;
		borderColor: Color black;
		borderWidth: 1;
		extent: (self width @ self height).
	
	content := Morph new.
	content
		color: Color transparent;
		layoutInset: 1;
		layoutPolicy: TableLayout new;
		vResizing: #spaceFill.
		
	card addMorphBack: content.
	estimationCircle := (XpfEstimationCircleMorph nUnits: 60 segmentUnitsComputing: [self timeEstimated]).
	estimationCircle center: (self width - 30 - 1) @ (self height - 30 - 1).
	card addMorphBack: estimationCircle.
	
	self createProgressBar.
	self progressBar extent: 10@118.
	self progressBar position: 0@0.
	
	content addMorphBack: (self newRowFor: {
		(self progressBar).
		(self newColumnFor: {
			(XpfUserStoryTitleContent forModel: self model).
			(self newRowFor: {
				self createEstimateEdit}) listDirection: #rightToLeft
			}) 
			vResizing: #shrinkWrap.
		}).
	
	self addMorphBack: card.
	^ card.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 22:52'!
createProgressBar
	self progressBar: (XpfProgressBarMorph new
			borderWidth: 0;
			color: Color transparent;
			progressColor: Color lightGreen;
			extent: 10@100).
	self updateProgressBar.
	^ self progressBar! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/11/2009 17:15'!
createTitleViewFor: aUserStory

	^ (XpfPluggableTextMorph
			on: aUserStory
			getTextSelector: #title)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			margins: 3@0;
			extent: 170@100! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mt 10/30/2009 13:38'!
createZoomContent

	self
		zoomContent: (XpfZoomButtonContent forModel: self model);
		addDependent: self zoomContent;
		addMorphBack: self zoomContent.
	
	^ self zoomContent
		addDependent: self;
		position: 0 @ self height;
		hide;
		yourself! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/27/2009 09:22'!
deleteButton
	^ deleteButton ! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 22:15'!
deleteButton: anObject
	deleteButton := anObject! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 22:17'!
deleteStory

	self model delete. self delete! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 13:54'!
detailContentMorph

	^ self valueOfProperty: #XpfTaskDetails
	! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 13:54'!
detailContentMorph: morphs

	^ self setProperty: #XpfTaskDetails toValue: morphs.	! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 16:02'!
detailContentMorphs

	^ {self detailContentMorph}
	! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mt 12/1/2009 19:46'!
detectAndShowOcclusions
	"If one card has the same model position like another, make the border thick."
	
	self showOcclusions ifFalse: [^ self].
	
	self model iteration userStories do: [:story |
		story id ~= self model id ifTrue: [
			story position = self model position
				ifTrue: [self cardMorph borderWidth: 5. ^ self]]].
		
	self cardMorph borderWidth: 1.! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'mt 10/29/2009 17:23'!
handleMouseOver: anEvent
	anEvent hand noticeMouseOver: self event: anEvent! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 6/29/2009 18:09'!
handlesMouseOver: anEvent
	^ true.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'mt 10/7/2009 09:34'!
hasNewUserStory

	self flag: #obsolete.
	^ self model isKindOf: XpfNewUserStory! !

!XpfUserStoryMorph methodsFor: 'layout' stamp: 'bs 7/21/2009 08:00'!
height
	^ 120! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:14'!
hideHalos
	self actionHalosMorph hide.
	! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/27/2009 09:23'!
historyButton

	^ historyButton ! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:53'!
historyButton: anObject

	historyButton := anObject! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 10/8/2009 15:21'!
initialize
	
	super initialize.
	self
		cellInset: 0;
		updateColor.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'mt 10/7/2009 09:34'!
isNew

	^ self model isKindOf: XpfNewUserStory! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 7/21/2009 08:52'!
mouseEnter: anEvent
	super mouseEnter: anEvent.
	self showsHalos
		ifFalse: [self showHalos].
		
	self showsDetails
		ifFalse: [self zoomContent show]! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 7/21/2009 09:01'!
mouseLeave: anEvent
	super mouseLeave: anEvent.
	self showsHalos 
		ifTrue: [self hideHalos].
		
	self showsDetails 
		ifFalse: [self zoomContent hide]! !

!XpfUserStoryMorph methodsFor: 'accessing-model' stamp: 'mt 11/13/2009 20:36'!
moveTo: anXpfIteration

	anXpfIteration addUserStory: self model.! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mt 12/1/2009 18:55'!
openContextPopupMenu

	| menu colorMenu |
	colorMenu := MenuMorph new.
	#(red orange yellow green cyan blue magenta gray white) do: [:currentColor |
		colorMenu
			add: currentColor asString capitalized
			target: self model
			selector: #color:
			argument: currentColor asString].
		
	menu := MenuMorph entitled: 'User Story'.
	menu add: 'Edit color' subMenu: colorMenu.
	menu addLine.
	menu
		add: 'Delete'
		target: self model
		selector: #delete
		enabled: true
		icon: #xpfDeleteIcon.
	
	menu popUpInWorld.
! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/2/2009 11:39'!
progressBar
	^ progressBar! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/2/2009 11:39'!
progressBar: anObject
	^ progressBar := anObject! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:15'!
showHalos
	self actionHalosMorph show.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 21:56'!
showHistory

	self model repository changed: #showHistory with: self model.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:46'!
showOcclusions

	^ showOcclusions ifNil: [false]! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:46'!
showOcclusions: anObject

	showOcclusions := anObject.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 10/8/2009 14:53'!
showsDetails

	self detailContentMorph ifNil: [self createDetailContentMorph].
	
	^ self detailContentMorph visible! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'bs 7/1/2009 20:30'!
showsHalos
	^ self actionHalosMorph visible.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'topa 10/6/2009 18:46'!
switchToEditMode

	super switchToEditMode.
	self actionHalosMorph 
		addMorphBack: self cancelButton; 
		addMorphBack: self acceptButton.
! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'topa 10/6/2009 18:46'!
switchToViewMode

	super switchToViewMode.
	self actionHalosMorph 
		removeMorph: self cancelButton; 
		removeMorph: self acceptButton.
! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:47'!
toggleShowOcclusions

	self showOcclusions: self showOcclusions not.
	self detectAndShowOcclusions. "force update"! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 12/1/2009 16:29'!
update: aSymbol 

	super update: aSymbol.
	
	aSymbol = #color ifTrue: [ self updateColor ].
	aSymbol = #position ifTrue: [self updatePosition.].
	aSymbol = #deleted ifTrue: [self delete].
	aSymbol = #moved ifTrue: [
		self owner ifNil: [self delete].
		self owner ifNotNilDo: [:morph |
			(morph isHandMorph or: [morph includesUserStory: self model])
				ifFalse: [self delete]]].

	self updateProgressBar.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'bs 6/23/2009 20:52'!
updateColor

	card color: (Color colorFrom: self model color asSymbol) muchLighter.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 17:20'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [
			(m isKindOf: XpfTasksContent)	
				ifTrue: [m model: self model tasks]
				ifFalse: [m model: self model]]].! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 18:16'!
updateEstimation
	! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 11/6/2009 20:38'!
updateModelPosition

	self owner ifNotNilDo: [:iterationMorph |
		self updateModelPosition: (iterationMorph gridMorph calculateCell: 
			(self localPointToGlobal: self topLeft))].! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 11/6/2009 20:30'!
updateModelPosition: aPoint

	aPoint = self model position
		ifTrue: [^ self].

	self model
		removeDependent: self;
		position: aPoint;
		addDependent: self.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 11/29/2009 18:25'!
updatePosition
	"Consider the grid of the owner/iteration."

	self comeToFront.

	self owner ifNotNilDo: [:iterationMorph |
		iterationMorph isHandMorph ifTrue: [^ self].
		
		iterationMorph gridMorph fixMorphPosition: self.
		iterationMorph expandToSubmorphs].! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:49'!
updateProgressBar

	self progressBar ifNotNil: [
		self progressBar value contents: self calculateProgressBarValue]! !

!XpfUserStoryMorph methodsFor: 'dropping/grabbing' stamp: 'topa 8/24/2009 13:02'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

!XpfUserStoryMorph methodsFor: 'layout' stamp: 'bs 7/21/2009 08:01'!
width
	^ 180! !

PanelMorph subclass: #XpfEntityMorphContent
	instanceVariableNames: 'model inEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfEntityMorphContent subclass: #XpfActionsContent
	instanceVariableNames: 'editModeButton historyButton acceptButton cancelButton estimationIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
acceptButton

	acceptButton ifNil: [
		self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes')].
	^ acceptButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:22'!
acceptButton: anObject

	acceptButton := anObject.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:22'!
acceptChanges

	self changed: #accepted.! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
cancelButton

	cancelButton ifNil: [
		self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes')].
	^ cancelButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:22'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:22'!
cancelChanges

	self changed: #cancelled.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 4/24/2009 15:23'!
createEditModeLayout

	self addMorphBack: self cancelButton.
	self addMorphBack: self acceptButton.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:42'!
createNormalModeLayout
! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton

	editModeButton ifNil: [
		self editModeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfEdit;
			actionSelector: #switchEditMode;
			setBalloonText: 'Toggle edit mode')].
	^ editModeButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton: anObject

	editModeButton := anObject! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton

	historyButton ifNil: [
		self historyButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfHistory;
			actionSelector: #showHistory;
			setBalloonText: 'Show history of this user story')].
	^ historyButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton: anObject

	historyButton := anObject! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:45'!
initialize

	super initialize.
	self
		createNormalModeLayout;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		changed.! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:09'!
showHistory

	self model repository changed: #showHistory with: self model.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:25'!
switchEditMode

	self changed: #enterEditMode.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:53'!
toggleEditMode

	super toggleEditMode.
	
	self removeAllMorphs.
	self extent: 0@0.
	
	self inEditMode
		ifFalse: [self createNormalModeLayout]
		ifTrue: [self createEditModeLayout].
		
	self changed.
	! !

XpfActionsContent subclass: #XpfTaskActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskActionsContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:44'!
defaultExtent

	^ 0@20! !

XpfActionsContent subclass: #XpfUserStoryActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryActionsContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:43'!
defaultExtent

	^ 0@40! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:48'!
defaultExtent

	self subclassResponsibility.! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 13:50'!
forModel: anXpfEntity

	^ (self basicNew)
	 	model: anXpfEntity;
		initialize! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
accept! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 16:08'!
cancel! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:26'!
inEditMode

	^ inEditMode! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:26'!
inEditMode: anObject

	inEditMode := anObject.! !

!XpfEntityMorphContent methodsFor: 'initialization' stamp: 'mfp 3/18/2009 15:38'!
initialize

	super initialize.
	self 
		inEditMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent.! !

!XpfEntityMorphContent methodsFor: 'testing' stamp: 'mfp 3/19/2009 16:13'!
isEntityMorphContent

	^ true! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 15:09'!
model

	^ model! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mt 4/28/2009 18:33'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model ifNotNil: [self model addDependent: self].
	
	self update.! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:58'!
toggleEditMode

	self
		inEditMode: (self inEditMode not);
		update.
	! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
update! !

XpfEntityMorphContent subclass: #XpfEstimationContent
	instanceVariableNames: 'estimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEstimationContent class methodsFor: 'defaults' stamp: 'cs 4/14/2009 18:31'!
defaultExtent

	^ 40@20! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 13:14'!
estimated

	estimated ifNil: [
		self estimated: (self theme newLabelIn: self label: '').
		self estimated
			hResizing: #shrinkWrap;
			disabledStyle: #plain;
			font: XpfClient sansFont.
		self updateLabel].
	
	^ estimated! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'cs 4/14/2009 18:27'!
estimated: anObject

	estimated := anObject.! !

!XpfEstimationContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 16:56'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #center;
		cellInset: 3;
		layoutInset: 2;
		addMorph: MenuIcons xpfClock asMorph;
		addMorphBack: ((self theme newToolSpacerIn: self) hResizing: #spaceFill; vResizing: #rigid);
		addMorphBack: self estimated;
		update.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'SR 4/18/2009 10:43'!
model: aModel

	super model: aModel.
	self updateLabel! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 4/18/2009 10:57'!
update: aSymbol

	aSymbol = #timeEstimated ifTrue: [self updateLabel].
	super update: aSymbol.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:58'!
updateLabel

	self model ifNil: [^self].
	self model timeEstimated ifNil: [^self].
	self estimated contents: (self model timeEstimated asString)", ' hrs'".! !

XpfEntityMorphContent subclass: #XpfProgressEstimationSliderContent
	instanceVariableNames: 'estimationSlider estimationContent progressBar estimationSliderModel isUserStory proxyModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/23/2009 15:00'!
withModel: aModel

	^ self new
		model: aModel;
		initializeUserInterface
! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:41'!
accept

	self model timeEstimated: self estimationSliderModel timeEstimated.
	super accept! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:21'!
barOrSliderExtent

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'private' stamp: 'topa 4/23/2009 14:25'!
calculateProgressBarValue

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:41'!
cancel

	self estimationSliderModel timeEstimated: (self model timeEstimated ifNil: [0.0]).
	super cancel! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:35'!
currentQuantum

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:31'!
estimationContent

	estimationContent ifNil: [
		"estimationContent := (XpfEstimationContent forModel: self estimationSliderModel)"
		estimationContent := (UITheme current
				newTextEntryIn: self
				for: self estimationSliderModel
				get: #timeEstimated
				set: #timeEstimated:
				class: LargePositiveInteger
				getEnabled: #isEnabled
				help: '') maxLength: 2. ].
	^ estimationContent! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:42'!
estimationContent: anObject

	estimationContent := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/21/2009 16:23'!
estimationSlider

	estimationSlider ifNil: [self estimationSlider:
		((self theme newSliderIn: self
			for: self estimationSliderModel
			getValue: #timeEstimated  
			setValue:  #timeEstimated:
			min: 0.5  
			max: self maxEstimation  
			quantum: self currentQuantum  
			getEnabled: nil  
			help: 'Drag slider to adjust estimated time required')
			height: self barOrSliderExtent y;
			width: self barOrSliderExtent x;
			vResizing: #rigid;
			hResizing: #rigid)].
	^ estimationSlider! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 11:16'!
estimationSlider: anObject
	
	estimationSlider := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 12:26'!
estimationSliderModel

	estimationSliderModel ifNil: [
		self estimationSliderModel: XpfProgressEstimationSliderModel new].
	^ estimationSliderModel! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:37'!
estimationSliderModel: anObject

	estimationSliderModel := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 17:32'!
initializeUserInterface

	self
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		cellInset: 14;
		updateUserInterface;
		update.! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/23/2009 13:39'!
isTask

	^ self isUserStory not! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:25'!
model: anXpfUserStoryOrTaskEntity
	
	super model: anXpfUserStoryOrTaskEntity.
	self model ifNotNilDo: [:m |
		self estimationSliderModel
			timeEstimated: (m timeEstimated ifNil: [0.0])].
	! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 19:25'!
progressBar

	progressBar ifNil: [self progressBar:
		(ProgressBarMorph new
			borderWidth: 1;
			color: (Color r: 0.5 g: 0.5 b: 0.5 alpha: 0.7);
			progressColor: Color lightGreen;
			extent: self barOrSliderExtent).
		self updateProgressBar].
	^ progressBar! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'SR 4/17/2009 11:17'!
progressBar: anObject

	progressBar := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 18:51'!
toggleEditMode

	super toggleEditMode.
	self updateUserInterface.
! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 13:52'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #timeEstimated ifTrue: [self estimationSliderModel timeEstimated: (self model timeEstimated ifNil: [0.0])].
	self updateProgressBar.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 14:44'!
updateProgressBar

	self progressBar value contents: self calculateProgressBarValue.	! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mt 4/24/2009 18:16'!
updateUserInterface

	self
		removeAllMorphs;
		addMorph: (self inEditMode 
			ifTrue: [self estimationSlider]
			ifFalse: [self progressBar]);
		addMorphBack:	self estimationContent.! !

XpfProgressEstimationSliderContent subclass: #XpfTaskProgressEstimationSliderContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTaskProgressEstimationSliderContent subclass: #XpfTaskProgressContentForWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskProgressContentForWidget methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 12:30'!
barOrSliderExtent

	^  95 @ 10! !

!XpfTaskProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2009 16:12'!
defaultExtent

	^ 150@20! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/25/2009 17:30'!
barOrSliderExtent

	^  68 @ 10! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'private' stamp: 'topa 4/23/2009 14:24'!
calculateProgressBarValue

	^ self model 
		ifNil: [0.0]
		ifNotNil: [(self model timeEstimated isNil not and: [self model timeActual isNil not] and: [self model timeEstimated > 0.0])
			ifFalse: [0.0]
			ifTrue: [self model timeActual / self model timeEstimated]]! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:27'!
currentQuantum

	^ 0.5! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	^ 20.0! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 19:19'!
updateProgressBar

	super updateProgressBar.
	self model ifNotNilDo: [:m |
		self progressBar assureExtension
			balloonText: ('Actual time: {1}' format: {((m timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat}).
		(m timeActual notNil & m timeEstimated notNil
		and: [m timeActual > m timeEstimated])
			ifTrue: [self progressBar
				borderWidth: 2;
				borderColor: Color red]
			ifFalse: [self progressBar
				borderWidth: 1;
				borderColor: Color black]].! !

XpfProgressEstimationSliderContent subclass: #XpfUserStoryProgressEstimationSliderContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2009 16:12'!
defaultExtent

	^ 140@20! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/25/2009 17:29'!
barOrSliderExtent

	^ 103 @ 10! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:25'!
calculateEstimationSumForAllTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:26'!
calculateEstimationSumForCompletedTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'private' stamp: 'mfp 4/23/2009 14:57'!
calculateProgressBarValue

	^ self model 
		ifNotNil: [ self calculateEstimationSumForAllTasks = 0.0 
			ifTrue: [ 0.0 ]
			ifFalse: [self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks]]! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:27'!
currentQuantum

	^ 1.0! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	^ 60.0! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/23/2009 14:54'!
model: anXpfUserStory

	super model: anXpfUserStory.
	self model tasks do: [:task | task addDependent: self].
	self model tasks addDependent: self.! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/23/2009 14:50'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #tasksAdded ifTrue: [anObject addDependent: self].
	aSymbol = #tasksRemoved ifTrue: [anObject removeDependent: self]
! !

XpfEntityMorphContent subclass: #XpfTaskDeveloperContent
	instanceVariableNames: 'responsibleDeveloperButton responsibleDeveloperLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:26'!
defaultExtent

	^ 100 @25! !

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'cs 5/7/2009 15:13'!
forModel: anXpfTask

	^ (super forModel: anXpfTask)
		update: #responsibleDeveloper! !

!XpfTaskDeveloperContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:38'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		layoutInset: 0;
		cellInset: 0;
		addMorphBack: self responsibleDeveloperButton;
		addMorphBack: (UITheme current newRowIn: self for: {self responsibleDeveloperLabel}).! !

!XpfTaskDeveloperContent methodsFor: 'model actions' stamp: 'mt 5/14/2009 10:45'!
responsibleDeveloper
	
	^ self model responsibleDeveloper
		ifNil: ['(nobody)']
		ifNotNilDo: [:dev | dev userName]! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:05'!
responsibleDeveloperButton

	responsibleDeveloperButton ifNil: [
		self responsibleDeveloperButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfUser;
			actionSelector: #showDeveloper;
			setBalloonText: 'Show all developers for this task.')].
	^ responsibleDeveloperButton! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'cs 5/13/2009 14:20'!
responsibleDeveloperButton: anObject

	responsibleDeveloperButton := anObject.! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:42'!
responsibleDeveloperLabel

	responsibleDeveloperLabel ifNil: [
		self responsibleDeveloperLabel: '' asMorph].
	^ responsibleDeveloperLabel! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:06'!
responsibleDeveloperLabel: anObject

	responsibleDeveloperLabel := anObject.! !

!XpfTaskDeveloperContent methodsFor: 'model actions' stamp: 'mig 4/15/2009 18:23'!
showDeveloper

	World openModal: (XpfTaskDeveloperDialog new model: self model)! !

!XpfTaskDeveloperContent methodsFor: 'updating' stamp: 'mt 5/14/2009 12:40'!
update: aSymbol
	
	aSymbol = #responsibleDeveloper ifTrue: [
		self responsibleDeveloperLabel
			font: (XpfClient sansFontAt: 9);
			contents: (self responsibleDeveloper truncateWithElipsisTo: 20);
			width: 135].
	super update: aSymbol.! !

XpfEntityMorphContent subclass: #XpfTaskWidgetActionsContent
	instanceVariableNames: 'startStopButton editTimeButton takeResponsibilityButton startTime doneButton reopenButton userStoryArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

XpfTaskWidgetActionsContent subclass: #XpfSimpleTaskWidgetActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfSimpleTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 15:42'!
initialize

	super initialize.

	self
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		layoutInset: 5.! !

!XpfSimpleTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 5/15/2009 15:42'!
initializeUserInterface

	self
		addMorphBack: ('Other Options: ' asMorph
			font: (XpfClient sansFontAt: 9));
		addMorphBack: self takeResponsibilityButton;
		addMorphBack: self startStopButton;
		addMorphBack: self editTimeButton;
		addMorphBack: self doneButton;
		addMorphBack: self reopenButton.! !

!XpfTaskWidgetActionsContent class methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 17:53'!
defaultExtent

	^ 50@27! !

!XpfTaskWidgetActionsContent methodsFor: 'testing' stamp: 'mt 5/14/2009 09:51'!
alreadyResponsible

	^ self model notNil
		and: [self model responsibleDeveloper notNil
		and: [self model responsibleDeveloper = self model currentUser]]! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:21'!
doneButton

	doneButton ifNil: [
		self doneButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfDone;
			actionSelector: #doneWork;
			setBalloonText: 'Finish this task')].
	^ doneButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:06'!
doneButton: aButton

	doneButton := aButton.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'topa 4/23/2009 17:15'!
doneWork

	self model isDone: true.
	self stopWork.
	! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 15:38'!
editTime

	| result |
	self model ifNil: [^ self].
	
	result := UITheme current
		textEntryIn: self
		text: 'Enter a new actual', String cr, ' time for this task:'
		title: 'Set actual time'
		entryText: ((self model timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat.
		
	result ifNil: [^ self].
	
	self model timeActual: result asNumber asFloat.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 15:42'!
editTimeButton

	editTimeButton ifNil: [
		self editTimeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockEdit;
			actionSelector: #editTime;
			setBalloonText: ('Set actual time. This is an alternative way to the start/stop mechanism.' withNoLineLongerThan: 60))].
	^ editTimeButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 15:09'!
editTimeButton: anObject

	editTimeButton := anObject.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 16:04'!
estimateTask

	| result |
	self model ifNil: [^ false].
	
	result := UITheme current
		textEntryIn: self
		text: 'You may only be responsible', String cr, ' if you can estimate this task:'
		title: 'Take responsibility'
		entryText: ((self model timeEstimated ifNil: [0.0]) * 10) truncated / 10 asFloat.
		
	result ifNil: [^ false].
	
	self model timeEstimated: result asNumber asFloat.
	^ true.! !

!XpfTaskWidgetActionsContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 15:33'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		initializeUserInterface.! !

!XpfTaskWidgetActionsContent methodsFor: 'initialization' stamp: 'mt 5/15/2009 15:11'!
initializeUserInterface

	self
		addMorphBack: self userStoryArea;
		addMorphBack: self takeResponsibilityButton;
		addMorphBack: self startStopButton;
		addMorphBack: self editTimeButton;
		addMorphBack: self doneButton;
		addMorphBack: self reopenButton.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:38'!
model: aModel

	super model: aModel.
	self updateAll.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'topa 4/23/2009 16:34'!
reopen

	self model isDone: false.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:22'!
reopenButton

	reopenButton  ifNil: [
		self reopenButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfPencil;
			actionSelector: #reopen;
			setBalloonText: 'Re-open this task')].
	^ reopenButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:17'!
reopenButton: anObject

	reopenButton := anObject.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 15:11'!
startStopButton

	startStopButton ifNil: [
		self startStopButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockPlay;
			actionSelector: #toggleStartStop;
			setBalloonText: 'Start work and choose Co-Developer')].
	^ startStopButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
startStopButton: anObject

	startStopButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/14/2009 11:00'!
startWork

	| secondDeveloper |
	secondDeveloper := (World openModal: (XpfDeveloperChooser for: self model)) result.
	secondDeveloper ifNil: [^self].

	self model
		addDeveloper: self model currentUser;
		addDeveloper: secondDeveloper;
		isStarted: true.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'cs 4/23/2009 14:19'!
stopWork

	self model isStarted: false.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 16:02'!
takeResponsibility

	self estimateTask
		ifTrue: [
			self model responsibleDeveloper: self model currentUser.
			self model developers reload].! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/12/2009 18:46'!
takeResponsibilityButton

	takeResponsibilityButton ifNil: [
		self takeResponsibilityButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfMedal;
			actionSelector: #takeResponsibility;
			setBalloonText: 'Take responsibility')].
	^ takeResponsibilityButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
takeResponsibilityButton: anObject

	takeResponsibilityButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'cs 4/23/2009 14:15'!
toggleStartStop

	self model isStarted
		ifTrue: [self stopWork]
		ifFalse: [self startWork].! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:20'!
update: aSymbol

	aSymbol = #isDone	ifTrue: [
		self
			updateDoneButton;
			updateReopenButton;
			updateStartStopButton;
			updateEditTimeButton].
	aSymbol = #responsibleDeveloper ifTrue: [
		self
			updateTakeResponsibilityButton;
			updateDoneButton;
			updateStartStopButton;
			updateEditTimeButton].
	aSymbol = #isStarted ifTrue: [
		self
			updateStartStopButton;
			updateEditTimeButton].! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:17'!
updateAll

	self
		updateTakeResponsibilityButton;
		updateDoneButton;
		updateReopenButton;
		updateStartStopButton;
		updateEditTimeButton;
		updateUserStoryArea.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:53'!
updateDoneButton

	self doneButton
		visible:
			(self model notNil
				and: [self model isDone not
				and: [self alreadyResponsible]]);
		disableTableLayout:
			self doneButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:15'!
updateEditTimeButton

	self editTimeButton visible:
		(self model notNil
			and: [self model isDone not
			and: [self alreadyResponsible
			and: [self model isStarted not]]]).
	self editTimeButton disableTableLayout: self editTimeButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:54'!
updateReopenButton

	self reopenButton 
		visible:
			(self model notNil
				and: [self model isDone
				and: [self alreadyResponsible]]); 
		disableTableLayout:
			self reopenButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:52'!
updateStartStopButton

	self startStopButton visible:
		(self model notNil
			and: [self model isDone not
			and: [self alreadyResponsible]]).
	self startStopButton visible ifTrue: [
		self startStopButton labelGraphic:
			(self model isStarted
				ifTrue: [MenuIcons xpfClockStop]
				ifFalse: [MenuIcons xpfClockPlay])].
	self startStopButton disableTableLayout: self startStopButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'topa 4/23/2009 16:36'!
updateTakeResponsibilityButton

	self takeResponsibilityButton
		visible: self alreadyResponsible not;
		disableTableLayout: self alreadyResponsible.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 11:51'!
updateUserStoryArea

	self model ifNil: [^ self].
	
	self userStoryArea
		color: (Color colorFrom: self model userStory color asSymbol) muchLighter.
		
	self userStoryArea assureExtension
		balloonText: ('User Story: "{1}"' format: {self model userStory title withNoLineLongerThan: 40}).! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:49'!
userStoryArea

	userStoryArea ifNil: [
		self userStoryArea: (BorderedMorph new
			hResizing: #rigid;
			vResizing: #rigid;
			extent: 21@8;
			borderWidth: 1;
			borderRaised;
			color: Color transparent)].
	^ userStoryArea! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:38'!
userStoryArea: anObject

	userStoryArea := anObject.! !

XpfEntityMorphContent subclass: #XpfTasksContent
	instanceVariableNames: 'taskList addButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTasksContent class methodsFor: 'defaults' stamp: 'bs 6/29/2009 16:14'!
defaultExtent

	^ 180@220! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'mt 4/24/2009 16:09'!
addButton

	addButton ifNil: [
		self addButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAddTask;
			actionSelector: #addTask;
			setBalloonText: 'Click this button to add a new task.')].
	^ addButton! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:13'!
addButton: aPluggableButtonMorph

	addButton := aPluggableButtonMorph.! !

!XpfTasksContent methodsFor: 'actions' stamp: 'mt 5/15/2009 15:57'!
addTask

	(self model addNew: (Dictionary newFrom: {'title' -> 'Please enter description for new task'}))
		responsibleDeveloper: self model repository currentUser.! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'bs 7/1/2009 21:24'!
initialize

	super initialize.
	self
		hResizing: #rigid;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35);
		layoutInset: 2.
		
	self taskList withScrollBars extent: self extent.
	self addMorphBack: self taskList withScrollBars.
	self addMorphBack:
			(self theme newRowIn: self for: {
				self addButton.
				self theme newToolSpacerIn: self}).
! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:23'!
model: anXpfTasksCollection

	super model: anXpfTasksCollection.
	self taskList model: self model.! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mt 4/24/2009 16:12'!
taskList

	taskList ifNil: [
		taskList := XpfTaskListMorph new model: self model].
	^ taskList! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:27'!
taskList: anObject

	taskList := anObject.! !

XpfEntityMorphContent subclass: #XpfTitleContent
	instanceVariableNames: 'titleEdit titleView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTitleContent subclass: #XpfTaskTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskTitleContent class methodsFor: 'defaults' stamp: 'mt 4/24/2009 14:58'!
defaultExtent

	^ 139@70! !

!XpfTaskTitleContent methodsFor: 'testing' stamp: 'topa 4/17/2009 16:03'!
isXpfTaskTitleContent

	^ true! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'cs 4/14/2009 18:44'!
accept

	self titleEdit accept.! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'SR 4/14/2009 21:02'!
cancel

	self titleEdit cancel.! !

!XpfTitleContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 17:32'!
initialize

	super initialize.
	self addMorph: self title.! !

!XpfTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 14:39'!
isXpfTaskTitleContent

	^ false! !

!XpfTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 14:39'!
isXpfUserStoryTitleContent

	^ false! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 5/25/2009 11:53'!
model: anXpfEntity 
	super model: anXpfEntity.

	"preset title."
	(self titleView) 
		model: anXpfEntity;
		extent: self class defaultExtent.
	self isXpfUserStoryTitleContent 
		ifTrue: [self resizeFontSizeForUserStoryIfNecessary: anXpfEntity].
	(self titleEdit)
		setText: self model title;
		extent: self class defaultExtent

	! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/21/2009 17:03'!
modelTitle

	^ self model ifNotNil: [self model title asText]
		! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/21/2009 17:13'!
modelTitle: aText

	self model title: (aText ifNotNil: [aText asString])! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 19:29'!
title

	^ self inEditMode
		ifTrue: [self titleEdit]
		ifFalse: [self titleView]! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mt 4/24/2009 15:16'!
titleEdit

	titleEdit ifNil: [
		titleEdit := (XpfSaveEditingTextMorph
			on: self
			text: #modelTitle
			accept: #modelTitle:) 
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			borderWidth: 0;
			fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35)].
	^ titleEdit! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'bs 6/12/2009 17:54'!
titleView

	titleView ifNil: [
		titleView := (XpfPluggableTextMorph
			on: self model
			getTextSelector: #title)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			margins: 3@0;
			lock].
	^ titleView! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'topa 4/22/2009 15:31'!
toggleEditMode

	super toggleEditMode.
	self
		removeAllMorphs;
		addMorph: (self title font: XpfClient sansFont).! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'mt 4/28/2009 10:40'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #title ifTrue: [
		self titleEdit update: #modelTitle].! !

XpfTitleContent subclass: #XpfUserStoryTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryTitleContent class methodsFor: 'defaults' stamp: 'bs 6/23/2009 13:29'!
defaultExtent

	^ 170@90! !

!XpfUserStoryTitleContent methodsFor: 'testing' stamp: 'topa 4/17/2009 16:03'!
isXpfUserStoryTitleContent

	^ true! !

!XpfUserStoryTitleContent methodsFor: 'accessing' stamp: 'mfp 5/6/2009 12:08'!
resizeFontSizeForUserStoryIfNecessary: anXpfEntity 

	| textLength |
	textLength := anXpfEntity title size.
	
	"In the following line, truncateWithElipsisTo: will be added in the future"
	textLength > 210 ifTrue:  [ self titleView beAllFont: (XpfClient sansFontAt: 8); font: (XpfClient sansFontAt: 8) ].	
	(textLength > 165 and: [ textLength <= 210 ]) ifTrue:  [ self titleView beAllFont: (XpfClient sansFontAt: 8); font: (XpfClient sansFontAt: 8) ].	
	(textLength > 150 and: [ textLength <= 165 ]) ifTrue: [ self titleView beAllFont: (XpfClient sansFontAt: 9); font: (XpfClient sansFontAt: 9)].
	(textLength > 130 and: [ textLength <= 150 ]) ifTrue: [ self titleView beAllFont: (XpfClient sansFontAt: 10); font: (XpfClient sansFontAt: 10) ]! !

!XpfUserStoryTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 15:22'!
titleView

	| tempTitleView |
	tempTitleView := super titleView.
	
"	self resizeFontSizeForUserStoryIfNecessary: self model ofTitleView: tempTitleView. "
	
	^ tempTitleView 
! !

XpfEntityMorphContent subclass: #XpfZoomButtonContent
	instanceVariableNames: 'zoomButton inZoomMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:05'!
defaultExtent
	
	^ 16@16! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:17'!
downArrowFrom

	^ ScrollBar arrowOfDirection: #bottom size: 16 color: Color lightGray
! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:17'!
rightArrowFrom

	^ ScrollBar arrowOfDirection: #right size: 16 color: Color lightGray
! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode

	^ inZoomMode! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode: anObject

	inZoomMode := anObject! !

!XpfZoomButtonContent methodsFor: 'initialization' stamp: 'mt 10/30/2009 13:40'!
initialize

	super initialize.	
	self
		addMorph: self zoomButton;
		listCentering: #center;
		listDirection: #topToBottom;
		vResizing: #shrinkWrap;
		hResizing: #rigid;
		color: Color transparent;
		update.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:31'!
toggleZoom

	self changed: #toggleZoom.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:42'!
update: aSymbol
	
	aSymbol = #zoomOut ifTrue: [self zoomButton labelGraphic: self class rightArrowFrom].
	aSymbol = #zoomIn ifTrue: [self zoomButton labelGraphic: self class downArrowFrom].
	super update: aSymbol.! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 3/23/2009 11:07'!
zoomButton

	zoomButton ifNil: [
		zoomButton :=  IconicButton new
	 		color: Color transparent;
		 	target: self;
		 	borderWidth: 0;
			labelGraphic: self class rightArrowFrom;
			actionSelector: #toggleZoom;
			setBalloonText: 'zoom' translated].
	^ zoomButton! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:03'!
zoomButton: anObject

	zoomButton := anObject.! !

PanelMorph subclass: #XpfHistoryEntryMorph
	instanceVariableNames: 'model entityTypeField timeField entityTitleField actionField detailField userField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryEntryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:22'!
forEntry: anXpfHistoryEntryModel

	^ self basicNew
		model: anXpfHistoryEntryModel;
		initialize! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:30'!
actionField

	actionField ifNil: [
		self actionField:
			(self model entry action asMorph
			font: XpfClient sansFont;
			emphasis: 1;
			hResizing: #rigid;
			width: 65;
			lock)].
	^ actionField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
actionField: anObject

	actionField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:30'!
detailField

	detailField ifNil: [
		self detailField:
			(self detailsText asMorph
			font: XpfClient sansFont;
			hResizing: #spaceFill;
			autoFitOnOff;
			wrapFlag: false;
			lock)].
	^ detailField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
detailField: anObject

	detailField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/17/2009 17:09'!
detailsText

	self model entry action = #added ifTrue: [^ self detailsTextAdded].
	self model entry action = #changed ifTrue: [^ self detailsTextChanged].
	^ '' asText! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/28/2009 16:58'!
detailsTextAdded

	^ self model new asText
		"addAttribute: TextEmphasis underlined;"
		append: ' to ';
		append: self model entry property capitalized asText allBold;
		yourself! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/28/2009 16:56'!
detailsTextChanged

	| text oldValue newValue  |
	oldValue := '''{1}''' format: {self model old}.
	newValue := '''{1}''' format: {self model new}.
	
	text := (self model entry property) asText allBold.
	
	oldValue ifNotNil: [text
		append: ' from ';
		append: (oldValue asText addAttribute: TextEmphasis italic; yourself)].
	
	text
		append: ' to ';
		append: (newValue asText addAttribute: TextEmphasis italic; yourself);
		yourself.
	^ text! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/29/2009 11:37'!
entityTitleField

	entityTitleField ifNil: [self entityTitleField: 
		((XpfPluggableTextMorph
			on: self model entity
			getTextSelector: #title)
			"emphasis: 4(self model entity isDeleted ifTrue: [20] ifFalse: [4]);"
			hResizing: #rigid;
			isTruncatedWithEllipsis: true;
			width: 120;
			lock)].
	^ entityTitleField ! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTitleField: anObject

	entityTitleField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:43'!
entityTypeField

	entityTypeField ifNil: [
		self entityTypeField:
			(self model entityType asString capitalized asMorph
			font: XpfClient sansFont;
			color: Color darkGray;
			hResizing: #rigid;
			width: 70;
			lock)].
	^ entityTypeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTypeField: anObject

	entityTypeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/8/2009 11:54'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color white;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		initializeFields.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/17/2009 16:41'!
initializeFields

	self addMorphBack: self timeField.
	self model entityType = #individual ifFalse: [
	self addMorphBack: self entityTypeField;
		  addMorphBack: self entityTitleField].
	self addMorphBack: self actionField;
		  addMorphBack: self detailField.
	self model entry user ifNotNil: [
	self addMorphBack: self userField].! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model

	^ model! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model: anObject

	model := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 11:46'!
timeField

	timeField ifNil: [
		self timeField:
			(self model entry timestamp printRelativeTimeStamp asMorph
			font: XpfClient sansFont;
			emphasis: 2;
			hResizing: #rigid;
			width: 180;
			lock)].
	^ timeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
timeField: anObject

	timeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:40'!
userField

	userField ifNil: [
		self userField:
			(self userText asMorph
				font: XpfClient sansFont;
				color: Color darkGray;
				hResizing: #rigid;
				width: 120;
				lock)].
	^ userField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:48'!
userField: anObject

	userField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/22/2009 16:06'!
userText

	^ ('by {1} --' format: {self model entry user asString}) asText
		addAttribute: TextEmphasis underlined;
		yourself! !

PanelMorph subclass: #XpfHistoryMorph
	instanceVariableNames: 'model table checkboxBar projectCheckbox userStoriesCheckbox tasksCheckbox individualCheckbox individualLabel client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 11:03'!
forProject: anXpfProject

	^ self basicNew
		model: (XpfHistoryModel new project: anXpfProject);
		initialize! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:26'!
checkboxBar

	checkboxBar ifNil: [self checkboxBar:
		(UITheme current newRowIn: self for: {
			'Show history for: ' asMorph font: XpfClient sansFont.
			self projectCheckbox.
			self userStoriesCheckbox.
			self tasksCheckbox.
			self individualCheckbox.
			self individualLabel})].
	
	^ checkboxBar! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:36'!
checkboxBar: anObject

	checkboxBar := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:19'!
client

	^ client! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:19'!
client: anObject

	client := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:29'!
individualCheckbox

	individualCheckbox ifNil: [self individualCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showIndividual
		setSelected: #showIndividual:
		getEnabled: #enableIndividual
		label: ''
		help: 'Check this box to see history details of a specific entity')].
	^ individualCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:06'!
individualCheckbox: anIndividualCheckbox

	individualCheckbox := anIndividualCheckbox.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:06'!
individualLabel

	individualLabel ifNil: [self individualLabel:
		((XpfPluggableTextMorph
			on: self model
			getTextSelector: #individualTitle)
			hResizing: #spaceFill;
			isTruncatedWithEllipsis: true;
			lock)].
	^ individualLabel! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:16'!
individualLabel: anObject

	individualLabel := anObject.! !

!XpfHistoryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 11:39'!
initialize

	super initialize.
	self
		visible: false;
		disableTableLayout: true;
		height: 100;
		vResizing: #rigid;
		hResizing: #spaceFill;
		changeTableLayout;
		addMorph: self table;
		addMorph: self checkboxBar.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:11'!
model

	^ model! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:14'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:27'!
projectCheckbox

	projectCheckbox ifNil: [self projectCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showProject
		setSelected: #showProject:
		getEnabled: #enableGlobal
		label: 'Project'  
		help: 'Check this box to see history details on project level')].
	projectCheckbox labelMorph font: XpfClient sansFont.
	^ projectCheckbox
	  ! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
projectCheckbox: anObject

	projectCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:51'!
table

	table ifNil: [self table:
		((UITheme current 
			newMorphListIn: self
			for: self model
			list: #entriesAsMorphs
			getSelected: nil
			setSelected: nil
			getEnabled: nil
			help: 'Shows the project history')
			height: 80;
			vResizing: #rigid;
			hResizing: #spaceFill)].
	^ table! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
table: anObject

	table := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:28'!
tasksCheckbox

	tasksCheckbox ifNil: [self tasksCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showTasks
		setSelected: #showTasks:
		getEnabled: #enableGlobal
		label: 'Tasks'
		help: 'Check this box to see history details on task level')].
	tasksCheckbox labelMorph font: XpfClient sansFont.
	^ tasksCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
tasksCheckbox: anObject

	tasksCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:22'!
update: aSymbol

	super update: aSymbol.
	(aSymbol = #showIndividual
		and: [self client notNil]
		and: [self visible not])
		ifTrue: [self client toggleHistory].! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:28'!
userStoriesCheckbox

	userStoriesCheckbox ifNil: [self userStoriesCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showUserStories
		setSelected: #showUserStories:
		getEnabled: #enableGlobal
		label: 'User Stories'  
		help: 'Check this box to see history details on User Story level')].
	userStoriesCheckbox labelMorph font: XpfClient sansFont.
	^ userStoriesCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
userStoriesCheckbox: anObject

	userStoriesCheckbox := anObject.! !

PanelMorph subclass: #XpfIterationSidebarMorph
	instanceVariableNames: 'model selectedTitles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:44'!
click: anXpfIteration with: anEvent from: anExpanderTitleMorph

	anEvent redButtonChanged ifTrue: [
		self selectIteration: anXpfIteration with: anEvent from: anExpanderTitleMorph.
		anEvent wasHandled: true].
	anEvent yellowButtonChanged ifTrue: [
		self openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph..
		anEvent wasHandled: true].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/12/2009 21:27'!
editIdealTime: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter ideal time:' title: 'XPF-Client' entryText: anXpfIteration timeIdeal).
	answer ifNotNil: [anXpfIteration timeIdeal: answer].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:43'!
editName: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter iteration name:' title: 'XPF-Client' entryText: anXpfIteration title).
	answer ifNotNil: [
		anXpfIteration title: answer.
		anExpanderTitleMorph titleText: anXpfIteration title].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 5/6/2009 16:10'!
fill

	self model iterations do: [:iteration | |expander|
			expander := (UITheme current
				newExpanderIn: self
				label: (iteration title ifNil: [''])
				forAll: {XpfIterationTreeMorph for: iteration}).
			expander titleMorph on: #mouseUp send: #click:with:from: to: self withValue: iteration.
			self addMorph: expander.
			expander titleMorph addDependent: self.
			expander titleMorph labelMorph beAllFont: XpfClient sansFont.
			iteration isXpfFutureIteration ifTrue: [expander titleMorph labelMorph: MenuIcons xpfOpenStories asMorph].

			iteration isXpfFutureIteration
				ifTrue: [self selectIteration: iteration with: nil from: expander titleMorph]].
	
	self submorphs size > 1 ifTrue: [ | expander tree |
		expander := self submorphs second expanded: true.
		tree := expander submorphs detect: [:m | m ~= expander titleMorph].
		self selectIteration: tree model iteration with: nil from: expander titleMorph].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:19'!
initialize

	super initialize.
	
	self
		selectedTitles: Set new;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 200@700.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 3/26/2009 12:47'!
model

	^ model! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 11:30'!
model: anXpfProject

	self model ifNotNil: [
		self model removeDependent: self.
		self model iterations removeDependent: self].
	model := anXpfProject.
	self model ifNotNil: [
		self model addDependent: self.
		self model iterations addDependent: self.
		self fill.].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/20/2009 10:35'!
openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph
	
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Iteration'.
	menu add: 'Edit name' target: self selector: #editName:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Edit ideal time' target: self selector: #editIdealTime:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Remove' target: self selector: #removeIteration:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu popUpInWorld.! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 11:52'!
removeAllIterations

	self
		changed: #iterationDeselectAll;
		removeAllMorphs;
		selectedTitles: Set new.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'mt 4/25/2009 14:59'!
removeIteration: anXpfIteration

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you sure?' title: 'Proceed') ifTrue: [
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'mt 4/25/2009 15:01'!
removeIteration: anXpfIteration with: anExpanderTitleMorph

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you sure?' title: 'Proceed') ifTrue: [
			(self selectedTitles includes: anExpanderTitleMorph) ifTrue: [
					self selectedTitles remove: anExpanderTitleMorph.
					self changed: #iterationDeselected with: anXpfIteration].
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 20:32'!
selectIteration: anXpfIteration with: evt from: anExpanderTitleMorph 

	(self selectedTitles includes: anExpanderTitleMorph)
		ifTrue: [
			self selectedTitles remove: anExpanderTitleMorph.
			self changed: #iterationDeselected with: anXpfIteration]
		ifFalse: [
			self selectedTitles add: anExpanderTitleMorph.
			self changed: #iterationSelected with: anXpfIteration].
	self updateHighlight.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:18'!
selectedTitles

	^ selectedTitles! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:17'!
selectedTitles: anObject

	selectedTitles := anObject! !

!XpfIterationSidebarMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 11:47'!
update: aSymbol

	super update: aSymbol.
	self updateHighlight.

	aSymbol = #iterations | aSymbol = #iterationsLoaded ifTrue: [
		self model iterations reloadDepth: 2.
		self			
			removeAllIterations;
			fill].! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 19:24'!
updateHighlight
	
	self submorphsDo: [:morph | 
		(morph isKindOf: ExpanderMorph) ifTrue: [
			morph titleMorph fillStyle:
				(UITheme current expanderTitleNormalFillStyleFor: morph titleMorph)]].

	self selectedTitles do: [:morph | morph fillStyle: (morph fillStyle mixed: 3/4 with: Color green)].! !

PanelMorph subclass: #XpfTaskbarExtension
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Taskbar'!

XpfTaskbarExtension class
	instanceVariableNames: 'instance'!

XpfTaskbarExtension class
	instanceVariableNames: 'instance'!

!XpfTaskbarExtension class methodsFor: 'setup' stamp: 'mt 11/23/2009 14:27'!
install
	"XpfTaskbarExtension install"
	self uninstall.
	instance := self new install.! !

!XpfTaskbarExtension class methodsFor: 'accessing' stamp: 'cs 5/26/2009 15:38'!
instance

	^ instance! !

!XpfTaskbarExtension class methodsFor: 'accessing' stamp: 'cs 5/26/2009 15:38'!
instance: anObject

	instance := anObject.! !

!XpfTaskbarExtension class methodsFor: 'setup' stamp: 'mt 12/30/2009 15:39'!
uninstall

	instance ifNotNil: [instance uninstall].
	instance := nil.
	
	World hands do: [:h | h resetLoginAndPassword; resetProject]! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForChangePassword

	^ self
		newButtonLabel: 'Change Password'
		icon: MenuIcons xpfPassword asMorph
		action: #openChangePassword:! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForClient

	^ self
		newButtonLabel: 'Client'
		icon: MenuIcons flagBlueIcon asMorph
		action: #openClient:! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForDeveloperListWidget

	^ self
		newButtonLabel: 'Developer List'
		icon: MenuIcons xpfScreenIndicatedShared asMorph
		action: #openDeveloperListWidget:! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForLogout

	^ self
		newButtonLabel: 'Logout'
		icon: MenuIcons xpfLogout asMorph
		action: #logout:! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForOptions

	^ self
		newButtonLabel: 'Options'
		icon: MenuIcons xpfHammerScrewdriverIcon asMorph
		action: #showOptionsMenu:! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForTaskWidget

	^ self
		newButtonLabel: 'Task Widget'
		icon: MenuIcons noteIcon asMorph
		action: #openTaskWidget:! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:13'!
buttonForUserStoryWidget

	^ self
		newButtonLabel: 'US Widget'
		icon: MenuIcons pageWhiteTextIcon asMorph
		action: #openUserStoryWidget:! !

!XpfTaskbarExtension methodsFor: 'accessing' stamp: 'cs 5/26/2009 15:37'!
buttonState

	^ true! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 15:09'!
chooseProject: aHand

	self connection repository useLoginDataFromHand: aHand.
	aHand project: self connection project.! !

!XpfTaskbarExtension methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:11'!
connection

	^ connection! !

!XpfTaskbarExtension methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:11'!
connection: anObject

	connection := anObject.! !

!XpfTaskbarExtension methodsFor: 'initialization' stamp: 'mt 12/8/2009 15:35'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		connection: XpfLoginProcessor new;
		initializeReloadIndicator;
		initializeButtons.! !

!XpfTaskbarExtension methodsFor: 'initialization' stamp: 'mt 12/30/2009 11:42'!
initializeButtons

	self
		addMorphBack: self buttonForClient;
		addMorphBack: self buttonForTaskWidget;
		addMorphBack: self buttonForUserStoryWidget;
		addMorphBack: self buttonForDeveloperListWidget;
		addMorphBack: self separator;
"		addMorphBack: self buttonForChangePassword;
		addMorphBack: self buttonForLogout;
"		addMorphBack: self buttonForOptions;
		addMorphBack: self spacer.! !

!XpfTaskbarExtension methodsFor: 'initialization' stamp: 'mt 12/8/2009 15:42'!
initializeReloadIndicator

	| indicator |
	indicator := XpfReloadIndicator new.
	self connection repository addDependent: indicator.
	self addMorphBack: indicator.! !

!XpfTaskbarExtension methodsFor: 'taskbar' stamp: 'mt 12/31/2009 11:36'!
install

	self taskbar
		ifNotNilDo: [:t | t addMorphFront: self]
		ifNil: [
			"Fallback for non-polymorph images."
			self
				color: (Color black alpha: 0.5);
				layoutInset: 5;
				removeMorph: (self submorphs last); "remove trailing spacer item"
				openInWorld;
				setToAdhereToEdge: #bottomLeft].
	self changed: #buttonState.! !

!XpfTaskbarExtension methodsFor: 'connection' stamp: 'mt 12/30/2009 16:30'!
login: aHand

	aHand retrieveLoginAndPassword.
	self chooseProject: aHand.! !

!XpfTaskbarExtension methodsFor: 'connection' stamp: 'mt 12/30/2009 14:52'!
logout: aHand

	aHand
		resetLoginAndPassword;
		resetProject.! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/30/2009 12:11'!
newButtonLabel: aString icon: aMorph action: aSymbol

	| button |
	button := (XpfMultiPointButton
			on: self getState: #buttonState action: aSymbol)
		label: aMorph;
		setBalloonText: aString;
		useRoundedCorners;
		onColor: Color gray
		offColor: Color gray;
		hResizing: #spaceFill.
	^ button! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 16:22'!
openAdminTool: aHand

	aHand providesLoginAndPassword
		ifFalse: [	aHand retrieveLoginAndPassword].

	self connection repository useLoginDataFromHand: aHand.
	XpfAdminTool open.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 15:48'!
openChangePassword: aHand

	| dialog |
	dialog := XpfChangePasswordDialog new.
	dialog model user: self connection user.
	dialog title: dialog title, ' (', aHand login, ')'.
	World openModal: dialog.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 15:33'!
openClient: aHand

	aHand providesLoginAndPassword
		ifFalse: [	aHand retrieveLoginAndPassword].
	aHand providesProject
		ifFalse: [self chooseProject: aHand].

	self connection repository useLoginDataFromHand: aHand.
	XpfProjectTalk openForHand: aHand.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 15:38'!
openDeveloperListWidget: aHand

	aHand providesLoginAndPassword
		ifFalse: [	aHand retrieveLoginAndPassword].
	aHand providesProject
		ifFalse: [self chooseProject: aHand].
		
	self connection repository useLoginDataFromHand: aHand.
	XpfDeveloperListWidget openProject: aHand project.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 15:38'!
openTaskWidget: aHand

	aHand providesLoginAndPassword
		ifFalse: [	aHand retrieveLoginAndPassword].
	aHand providesProject
		ifFalse: [self chooseProject: aHand].
		
	self connection repository useLoginDataFromHand: aHand.
	XpfTaskListWidget openProject: aHand project.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 15:38'!
openUserStoryWidget: aHand

	aHand providesLoginAndPassword
		ifFalse: [	aHand retrieveLoginAndPassword].
	aHand providesProject
		ifFalse: [self chooseProject: aHand].
		
	self connection repository useLoginDataFromHand: aHand.
	XpfUserStoryListWidget openProject: aHand project.! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'mt 12/2/2009 11:04'!
separator

	^ (Morph new)
		color: self palette mid;
		width: 2;
		height: 2;
		yourself! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'mt 12/30/2009 16:30'!
showOptionsMenu: aHand

	| menu |
	menu := XpfMultiPointMenuMorph entitled: 'Hand-Options' forHand: aHand.
	menu addLine.
	aHand providesLoginAndPassword
		ifTrue: [
			(aHand login asLowercase includesSubString: 'admin')
				ifTrue: [menu add: 'Admin Tool' target: XpfAdminTool selector: #open; addLine].
			menu add: 'Choose Project' target: self selector: #chooseProject: argument: aHand.
			menu add: 'Change Password' target: self selector: #openChangePassword: argument: aHand.
			menu addLine.
			menu add: 'Logout' target: self selector: #logout: argument: aHand]
		ifFalse: [menu add: 'Login' target: self selector: #login: argument: aHand].
	menu popUpInWorld.! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 15:28'!
spacer

	^ (UITheme current newToolSpacerIn: self)
		hResizing: #rigid;
		width: 10;
		yourself! !

!XpfTaskbarExtension methodsFor: 'taskbar' stamp: 'mt 12/31/2009 11:33'!
taskbar
	"Return the taskbar if polymorph is installed."
	
	(Smalltalk includesKey: #TaskbarMorph)
		ifFalse: [^ nil].

	^ World
		submorphThat: [:m | m isTaskbar]
		ifNone: []! !

!XpfTaskbarExtension methodsFor: 'taskbar' stamp: 'cs 5/26/2009 15:47'!
uninstall

	self delete.! !

Slider subclass: #XpfScrollBar
	instanceVariableNames: 'menuButton upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay'
	classVariableNames: 'UpArrow8Bit BoxesImagesCache ArrowImagesCache UpArrow'
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfScrollBar commentStamp: 'mt 8/6/2009 09:12' prior: 0!
This is the original version of ScrollBar without Polymorph extensions.

Inspired by an oiginal design of Hans-Martin Mosner, this XpfScrollBar is intended to exercise the handling of input events in Morphic.  With sufficient flexibility in this area, all particular behavior can be concentrated in this single class with no need to specialize any other morphs to achieve button, slider and menu-button behavior.

Once we have this working, put in logic for horizontal operation as well.

CachedImages was added to reduce the number of forms created and thrown away. This will be helpful for Nebraska and others as well.!

XpfScrollBar subclass: #XpfNavigationBar
	instanceVariableNames: 'anchors pagingAreaTransformMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfNavigationBar commentStamp: 'mt 9/11/2009 10:32' prior: 0!
I am a special scroll bar with a cool paging area and anchor handling.!

!XpfNavigationBar methodsFor: 'anchor handling' stamp: 'mt 9/2/2009 13:09'!
addPositionAsAnchor

	self anchors add: self value.! !

!XpfNavigationBar methodsFor: 'accessing' stamp: 'mt 9/2/2009 13:07'!
anchors
	
	anchors ifNil: [anchors := OrderedCollection new].
	^ anchors! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:32'!
doScrollByPage

	super doScrollByPage.
	self shift.! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:32'!
doScrollDown

	super doScrollDown.
	self shift.! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:33'!
doScrollUp

	super doScrollUp.
	self shift.! !

!XpfNavigationBar methodsFor: 'drawing' stamp: 'mt 9/6/2009 18:47'!
drawAnchorsOn: aCanvas
	"Display a small flag so indicate marked positions in the scrolling area."

	| r |
	r := self roomToMove.

	self anchors do: [:anchor | | pos |
		pos := ((((anchor * r width) + r left + (self slider width / 2)) - (MenuIcons flagBlueIcon width / 2))
				min: self pagingArea right - MenuIcons flagBlueIcon width
				max: self pagingArea left)
			@
			((self top) + ((self height / 2) - (MenuIcons flagBlueIcon height / 2))).
		aCanvas
			translucentImage: MenuIcons flagBlueIcon
			at: pos].! !

!XpfNavigationBar methodsFor: 'drawing' stamp: 'mt 12/1/2009 16:33'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawAnchorsOn: aCanvas.
! !

!XpfNavigationBar methodsFor: 'geometry' stamp: 'mt 8/28/2009 11:31'!
expandSlider
	"OVERRIDE: Use another minimum."
	
	| r |
	r := self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: 10) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: 10)])! !

!XpfNavigationBar methodsFor: 'event handling' stamp: 'mt 9/14/2009 14:36'!
handlesMouseWheel: evt

	^ true! !

!XpfNavigationBar methodsFor: 'initialize' stamp: 'mt 9/14/2009 14:32'!
initializeDownButton
	"Not needed."
	
	super initializeDownButton.
	downButton hide.! !

!XpfNavigationBar methodsFor: 'initialize' stamp: 'mt 8/6/2009 09:05'!
initializeMenuButton
	"Ignore menu button."
	
	menuButton := nil.! !

!XpfNavigationBar methodsFor: 'initialize' stamp: 'mt 9/14/2009 16:01'!
initializePagingArea

	pagingArea := XpfPagingAreaMorph new
		model: self;
		extent: self totalSliderArea extent;
		topLeft: 0@0;
		borderWidth: 0.
	self pagingAreaTransformMorph: (TransformMorph new
		bounds: self totalSliderArea;
		on: #mouseDown send: #scrollToMousePosition: to: self;
		addMorph: pagingArea;
		offset: 0@0).

	self addMorph: self pagingAreaTransformMorph.! !

!XpfNavigationBar methodsFor: 'initialize' stamp: 'mt 8/28/2009 11:02'!
initializeSlider

	super initializeSlider.
	
	"Setup slider. Can't use #sliderColor, because slider buttons are using them."
	slider setColor: (Color white alpha: 0.1) borderWidth: 2 borderColor: Color black.
	sliderShadow
		setColor: Color transparent
		borderWidth: 2 borderColor: Color gray.! !

!XpfNavigationBar methodsFor: 'initialize' stamp: 'mt 9/14/2009 14:32'!
initializeUpButton
	"Not needed."
	
	super initializeUpButton.
	upButton hide.! !

!XpfNavigationBar methodsFor: 'as yet unclassified' stamp: 'topa 9/9/2009 15:38'!
model: anObject

	super model: anObject.
	self model addDependent: self.! !

!XpfNavigationBar methodsFor: 'event handling' stamp: 'mt 9/15/2009 09:41'!
mouseWheel: evt

	evt direction = #up ifTrue: [self model zoomIn].
	evt direction = #down ifTrue: [self model zoomOut].! !

!XpfNavigationBar methodsFor: 'accessing' stamp: 'mt 9/14/2009 14:11'!
pagingAreaTransformMorph

	^ pagingAreaTransformMorph! !

!XpfNavigationBar methodsFor: 'accessing' stamp: 'mt 9/14/2009 14:11'!
pagingAreaTransformMorph: anObject

	pagingAreaTransformMorph := anObject.! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:36'!
scrollAbsolute: event

	super scrollAbsolute: event.
	self shift.! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:33'!
scrollDown: count

	super scrollDown: count.
	self shift.! !

!XpfNavigationBar methodsFor: 'initialize' stamp: 'mt 9/2/2009 12:54'!
scrollToMousePosition: event

	| r |
	r := self roomToMove.
	self setValue: ((event cursorPoint x - r left - (self slider width / 2)) asFloat / r width).! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:33'!
scrollUp: count

	super scrollUp: count.
	self shift.! !

!XpfNavigationBar methodsFor: 'accessing' stamp: 'mt 8/6/2009 09:13'!
setValueSelector: aSymbol
	"Directly set the selector to make more flexible."
	
	setValueSelector := aSymbol! !

!XpfNavigationBar methodsFor: 'scrolling' stamp: 'mt 9/15/2009 11:32'!
shift
	"Shift the tape if needed."
	
	self value > 0.999 ifTrue: [
		self model shiftToLeft].
	self value < 0.001 ifTrue: [
		self model shiftToRight].! !

!XpfNavigationBar methodsFor: 'accessing' stamp: 'topa 8/24/2009 15:55'!
slider
	"Answer the slider."

	^ slider! !

!XpfNavigationBar methodsFor: 'access' stamp: 'topa 8/24/2009 16:51'!
sliderShadowColor

	^ Color white alpha: 0.5! !

!XpfNavigationBar methodsFor: 'geometry' stamp: 'mt 8/5/2009 17:12'!
sliderThickness

	^ 32! !

!XpfNavigationBar methodsFor: 'geometry' stamp: 'mt 9/15/2009 10:07'!
totalSliderArea
	"Ignore up, down and menu buttons."
	
	| p1 p2 |
	p1 := upButton visible
		ifTrue: [upButton bounds topRight]	
		ifFalse: [self bounds topLeft].

	p2 := downButton visible
		ifTrue: [downButton bounds bottomLeft]	
		ifFalse: [self bounds bottomRight].

	^ p1 corner: p2! !

!XpfNavigationBar methodsFor: 'as yet unclassified' stamp: 'topa 10/6/2009 18:46'!
update

	self pagingArea
		width: (self height / self model scrollTarget height) * self model scrollTarget width;
		height: self height.! !

!XpfNavigationBar methodsFor: 'updating' stamp: 'mt 9/15/2009 09:39'!
updatePagingArea
	"Update the content of the paging area according to the current zoom-level-conditions."

	| tape factor factor2 |
	
	tape := self model scrollTarget.
		
	factor := tape fullBounds width asFloat / tape width.
	self pagingArea width: self totalSliderArea width * factor.
	
	factor2 := self totalSliderArea width asFloat / tape width.
	self pagingAreaTransformMorph offset: (tape left * factor2) negated @ 0.! !

!XpfNavigationBar methodsFor: 'updating' stamp: 'mt 9/15/2009 10:55'!
updateScrollButtons
	"Show or hide the scroll buttons according to the full size of the paging area."

	self pagingAreaTransformMorph offset x > 0
		ifTrue: [upButton show]
		ifFalse: [upButton hide].
	
	self pagingArea right > (self pagingAreaTransformMorph width + self pagingAreaTransformMorph offset x)
		ifTrue: [downButton show]
		ifFalse: [downButton hide].
		
	self pagingAreaTransformMorph bounds: self totalSliderArea.! !

!XpfScrollBar class methodsFor: 'as yet unclassified' stamp: 'dew 3/23/2002 01:30'!
alwaysShowFlatScrollbarForAlternativeLook
	"Set this value to true, if you want to see the flat scrollbar look in flop-out mode as well as inboard.  Otherwise the flop-out scrollbar will be rounded and inboard will be flat."
	^ false! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:22'!
arrowOfDirection: aSymbol size: finalSizeInteger color: aColor 
	"answer a form with an arrow based on the parameters"
	^ ArrowImagesCache at: {aSymbol. finalSizeInteger. aColor}! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'sd 11/8/2003 16:02'!
arrowSamples
	"create a set of arrow with different sizes, colors and directions"
	" 
	XpfScrollBar arrowSamples.  
	"
	| column |
	column := AlignmentMorph newColumn vResizing: #shrinkWrap;
				 hResizing: #shrinkWrap;
				 layoutInset: 1;
				 borderColor: Color black;
				 borderWidth: 0;
				 wrapCentering: #center;
				 cellPositioning: #center;
				 color: Color white;
				 yourself.
	
	self sampleSizes
		do: [:size | 
			| row | 
			row := AlignmentMorph newRow color: Color transparent;
						 vResizing: #shrinkWrap;
						 cellInset: 2 @ 0 yourself.
			
			self sampleColors
				do: [:color | 
					#(#top #right #bottom #left )
						do: [:direction | 
							row addMorphBack: (XpfScrollBar
									arrowOfDirection: direction
									size: size
									color: color) asMorph]].
			
			column addMorphBack: row].
	
	column openInHand! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:22'!
boxOfSize: finalSizeInteger color: aColor 
	"answer a form with an box based on the parameters"
	^ BoxesImagesCache at: {finalSizeInteger. aColor}! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'dgd 3/28/2003 10:18'!
boxSamples
	"create a set of box with different sizes and colors"
	" 
	XpfScrollBar boxSamples.  
	"
	| column |
	column := AlignmentMorph newColumn vResizing: #shrinkWrap;
				 hResizing: #shrinkWrap;
				 layoutInset: 1;
				 borderColor: Color black;
				 borderWidth: 0;
				 wrapCentering: #center;
				 cellPositioning: #center;
				 color: Color white;
				 yourself.
	""
	self sampleSizes
		do: [:size | 
			| row | 
			row := AlignmentMorph newRow color: Color transparent;
						 vResizing: #shrinkWrap;
						 cellInset: 2 @ 0 yourself.
			""
			self sampleColors
				do: [:color | 
					row addMorphBack: (XpfScrollBar boxOfSize: size color: color) asMorph].
			""
			column addMorphBack: row].
	""
	""
	column openInHand! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 20:54'!
changesInPreferences
	"the related preferences changed"
	self initializeImagesCache
	" XpfScrollBar allInstances do: [:each | each removeAllMorphs; initializeSlider] "! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'dgd 3/28/2003 10:13'!
createArrowImagesCache
	"creates the cache to store the arrow forms"
	^ LRUCache
		size: 40
		factory: [:key | ""
			self
				createArrowOfDirection: key first
				size: key second
				color: key third]! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 20:43'!
createArrowOfDirection: aSymbol in: aRectangle 
	"PRIVATE - create an arrow bounded in aRectangle"

	| arrow vertices |
	vertices := Preferences alternativeButtonsInScrollBars 
				ifTrue: [self verticesForComplexArrow: aRectangle]
				ifFalse: [self verticesForSimpleArrow: aRectangle].
	""
	arrow := PolygonMorph 
				vertices: vertices
				color: Color transparent
				borderWidth: 0
				borderColor: Color black.
	""
	arrow bounds: (arrow bounds insetBy: (aRectangle width / 6) rounded).
	""
	Preferences alternativeButtonsInScrollBars 
		ifTrue: [arrow rotationDegrees: 45].
	""
	aSymbol == #right 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 90].
	aSymbol == #bottom 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 180].
	aSymbol == #left 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 270].
	""
	^arrow! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 19:32'!
createArrowOfDirection: aSymbolDirection size: finalSizeInteger color: aColor 
	"PRIVATE - create an arrow with aSymbolDirectionDirection,  
	finalSizeInteger and aColor  
	 
	aSymbolDirectionDirection = #top, #bottom. #left or #right  
	 
	Try with:  
	(XpfScrollBar createArrowOfDirection: #top size: 32 color: Color  
	lightGreen) asMorph openInHand.  
	"
	| resizeFactor outerBox arrow resizedForm |
	resizeFactor := 4.
	outerBox := RectangleMorph new.
	outerBox extent: finalSizeInteger asPoint * resizeFactor;
		 borderWidth: 0;
		 color: aColor.
	""
	arrow := self createArrowOfDirection: aSymbolDirection in: outerBox bounds.
	self updateScrollBarButtonAspect: arrow color: aColor muchDarker.
	outerBox addMorphCentered: arrow.
	""
	resizedForm := outerBox imageForm
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.
	""
	^ (resizedForm replaceColor: aColor withColor: Color transparent)
		trimBordersOfColor: Color transparent! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'dgd 3/28/2003 10:13'!
createBoxImagesCache
	"creates the cache to store the arrow forms"
	^ LRUCache
		size: 20
		factory: [:key | self createBoxOfSize: key first color: key second]! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:29'!
createBoxIn: aRectangle 
	"PRIVATE - create an box bounded in aRectangle"
	| box |
	box := RectangleMorph new.
	box extent: (aRectangle scaleBy: 1 / 2) extent rounded;
		 borderWidth: 0.
	""
	^ box! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 19:32'!
createBoxOfSize: finalSizeInteger color: aColor 
	"PRIVATE - create a box with finalSizeInteger and aColor  
	 
	Try with:  
	(XpfScrollBar createBoxOfSize: 32 color: Color lightGreen) asMorph  
	openInHand.  
	"
	| resizeFactor outerBox innerBox resizedForm |
	resizeFactor := 4.
	outerBox := RectangleMorph new.
	outerBox extent: finalSizeInteger asPoint * resizeFactor;
		 borderWidth: 0;
		 color: aColor.
	""
	innerBox := self createBoxIn: outerBox bounds.
	self updateScrollBarButtonAspect: innerBox color: aColor muchDarker.
	outerBox addMorphCentered: innerBox.
	""
	resizedForm := outerBox imageForm
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.
	""
	^ (resizedForm replaceColor: aColor withColor: Color transparent)
		trimBordersOfColor: Color transparent! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'dgd 3/27/2003 10:05'!
initialize
	"XpfScrollBar initialize"
	UpArrow := Form
				extent: 6 @ 3
				fromArray: #(805306368 2013265920 4227858432 )
				offset: 0 @ 0.
	""
	self initializeImagesCache! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'md 3/23/2006 15:55'!
initializeImagesCache
	"initialize the receiver's ImagesCache. 
	 
	normally this method is not evaluated more than in the class 
	initializazion. "

	" 
	XpfScrollBar initializeImagesCache.
	"

	ArrowImagesCache := self createArrowImagesCache.
	BoxesImagesCache := self createBoxImagesCache! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'dgd 3/28/2003 10:18'!
sampleColors
	"private"
	^ (Color lightCyan wheel: 5)! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'dgd 3/28/2003 10:17'!
sampleSizes
	
"private"
	^ #(10 12 14 16 18 32 64 )! !

!XpfScrollBar class methodsFor: 'coloring morphs' stamp: 'dgd 3/28/2003 20:29'!
updateScrollBarButtonAspect: aMorph color: aColor 
	"update aMorph with aColor"
	| fill direction |
	aMorph isNil
		ifTrue: [^ self].
	""
aMorph color: aColor.
	Preferences gradientScrollBars
		ifFalse: [^ self].
	""
	fill := GradientFillStyle ramp: {0.0 -> aColor twiceLighter twiceLighter. 1.0 -> aColor twiceDarker}.
	""
	direction := ((aMorph width min: aMorph height)
				+ ((aMorph width - aMorph height) abs * 0.3)) rounded.
	""
	fill origin: aMorph topLeft + (direction // 8).
	fill direction: direction @ direction.
	fill radial: true.
	""
	aMorph fillStyle: fill! !

!XpfScrollBar class methodsFor: 'coloring morphs' stamp: 'dgd 3/28/2003 20:29'!
updateScrollBarButtonsAspect: aCollection color: aColor 
	"update aCollection of morphs with aColor"
	
	
	aCollection
		do: [:each | self updateScrollBarButtonAspect: each color: aColor]! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:21'!
verticesForComplexArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a complex arrow"
	| vertices aux |
	vertices := OrderedCollection new.
	""
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle topLeft.
	vertices add: aRectangle topRight.
	""
	aux := (aRectangle width / 3) rounded.
	vertices add: aRectangle topRight + (0 @ aux).
	vertices add: aRectangle topLeft + aux.
	vertices add: aRectangle bottomLeft + (aux @ 0).
	""
	^ vertices! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:21'!
verticesForSimpleArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a simple arrow"
	| vertices |
	vertices := OrderedCollection new.
	""
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle center x @ (aRectangle top + (aRectangle width / 8)).
	vertices add: aRectangle bottomRight.
	""
	^ vertices! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 16:27'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 7/16/2004 19:33'!
buttonExtent
	| size |
	size := Preferences scrollBarsNarrow
				ifTrue: [11]
				ifFalse: [15].
	^ bounds isWide
		ifTrue: [size @ self innerBounds height]
		ifFalse: [self innerBounds width @ size]! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:13'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'di 4/22/2001 18:28'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'di 4/22/2001 18:28'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
downImage
	"answer a form to be used in the down button"
	^ self class
		arrowOfDirection: (bounds isWide
				ifTrue: [#right]
				ifFalse: [#bottom])
		size: (self buttonExtent x min: self buttonExtent y)
		color: self thumbColor! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 2/27/1999 18:22'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r _ self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: self sliderThickness) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: self sliderThickness)])! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dgd 3/26/2003 09:13'!
extent: p 
	p x > p y
		ifTrue: [super
				extent: (p max: 42 @ 8)]
		ifFalse: [super
				extent: (p max: 8 @ 42)].
	! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'jrp 8/3/2005 10:20'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook ifTrue:[
		upButton borderStyle: (BorderStyle complexRaised width: upButton borderWidth).
		downButton borderStyle: (BorderStyle complexRaised width: downButton borderWidth).
	] ifFalse:[
		downButton borderStyle: BorderStyle thinGray.
		upButton borderStyle: BorderStyle thinGray.
	].

! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dew 3/4/2002 01:11'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self roundedScrollbarLook ifTrue:[
		self borderStyle: ((BorderStyle complexFramed width: 2) "baseColor: Color gray")].! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'jrp 8/3/2005 09:55'!
initializeDownButton
	"initialize the receiver's downButton"

	downButton _ RectangleMorph 
				newBounds: (self innerBounds bottomRight - self buttonExtent 
						extent: self buttonExtent)
				color: self thumbColor.
	downButton 
		on: #mouseDown
		send: #scrollDownInit
		to: self.
	downButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateDownButtonImage.
	self roundedScrollbarLook 
		ifTrue: 
			[downButton color: Color veryLightGray.
			downButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [downButton setBorderWidth: 1 borderColor: Color lightGray].
	self addMorph: downButton! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dew 3/4/2002 01:13'!
initializeEmbedded: aBool
	"aBool == true => inboard scrollbar
	aBool == false => flop-out scrollbar"
	self roundedScrollbarLook ifFalse:[^self].
	aBool ifTrue:[
		self borderStyle: (BorderStyle inset width: 2).
		self cornerStyle: #square.
	] ifFalse:[
		self borderStyle: (BorderStyle width: 1 color: Color black).
		self cornerStyle: #rounded.
	].
	self removeAllMorphs.
	self initializeSlider.! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'wiz 12/22/2007 23:01'!
initializeMenuButton
"initialize the receiver's menuButton"
	"Preferences disable: #scrollBarsWithoutMenuButton"
	"Preferences enable: #scrollBarsWithoutMenuButton"
	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton)
		ifTrue: [menuButton := nil .^ self].
	menuButton _ self roundedScrollbarLook
		ifTrue: [RectangleMorph
					newBounds: ((bounds isWide
							ifTrue: [upButton bounds topRight]
							ifFalse: [upButton bounds bottomLeft])
							extent: self buttonExtent)]
		ifFalse: [RectangleMorph
					newBounds: (self innerBounds topLeft extent: self buttonExtent)
					color: self thumbColor].
	menuButton
		on: #mouseEnter
		send: #menuButtonMouseEnter:
		to: self.
	menuButton
		on: #mouseDown
		send: #menuButtonMouseDown:
		to: self.
	menuButton
		on: #mouseLeave
		send: #menuButtonMouseLeave:
		to: self.
	"menuButton 
	addMorphCentered: (RectangleMorph 
	newBounds: (0 @ 0 extent: 4 @ 2) 
	color: Color black)."
	self updateMenuButtonImage.
	self roundedScrollbarLook
		ifTrue: [menuButton color: Color veryLightGray.
			menuButton
				borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [menuButton setBorderWidth: 1 borderColor: Color lightGray].
	self addMorph: menuButton! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:44'!
initializePagingArea
"initialize the receiver's pagingArea"
	pagingArea := RectangleMorph
				newBounds: self totalSliderArea
				color: (Color
						r: 0.6
						g: 0.6
						b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea
		on: #mouseDown
		send: #scrollPageInit:
		to: self.
	pagingArea
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook
		ifTrue: [pagingArea
				color: (Color gray: 0.9)]! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:44'!
initializeSlider
"initialize the receiver's slider"
	self roundedScrollbarLook
		ifTrue: [self initializeUpButton; initializeMenuButton; initializeDownButton; initializePagingArea]
		ifFalse: [self initializeMenuButton; initializeUpButton; initializeDownButton; initializePagingArea].
	super initializeSlider.
	self roundedScrollbarLook
		ifTrue: [slider cornerStyle: #rounded.
			slider
				borderStyle: (BorderStyle complexRaised width: 3).
			sliderShadow cornerStyle: #rounded].
	self sliderColor: self sliderColor! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'jrp 8/3/2005 09:57'!
initializeUpButton
"initialize the receiver's upButton"
	upButton _ self roundedScrollbarLook
		ifTrue: [RectangleMorph
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
		ifFalse: [RectangleMorph
						newBounds: ((menuButton
								ifNil: [self innerBounds topLeft]
								ifNotNil: [bounds isWide
										ifTrue: [menuButton bounds topRight]
										ifFalse: [menuButton bounds bottomLeft]])
								extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateUpButtonImage.
	self roundedScrollbarLook
		ifTrue: [upButton color: Color veryLightGray.
			upButton
				borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton setBorderWidth: 1 borderColor: Color lightGray].
	self addMorph: upButton! !

!XpfScrollBar methodsFor: 'access' stamp: 'dew 2/21/1999 03:08'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval _ d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!XpfScrollBar methodsFor: 'other events' stamp: ''!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event]! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
menuImage
	"answer a form to be used in the menu button"
	^ self class
		boxOfSize: (self buttonExtent x min: self buttonExtent y)
		color: self thumbColor! !

!XpfScrollBar methodsFor: 'other events' stamp: 'sps 3/10/2004 10:14'!
mouseDownInSlider: event
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBars.].
	super mouseDownInSlider: event
! !

!XpfScrollBar methodsFor: 'access' stamp: 'dew 2/15/1999 18:25'!
pagingArea
	^pagingArea! !

!XpfScrollBar methodsFor: 'scroll timing' stamp: 'di 8/17/1998 09:22'!
resetTimer
	timeOfMouseDown _ Time millisecondClockValue.
	timeOfLastScroll _ timeOfMouseDown - 1000 max: 0.
	nextPageDirection _ nil.
	currentScrollDelay _ nil! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 21:26'!
roundedScrollbarLook
	"Rounded look currently only shows up in flop-out mode"
	^false and: [
		self class alwaysShowFlatScrollbarForAlternativeLook not]
! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 14:56'!
scrollBarAction
	^self valueOfProperty: #scrollBarAction! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 14:56'!
scrollBarAction: aSymbol
	self setProperty: #scrollBarAction toValue: aSymbol! !

!XpfScrollBar methodsFor: 'access' stamp: ''!
scrollDelta
	^ scrollDelta! !

!XpfScrollBar methodsFor: 'access' stamp: ''!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta _ d1.
	pageDelta _ d2.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:12'!
scrollDown
	self flag: #obsolete.
	downButton eventHandler: nil.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollDownInit! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'bf 4/14/1999 12:03'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:05'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'RAA 12/29/2000 11:56'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:11'!
scrollUp
	self flag: #obsolete.
	upButton eventHandler: nil.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollUpInit! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'bf 4/14/1999 12:03'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:05'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'RAA 12/29/2000 11:56'!
setNextDirectionFromEvent: event

	nextPageDirection _ bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 16:25'!
sliderColor: aColor 
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor := self thumbColor.
	menuButton
		ifNotNil: [menuButton color: buttonColor].
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor slightlyLighter.
	
	self class updateScrollBarButtonsAspect: {menuButton. upButton. downButton} color: buttonColor.
	
	self updateMenuButtonImage.
	self updateUpButtonImage.
	self updateDownButtonImage.
	
	self roundedScrollbarLook
				ifTrue: [
					self color: Color transparent.
					pagingArea color: aColor muchLighter.
					self borderStyle style == #simple
						ifTrue: [self borderColor: aColor darker darker]
						ifFalse: [self borderStyle baseColor: aColor]]
				ifFalse: [
					pagingArea
						color: (aColor alphaMixed: 0.3 with: Color white).
					self borderWidth: 0]! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 2/21/1999 03:08'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!XpfScrollBar methodsFor: 'access' stamp: 'dew 3/4/2002 01:17'!
sliderShadowColor
	^ self roundedScrollbarLook
		ifTrue: [self sliderColor darker]
		ifFalse: [super sliderShadowColor]
! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 3/4/2002 01:18'!
sliderThickness
	^ self roundedScrollbarLook ifTrue:[15] ifFalse:[super sliderThickness]! !

!XpfScrollBar methodsFor: 'stepping and presenter' stamp: 'ar 10/7/2000 15:02'!
step
	| action |
	action _ self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!XpfScrollBar methodsFor: 'testing' stamp: 'di 4/22/2001 18:30'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 16:26'!
thumbColor
	"Problem: Part of the XpfScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self sliderColor alphaMixed: 0.5 with: (Color gray: 0.95)
! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'hpt 4/3/2003 19:18'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton _ menuButton ifNil: [upButton].
	bounds isWide
		ifTrue: [
			upButton right > upperBoundsButton right
				ifTrue: [upperBoundsButton _ upButton].
			^upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse:[
			upButton bottom > upperBoundsButton bottom
				ifTrue: [upperBoundsButton _ upButton].
			^upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'RAA 7/28/2000 10:12'!
upArrow8Bit

	"convert to 8-bit and convert white to transparent to avoid gratuitous conversion every time we put one in an ImageMorph"

	^UpArrow8Bit ifNil: [
		UpArrow8Bit _ (ColorForm mappingWhiteToTransparentFrom: UpArrow) asFormOfDepth: 8
	]! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
upImage
	"answer a form to be used in the up button"
	^ self class
		arrowOfDirection: (bounds isWide
				ifTrue: [#left]
				ifFalse: [#top])
		size: (self buttonExtent x min: self buttonExtent y)
		color: self thumbColor! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 10:24'!
updateDownButtonImage
	"update the receiver's downButton.  put a new image inside"
	downButton removeAllMorphs.
	downButton
		addMorphCentered: (ImageMorph new image: self downImage)! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'sd 11/8/2003 16:01'!
updateMenuButtonImage
	"update the receiver's menuButton. put a new image inside"
menuButton isNil ifTrue:[^ self].

	menuButton removeAllMorphs.
	menuButton
		addMorphCentered: (ImageMorph new image: self menuImage)! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
updateUpButtonImage
"update the receiver's upButton. put a new image inside"
	upButton removeAllMorphs.
	upButton
		addMorphCentered: (ImageMorph new image: self upImage)! !

!XpfScrollBar methodsFor: 'scroll timing' stamp: 'dgd 2/21/2003 23:05'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!XpfScrollBar methodsFor: 'testing' stamp: 'ar 10/7/2000 15:02'!
wantsSteps
	^self scrollBarAction notNil! !

!ListItemWrapper methodsFor: '*Xpf-Client' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ false! !

ListItemWrapper subclass: #XpfEntityItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfEntityItemWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 13:14'!
with: anObject model: aModel

	| result |
	result := super with: anObject model: aModel.
	aModel addDependent: result.
	^ result! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mig 4/19/2009 22:30'!
asString

	^ (model title ifNil: ['(no title)']) asString truncateWithElipsisTo: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mig 4/19/2009 22:29'!
balloonText

	^ (model title ifNil: ['(no title)']) asString withNoLineLongerThan: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:50'!
contents

	^ {self createTimeEstimatedItem.
		self createTimeActualItem}! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 15:17'!
createTimeActualItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeActual;
		preferredColor: ((self model timeEstimated isNil | self model timeActual isNil)
			ifTrue: [Color black]
			ifFalse: [ | diff |
				((diff := self model timeEstimated - self model timeActual) abs < 2)
				ifTrue: [Color green muchDarker]
				ifFalse: [	diff > 0
					ifTrue: [Color orange]
					ifFalse: [Color red]]]);
		prefix: 'Actual Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:09'!
createTimeEstimatedItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeEstimated;
		preferredColor: (self model timeEstimated isNil
			ifNil: [Color black]
			ifNotNil: [Color blue]);
		prefix: 'Estimated Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:33'!
hasXpfModel

	^ true! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:29'!
update: aSymbol

	super update: aSymbol.
	self changed: #rootItems.! !

XpfEntityItemWrapper subclass: #XpfUserStoryItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:53'!
contents

	^ super contents asOrderedCollection
		add: self createTasksItem;
		yourself! !

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
createTasksItem

	^ XpfTaskListItemWrapper with: nil model: self model tasks! !

ListItemWrapper subclass: #XpfTaskListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:02'!
asString

	^ 'Tasks'! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
contents

	^ self model collect: [:task |
		XpfEntityItemWrapper with: nil model: task]! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ true! !

ListItemWrapper subclass: #XpfValueBarWrapper
	instanceVariableNames: 'getValueSelector preferredColor prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfValueBarWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:05'!
max

	^ 25! !

!XpfValueBarWrapper methodsFor: 'converting' stamp: 'mt 3/25/2009 17:11'!
asString

	| value |
	
	value := self model perform: self getValueSelector.
	
	value ifNil: [^ '(not set)'].
	^ (String new: ((10 * value) / self class max) ceiling) collect: [:e | $+]! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:33'!
balloonText

	^ '{1} {2}' format: {self prefix. self model perform: self getValueSelector}! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
getValueSelector

	^ getValueSelector! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
getValueSelector: anObject

	getValueSelector := anObject.! !

!XpfValueBarWrapper methodsFor: 'testing' stamp: 'topa 4/20/2009 17:18'!
isValueBarWrapper

	^ true! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:21'!
preferredColor

	^ preferredColor! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:22'!
preferredColor: anObject

	preferredColor := anObject.! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
prefix

	^ prefix! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
prefix: anObject

	prefix := anObject.! !

!Number class methodsFor: '*xpf-client-override' stamp: 'mig 4/21/2009 11:30'!
readExponent: baseValue base: base from: aStream
	"Complete creation of a number, reading exponent from aStream. Answer the
	number, or nil if parsing fails.
	<number>(e|d|q)<exponent>>"

	| sign exp value |
	('edqEDQ' includes: aStream next) ifFalse: [^ nil].
	sign := ((aStream peek) == $-)
		ifTrue: [aStream next. -1]
		ifFalse: [1].
	(aStream peek) == $+ ifTrue: [aStream next].
	(aStream atEnd or: [(aStream peek digitValue between: 0 and: 9) not])
		ifTrue: [^ nil]. "Avoid throwing an error"
	exp := (Integer readFrom: aStream base: 10) * sign.
	value := baseValue * (base raisedTo: exp).
	^ value
! !

IndentingListItemMorph subclass: #XpfIndentingListItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIndentingListItemMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:25'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	| fontToUse |
	"We use our own font. Else, do the super doings, thus copied"
	fontToUse := anObject isValueBarWrapper
		ifTrue: [XpfClient monoFont]
		ifFalse: [XpfClient sansFontAt: 10].
	container := hostList.
	complexContents := anObject.
	self initWithContents: anObject asString font: fontToUse emphasis: nil.
	indentLevel := 0.
	isExpanded := false.
 	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [
		priorMorph nextSibling: self.
	].
	indentLevel := newLevel.
	icon := anObject icon.
	self extent: self minWidth @ self minHeight! !

!XpfIndentingListItemMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/18/2009 16:15'!
isFirstItem

	^ owner notNil and: [owner submorphs first == self]! !

XpfSystemWindow subclass: #XpfProjectTalk
	instanceVariableNames: 'tape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfProjectTalk commentStamp: 'mt 10/4/2009 14:54' prior: 0!
ProjectTalk - Agile software planning with ease
-----------------------------------------------

- new UI with scrollable tapes

Start with: "XpfProjectTalk open."

If you want to access the project model, use "self tape model" and not "self model".!

!XpfProjectTalk class methodsFor: 'support' stamp: 'mt 9/2/2009 14:41'!
createContainerFor: tape1 and: tape2
	"Layout two tapes horizontally in a splitter."

	^ PanelMorph new
		color: Color transparent;
		listDirection: #leftToRight;
		changeProportionalLayout;
		addMorph: (tape1 withScrollBar withToolbar hResizing: #spaceFill; vResizing: #spaceFill)
			fullFrame: (LayoutFrame fractions: (0@0 corner: 0.66@1));
		addMorph: (tape2 withScrollBar withToolbar hResizing: #spaceFill; vResizing: #spaceFill)
			fullFrame: (LayoutFrame fractions: (0.66@0 corner: 1@1));
		addPaneSplitters.! !

!XpfProjectTalk class methodsFor: 'constants' stamp: 'mt 10/6/2009 09:58'!
defaultHeight

	^ XpfTapeMorph tapeHeight! !

!XpfProjectTalk class methodsFor: 'constants' stamp: 'mt 8/28/2009 10:25'!
defaultWidth

	^ 800! !

!XpfProjectTalk class methodsFor: 'instance creation' stamp: 'mt 12/7/2009 13:05'!
open

	| authority |
	authority := XpfLoginProcessor serverString asUrl authority.
	((authority beginsWith: 'xpforums.hpi') or: [authority endsWith: 'xpforums'])
		ifTrue: [self inform: 'You must not start the new client with the old server. See preferences.'. ^ self].

	[
	XpfSplashScreen
		show: 'Project Talk'
		with: {'Checking connection...'. 'Loading model data & GUI...'. 'Opening GUI...'} asOrderedCollection
		for: [:step | | instance project |
			step = 1 ifTrue: [project := XpfTaskbarExtension instance connection project].
			step = 2 ifTrue: [instance := self new initializeProject: project].
			step = 3 ifTrue: [instance openInWorld; top: 0; fullScreen]]
	] on: XpfClientOpenError do: [:nothing | ].

	XpfSplashScreen delete. "In case of an error."! !

!XpfProjectTalk class methodsFor: 'instance creation' stamp: 'mt 10/4/2009 15:17'!
openExample

	^ self new
		addMainPanel: (self
			createContainerFor: XpfProjectTapeMorph exampleTape
			and: XpfProjectTapeMorph exampleTape);
		openInWorld;
		top: 0;
		fullScreen.! !

!XpfProjectTalk class methodsFor: 'instance creation' stamp: 'mt 12/30/2009 15:28'!
openForHand: aHand

	| authority |
	authority := XpfLoginProcessor serverString asUrl authority.
	((authority beginsWith: 'xpforums.hpi') or: [authority endsWith: 'xpforums'])
		ifTrue: [self inform: 'You must not start the new client with the old server. See preferences.'. ^ self].

	[
	XpfSplashScreen
		show: 'Project Talk'
		with: {'Checking connection...'. 'Loading model data & GUI...'. 'Opening GUI...'} asOrderedCollection
		for: [:step | | instance project |
			step = 1 ifTrue: [project := aHand project].
			step = 2 ifTrue: [instance := self new initializeProject: project].
			step = 3 ifTrue: [instance openInWorld; top: 0; fullScreen]]
	] on: XpfClientOpenError do: [:nothing | ].

	XpfSplashScreen delete. "In case of an error."! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 8/28/2009 09:46'!
addGrips
	"OVERRIDE: Only provide grips to resize to left or right."

	|l r lh|
	lh := self labelHeight.
	l  := WindowEdgeGripMorph new target: self; position: self position; edgeName: #left.
	l layoutFrame topOffset: lh negated + 22.
	r  := WindowEdgeGripMorph new target: self; position: self position; edgeName: #right.
	r layoutFrame topOffset: lh negated + 22.
	self
		addMorph: l;
		addMorph: r.! !

!XpfProjectTalk methodsFor: 'close & delete' stamp: 'mt 12/2/2009 15:29'!
delete

	self tape project repository stopUpdating.
	super delete.
! !

!XpfProjectTalk methodsFor: 'geometry' stamp: 'mt 8/29/2009 10:07'!
fullScreen
	"OVERRIDE: Just expand horizontally."
	
	self
		width: World width;
		left: 0.! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 10/4/2009 14:51'!
initialize

	super initialize.		
	self
		removeMenuBox;
		setLabel: 'XPForums ProjectTalk - No project loaded.'.! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 12/2/2009 11:00'!
initializeProject: anXpfProject
	"Setup this client instance for a project."

	self
		setLabel: anXpfProject title;
		initializeProjectTape: anXpfProject.
		
	"Start automatic updating."
	XpfSplashScreen appendMessage: 'Auto-update...'.
	anXpfProject isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 12/2/2009 11:01'!
initializeProjectTape: anXpfProject

	XpfSplashScreen appendMessage: 'Project...'.

	tape := XpfProjectTapeMorph new name: 'primary'.
	self tape model: anXpfProject.
	
	self addMainPanel:
		(self class
			createContainerFor: self tape
			and: (XpfProjectTapeMorph new model: anXpfProject; name: 'secondary')).! !

!XpfProjectTalk methodsFor: 'accessing' stamp: 'mt 10/4/2009 14:48'!
tape

	^ tape! !

Error subclass: #XpfClientOpenError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

ProgressBarMorph subclass: #XpfProgressBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:49'!
drawOn: aCanvas
	| width height inner origin progressRectangle |
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	inner := self innerBounds.
	(inner height > inner width) 
		ifTrue: [
			height := (inner height * lastValue) truncated min: inner height.
			origin := inner origin x @ (inner bottom - height).
			progressRectangle := origin extent: (inner width @ height)]
		ifFalse: [
			width := (inner width * lastValue) truncated min: inner width.
			progressRectangle := inner origin extent: width @ inner height].
	
	aCanvas fillRectangle: progressRectangle color: progressColor.! !

!Collection methodsFor: '*xpf-client-projecttalk' stamp: 'mt 4/22/2009 13:47'!
inject: thisValue into: binaryBlock displayingProgress: aString
	"Like inject:into: but displaying the progress of the operation."
	
	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each] displayingProgress: aString.
	^nextValue! !

GeneralScrollPane subclass: #XpfTapeScroller
	instanceVariableNames: 'showHScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfTapeScroller commentStamp: 'mt 9/6/2009 18:55' prior: 0!
I modify the GeneralScrollPane in the following:

  - hide vertical scrollbar
  - use a special horizontal scrollbar (-> XpfNavigationBar)
  - react to changes of my scroll target
  - use mouse wheel to scroll horizontally!

!XpfTapeScroller methodsFor: 'commands' stamp: 'mt 12/1/2009 19:50'!
availableCommands

	^ {
		XpfCommand new
			name: 'Add anchor to scrollbar';
			icon: MenuIcons flagBlueIcon;
			target: self hScrollbar;
			selector: #addPositionAsAnchor.
		XpfCommand new
			name: 'Toggle grid visibility';
			icon: MenuIcons xpfGridIcon;
			target: self scrollTarget;
			selector: #toggleShowGrid.
		XpfCommand new
			name: 'Toggle smooth card movement';
			icon: MenuIcons xpfMoveCardIcon;
			target: self scrollTarget;
			selector: #toggleSmoothMoving.
		XpfCommand new
			name: 'Toggle hover effect in grid';
			icon: MenuIcons xpfGridHoverIcon;
			target: self scrollTarget;
			selector: #toggleShowHoverEffect.
		XpfCommand new
			name: 'Toggle visualization of occluded cards';
			icon: MenuIcons xpfCardOcclusionIcon;
			target: self scrollTarget;
			selector: #toggleShowOcclusions
		}! !

!XpfTapeScroller methodsFor: 'testing' stamp: 'mt 8/5/2009 16:41'!
hScrollbarNeeded

	^ self showHScrollbar! !

!XpfTapeScroller methodsFor: 'event handling' stamp: 'mt 8/5/2009 16:42'!
handleMouseLeave: evt

	self showHScrollbar: false.! !

!XpfTapeScroller methodsFor: 'event handling' stamp: 'mt 8/20/2009 13:24'!
handleMouseMove: evt

	evt translateBy: self position negated.
	self showHScrollbar
		ifFalse: [	self showHScrollbar: (evt position y > (self height - (self scrollBarThickness / 2)))]
		ifTrue: [self showHScrollbar: (evt position y > (self height - self scrollBarThickness))].! !

!XpfTapeScroller methodsFor: 'actions' stamp: 'mt 8/6/2009 10:34'!
hideOrShowScrollBars
	"Requested by slider. See ScrollBar>>#mouseDownInSlider:"! !

!XpfTapeScroller methodsFor: 'initialization' stamp: 'mt 10/4/2009 15:29'!
initialize

	super initialize.
	self extent: 1 @ XpfTapeMorph tapeHeight.! !

!XpfTapeScroller methodsFor: 'event handling' stamp: 'mt 8/28/2009 10:47'!
mouseWheel: event 
	"OVERRIDE: Only scroll horizontally."

	(self scrollTarget handlesMouseWheel: event)
		ifTrue: [^self scrollTarget mouseWheel: event]. "pass on"
	
	self showHScrollbar: true. "Should disappear after a mouse move."
	
	event direction = #up ifTrue: [
		hScrollbar scrollUp: 3].
	event direction = #down ifTrue: [
		hScrollbar scrollDown: 3]! !

!XpfTapeScroller methodsFor: 'initialization' stamp: 'mt 8/5/2009 16:53'!
newHScrollbar
	"Answer a new horizontal scrollbar."

	^XpfNavigationBar new
		model: self;
		setValueSelector: #hScrollbarValue:! !

!XpfTapeScroller methodsFor: 'accessing' stamp: 'mt 8/5/2009 17:18'!
scrollBarThickness

	^ self hScrollbar sliderThickness! !

!XpfTapeScroller methodsFor: 'accessing' stamp: 'mt 10/4/2009 15:31'!
scrollTarget: aTapeMorph

	super scrollTarget: aTapeMorph.
	
	(aTapeMorph isKindOf: XpfTapeMorph)
		ifTrue: [self height: aTapeMorph class tapeHeight].
		
	aTapeMorph addDependent: self.
	
	self width: (aTapeMorph width min: 300).! !

!XpfTapeScroller methodsFor: 'zooming' stamp: 'mt 9/15/2009 11:21'!
shiftToLeft

	| tape step delta |
	step := 100.
	tape := self scrollTarget.
	delta := tape bounds right - tape fullBounds right.
	tape left = delta ifFalse: [
		tape left: tape left - (tape left + delta negated min: step).
		self updateScrollbars].! !

!XpfTapeScroller methodsFor: 'zooming' stamp: 'mt 9/15/2009 11:21'!
shiftToRight

	| tape step |
	step := 100.
	tape := self scrollTarget.	
	tape left = 0 ifFalse: [
		tape left: tape left + (tape left negated min: step).
		self updateScrollbars].! !

!XpfTapeScroller methodsFor: 'accessing' stamp: 'mt 8/5/2009 16:33'!
showHScrollbar

	showHScrollbar ifNil: [showHScrollbar := false].
	^ showHScrollbar! !

!XpfTapeScroller methodsFor: 'accessing' stamp: 'mt 8/5/2009 16:35'!
showHScrollbar: aBoolean

	aBoolean = self showHScrollbar
		ifTrue: [^ self].
		
	showHScrollbar := aBoolean.
	self updateScrollbars.! !

!XpfTapeScroller methodsFor: 'updating' stamp: 'mt 8/5/2009 16:01'!
update: aSymbol

	aSymbol = #resized
		ifTrue: [self updateScrollbars].! !

!XpfTapeScroller methodsFor: 'updating' stamp: 'mt 9/6/2009 19:53'!
update: aSymbol with: aNumber

	aSymbol = #resized
		ifTrue: [
			self updateScrollbars.
			self hScrollbar setValue: self hScrollbar value + (aNumber / self scrollTarget width asFloat)].! !

!XpfTapeScroller methodsFor: 'updating' stamp: 'mt 9/15/2009 10:16'!
updateScrollbars

	(self hScrollbar)
		updatePagingArea;
		updateScrollButtons;
		updatePagingArea.
	super updateScrollbars.! !

!XpfTapeScroller methodsFor: 'testing' stamp: 'mt 8/5/2009 15:52'!
vScrollbarNeeded

	^ false! !

!XpfTapeScroller methodsFor: 'initialization' stamp: 'mt 9/2/2009 14:30'!
withToolbar

	^ PanelMorph new
		changeTableLayout;
		listDirection: #leftToRight;
		addMorphBack: (XpfToolbarMorph new vResizing: #spaceFill; commandProvider: self);
		addMorphBack: (self hResizing: #spaceFill; vResizing: #spaceFill);
		bounds: self submorphBounds.! !

!XpfTapeScroller methodsFor: 'zooming' stamp: 'mt 11/1/2009 12:07'!
zoomIn
	"Hide a portion of the tape to enable the navigation bar to show more details. Not a real zoom feature for the tape but for the scroll/navigation bar."
	
	| tape step scrollValue |
	
	step := 500.
	tape := self scrollTarget.
	
	step := (tape width - 2000) min: step.
	
	tape expandToRight: step negated.
	
	tape left: tape left - (step / 2).
	
	scrollValue := self hScrollbar value.
	self updateScrollbars.	
	self hScrollbar setValue: scrollValue.! !

!XpfTapeScroller methodsFor: 'zooming' stamp: 'mt 11/1/2009 12:09'!
zoomOut
	"Show more of the tape to enable the navigation bar to show less details. Not a real zoom feature for the tape but for the scroll/navigation bar."
	
	| tape step delta scrollValue |
	
	step := 500.
	tape := self scrollTarget.
	
	delta := tape fullBounds width - tape width.
	step := delta min: step.
	
	tape expandToRight: step.
	
	delta := tape fullBounds width - tape width. "new delta"
	tape left: ((tape left + (step / 2) max: delta negated) min: 0).
	
	scrollValue := self hScrollbar value.
	self updateScrollbars.
	self hScrollbar value: scrollValue.! !

ScrollPane subclass: #XpfScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/9/2009 13:57'!
extent: newExtent

	super extent: newExtent.
	self scroller submorphsDo: [:each | each adjustLayoutBounds].
	^self.! !

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 12:05'!
toggleShow

	self
		visible: self visible not;
		disableTableLayout: self visible not! !

SimpleHierarchicalListMorph subclass: #XpfIterationTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationTreeMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:53'!
for: anXpfIteration

	| result |
	result := self
		on: (XpfIterationTreeModel new iteration: anXpfIteration)
		list: #rootItems
		selected: nil
		changeSelected: nil
		menu: nil
		keystroke: nil.
	^ result model addDependent: result expandRoots
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:06'!
backupExpandedState

	| backup |
	backup := Dictionary new.
	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			backup at: m complexContents model restUri put: m isExpanded]].
	^ backup.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:49'!
collapseAll
	"Expand all of the roots!!"
	
	self roots do: [:m |
		self collapseAll: m].
	self adjustSubmorphPositions! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
collapseAll: aMorph
	| allChildren |
	aMorph isExpanded ifTrue: [aMorph toggleExpandedState].
	allChildren _ OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded])
			ifTrue: [self collapseAll: each]].
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:12'!
indentingItemClass

	^ XpfIndentingListItemMorph! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 10:27'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:52'!
restoreExpandedState: aDictionary

	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			(aDictionary includesKey: m complexContents model restUri)
				ifTrue: [
					m isExpanded = (aDictionary at: m complexContents model restUri) ifFalse: [m toggleExpandedState]]]].! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 17:12'!
update: aSymbol

	aSymbol = #userStories ifTrue: [ | backup |
		backup := self backupExpandedState.
		self
			list: self getList;
			collapseAll;
			expandRoots;
			restoreExpandedState: backup;
			adjustSubmorphPositions].
	super update: aSymbol.! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:14'!
flagBlueContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIxSURBVDjLpdNdSFNhGAdwKSNy
g6ALC8GLoE8so49VRHVRFFQISlJeREXQBxWSSZDUpNrOTDoxSGvhmokV1TazLeekTBda9rVK
mW5lYq6slgutOI7j1vn3vKc4rCAv3MXDgfPy/73Pc3hOEoCkROq/B6v2GdIWHLnhmK1v7ZtZ
3PIuo9DmOr17iaUkLx1Ud6g2jgqo+JCU4x7Bs5AEe4+EhbYYMsv9iEYGcU+/VEZkYNkew7iJ
nHBrgl4YSeYEJJcIGF8qoKw9Bv8g8GkY8IaBthDgqatCsNGAq4czGbBLBhbv5VWT+EiL2Q9c
fg2YA0DDe+AxBeqDQPvX3+/PdwKmfA0+PDDCuGM6A9JkYP5Byyy1SexgQM5dIJvqpJdCb4DW
z8BDKguhhzxDor1Ig+7afBaG8hFnFDiyp1ZFgxa6JbcR2NoEnCLg2ltqfQBwUzcVhJc1+4c8
/Br0urV/A9OKvJyxQ/qmfQ5so/D2ZoB7CVh7gN4fwP1+wEWjGK/XoKt6C9rOrWeATwHUugEn
3RBjrW9oAI4TdJPCno80RlfsZ27d9+Eslxitcdpk4HbxCgboFEB1JvKk3CfhSjdQTXM7+yRo
rCLUZ8PSposvvMZX0bydtf2Vi9JT4avcjIr9GQxYrQBzC2zmVG2nkGIISyncF2mKLiDOKbQ+
it8JCqy9dGCe3EH8/KMu0j9AqePEyoSAwFNTVkKAHG7i1ykrPCbAfmw5A46OBbjw5y9kz8nx
Z78A90vOcDVd+i0AAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:15'!
flagBlueIcon
	^ Icons
			at: #'flagBlue'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self flagBlueContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:15'!
noteContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGGSURBVDjLxZO/alRBFMZ/c6Mm
omKhBLv4AIJiYekjCFopKSzyCnkGW99BbMTOQhsrBcFKsLCJhRYBNYYsWXNn5s6Z81nMGu+6
26XwFDOHge/PmfkmSOIk1XHCOvWn0ZdXsulPpAFZQbUgG5BlVDOURLWELEJJXLz3JMwTVOP0
tfsLChIEmC2A4OD5g0UHebLLWQl5bAcBJAcC4i9D6FZRiUtGMMOHb9j0PXhGGtruA3hCnpBH
zly+i5d+CUHNgCFPoDIDjcEJeQ8yNCxxYL/2m+U55Yh7mpFE8NhE7GiRwGsi7bzF8meoA8io
6ZC1jfWm7AnVCPLld1DjPna4y/kbm4Djw1emH56h2oN6VFNzIKOOCI6DFCTKj48cvN6m9jtQ
C64yAjcXrjrnoBu/94VbDymTPSZvHs/A6RgsT0gZqC1M/46AJcJKx7mbW8RPL5m+e8HKpeus
XbmNI1AFDHBkmZHzFpO9p3fkJSNLqEQsfgc6uhCQJRgy7qlF2ypXHynMEfy33/gbubc6XKsT
2+MAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:15'!
noteIcon
	^ Icons
			at: #'note'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self noteContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:14'!
pageWhiteTextContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADoSURBVBgZBcExblNBGAbA2cee
gTRBuIKOgiihSZNTcC5LUHAihNJR0kGKCDcYJY6D3/77MdOinTvzAgCw8ysThIvn/VojIyMj
IyPP+bS1sUQIV2s95pBDDvmbP/mdkft83tpYguZq5Jh/OeaYh+yzy8hTHvNlaxNNczm+la9O
Tlar1UdA/+C2A4trRCnD3jS8BB1obq2Gk6GU6QbQAS4BUaYSQAf4bhhKKTFdAzrAOwAxEUAH
+KEM01SY3gM6wBsEAQB0gJ+maZoC3gI6iPYaAIBJsiRmHU0AALOeFC3aK2cWAACUXe7+AwO0
lc9eTHYTAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:16'!
pageWhiteTextIcon
	^ Icons
			at: #'pageWhiteText'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self pageWhiteTextContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/15/2009 12:08'!
xpf7LikeFeedback

	^ Icons
		at: #'xpf7LikeFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpf7LikeFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/15/2009 12:07'!
xpf7LikeFeedbackContents

	^ 'R0lGODlhgQAQANUAAAAAAP///+vTLOvRM//qaP/rcv/te//ug//vi//vkf/wlv/xnv/ypf/z
rf/0s+vOSezSSuvTVf/0uv/1w//2zP/41+/OQufBMP/99uvHUOm4M/nWdv/57NyhJ9aXIuuY
Ev///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAACAALAAA
AACBABAAAAb/QJBwSCwaj8ikcslsOp/QqHRKrVqv2KzWCol4IRDLYCA4As5LdFQNYg/PcKva
vQYgN4F8HlOZUChlRHNKdFKFhVNzdlSIeBQSDg0MCwsKCRMcA4KLb4uKcUJwaKBtnqShnJ1u
opugoqmsqp2oQ3iQkpUJCAcHGBetm7SlworEnIepw8rFy6bEs8u0bhAYkZMKuwbaE7/Axt/N
4Mqtx87h58zB46h0FhzW2AcGBfQKGkau5sz75uvCqvli8fv36h87IxYq4EogrwCBhwY6mNFH
EVw6ZEUwZqyIrh+7ZA8oSIrn8CGBAx4EWeQ4cJxGaG0IrpwZbVg7ChMq4JTwUIGEN5TkyJki
1XJVMmRGk35SWq6cQRAPombIoCHSB6BbsmrdmkQDhw9cw4rlqgHs2LNorZhNy7atlCAAOw=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:37'!
xpfAccept

	^ Icons
		at: #'xpfAccept'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAcceptContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfAcceptContents

	^ 'R0lGODlhEAAQAMQfAHbDR0twLrPdlpHQaZGYjPn8983muYvSWIPNU3G/RNTtxTZZGn6TbVKC
LJPmV4nkTOz35ajld8LmqV16Rn7VR4DLT4zlUExgPHGLXIvOYKTad4DZSGm4PlJnQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAWE4Cd+Xml6Y0pORMswE6p6mGFIUR41skgbh+ABgag4eL4O
kFisDAwZxwLl6QiGzQHEM3AEqFZmJbNVICxfkjWjgAwUHkECYJmqBQNJYSuf18ECAABafQkJ
D3ZVGhyChoYcHH8+FwcJkJccD2kjHpQPFKAbmh4FMxcNqKhTPSknJiqwsSMhADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/17/2009 17:32'!
xpfAddIteration

	^ Icons
		at: #'xpfAddIteration'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAddIterationContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/17/2009 17:32'!
xpfAddIterationContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0
d2FyZQBBZG9iZSBJbWFnZVJlYWR5ccllPAAAAahJREFUeNqMk79Lw0AUx78X
U/zRioMUUVGci7hUd+Om1LGC2L3+A6VgEXFwEycHuxcEK4LopKCzYIWais6C
WKUKgWpJL5d4lzZNhST64Hgvd+8+933vLsSyLAjbLhaXuRvl45yPRIB/5XvO
0DbJCRhjY1vJZL5SqSSCvMgzTRPOII6CjUIhvZNKHTjfXkYIQa5QWOdh3pmT
ncAwDGLyzYLqZ5Ik2Xndcy6AUggAC1AAvibyPAG0rYAFKBAlUD8FlFIiTjcY
8wfwEkSeN6DZbAGCesDXRZ4fAH+VYLYAuB++sfsBarmA5j8UZO4yOJ46zTbk
7xkOSOPLdB+SAIgrFD3wG+UPFWuLKxP85Dh063cJjgKvEnLlTajag/0ONKYB
up1zCwslF6DrvteovquIKiN2XDNqUJbm4yK+PrlyFWiaJomt/eEw6vU6IpFI
x8fCMTxdPLYaqRBUjsql1r2i1OnBW7XaEwqFMK0o2QEO6fa7C3t43tezRAc+
2SfQ4EcZ1iwvId35mYbm5lZ5EyeZYRz2yPKql6exl6I5+B01+9glZJLGeC9+
BBgAlQAyLU/LNHUAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/24/2009 16:07'!
xpfAddTask

	^ Icons
		at: #'xpfAddTask'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAddTaskContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/24/2009 16:07'!
xpfAddTaskContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAITSURBVDjLpZNNSJRBGMd/s7q5
0ZoWISZSRAgF5VpELFJ0CK9RneokEl1qO3URpFNCXqIO0aFLEF0iiAj6JBB0WYwOoikRJiXU
Yqbsumv7zvu+M/N02BV30YPgc5h5GPh/zMz/USLCVirCFqt+tZGfb8UUFxEJEBMiNkRMgBgf
sT6EGms0YjwINU0Xn6haAmuIHrm0TkEEFFQWQCD3/PJ6B37+N9tFEOeVDxSIOEAhrDGoSAMS
ehtcwRhcMI8pfgLnIxKUdxeA04jTiPPYtucCLixtQGB9wCBOg4QVUDVYI64EYpBgAwdmZals
uUbZwzldIfHAeWUR8289gbMaPTOK8b+DDUAMVheI7W8pKzuNWA/E1byBWg3S4oteibZ0EO86
DzhcMEdx/BkN+3aBlBie1YzMOZY9j6CU489K/tabOxOD9VVMhAuT5D6m2dl9FaUUTkKQEu+/
FZny45w5fYL23R0MT79kbGr0djLV1hyp/u/Gk72E+b/kR+5VwBqxmtdfc3QdSmAjlsTeHqwK
SR7tBri+FmWjUXURdhy/gphmiplX1MUSxFr7WCgsEVVxzh2+AcDNs4842NIJEKvKgSb37j5i
NBJ6BN4XmM1Q+vyUQiFgOpthIpumv+cxQx/6iNU1AGi1mWlMptoG2w80DXR3nqKj9Rgz8+Nk
JtP8+rF8V212nJOptiHgGtAIFIGHYw+y/f8B3ntD1Kp2NbQAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfCancel

	^ Icons
		at: #'xpfCancel'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCancelContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfCancelContents

	^ 'R0lGODlhEAAQAMQfAOt0dP94eOFjY/a0tP/JyfFfX/yVlf6mppNtbf5qanknJ9dVVeZqat5e
XpiMjGo4OIUvL3pGRthWVuhvb1kaGv39/f1lZdg7O/7Y2F8/P+13d4tcXNRTU2dCQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAV/4Cd+Xml6Y0pGTosgEap6G0YQh6FDskhjGg0AMJkwAjxf
BygkGhmCAAXl6QyGnuLFI4g+qNbixLMNdBNfkpXBLncbial6AC17Gvg4eND1BPB3cHJVBguG
hwsSHHo+GRqKHJGRCQo9JI4WBZoFFpUVMw8QCqMQU58qJCclqKytIQA7'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 19:45'!
xpfCardOcclusionIcon

	^ Icons
		at: #'xpfCardOcclusion'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCardOcclusionIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 19:44'!
xpfCardOcclusionIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAGBJREFUeNpi/P//PwMlgImBQjDwBrCgCzAyMhIVKMCwY6SN
C+A2fM3AKs7IPYNGYUCs37EFBgM0Mf1fuHAhiEEUhumjfiACXYGhKD4+Hh5tGIEKywuEwoCg
AUM3LwAEGABnkDTmpK46EgAAAABJRU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfClock

	^ Icons
		at: #'xpfClock'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfClockContents

	^ 'R0lGODlhEAAQALMPAOz2/6mjhdrMrMe6kkE4H7OfY7iofJR7PnBgN9Dq/tLT1Ojaw3h/hf7+
/v///////yH5BAEAAA8ALAAAAAAQABAAAAR88MnpqpuYusNPzVLDLeTCNZm4CEM7CMKBSts6
OEhltDl9sBaHorHzPGo3i4IQIBYIlcMi2VgyEgDDs4KYIhqNAAFA1kJxC0ODDGAgEonC9ogQ
GNiJa2DQoxcGAXBwAQIFfQ8NCH8BjFqGMxOJBHJyCF8gRw4Em2eYGh8ZEQA7'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/15/2009 15:08'!
xpfClockEdit

	^ Icons
		at: #'xpfClockEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/15/2009 15:07'!
xpfClockEditContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANZSURBVDjLVZN7TFNnGIdPTMwS
Y/aHyTJjYkJmIjNT/zCLMS4uoomKRhMTTcjwMoJCWDTGeUFAtmIkoKIoA4QqoJRLrKyzLQ63
qS2ltDtcpOXYQi1SbMFSodALp1fbn+9pgGwneU6+vN/7e75LzmEAMHNPmSWEiDASPcRnQv2/
UO3L+XmWSF6oM7MyZilxfa43fTwyrYK394iLVezXnn8eURPuedT/Kg5qfAM50wHzZTf1s8Tq
hMDVyhR42aMT4cmnmNJnzPZJt/pLtdOo7HWhzuBMIIxvaUZhkG7iPVwR7zec+0C5fmIp43jA
FPqMl92TXRmzuqat0Qq9HY+M79GiGUO1zISKxyY8eDGKloFx1HeqMKTYHQs4Hn+cfLLOQtlk
5m0ts21YvMzSfX8jf101ilbWDpnKhhGHF9NeP6a8c7DYvZD8PYL6LhseyctgbNkSMos/f0XZ
5MRFnK9T3sj9nYNYa4OUVhOeGY8HbyacCNJYwB8H/lA2Y7g5DVZ5MQx1u2Cs+uZYQpBe26++
0MahpsMCM63MR+Pw8zyq6hvgIpEvFIL6WQmcL3PhGWwn2wRmB9ugL9szmRAcuq1xn215hWvN
RrgCEcyEYgjTRJ6oCE0yOe7dyYDbJELYoYBTfQMBToaPY1pwDVnBhOBASYc76z4LUcMA7P4I
SWJweHy4WnYT1eXZmHldiFhAi8DbU3D3nMaQJBOsODPeU3FwbUKw55c2dVq5CkWSfnRaPXhP
h3b4Iuj8pxozXB5iQT34keMI2tPhM+eDq9mH7CuVfYnvQHilXHgo2it6gjP3dCiVWjBFF2Yd
lMPZmzsfPobgux/gfV0Ac1Uqhe9CyCwKvjtd/S1h2lWoxNlaDWrqxDD/dZG2rUHQlomQ/Sg8
tJOhqt1I+7UJQq+QWRQIbD5Zlp1TKuGzfr4I05/5MHbcxjh7GLwtHW7DJQz8tg8/lUhwovgh
L/Qu/gsLA51Ol8JxHKTXdgK+MQyLD+Fl/ip016RCKdqOjLxydGm74906XZx6v/+foL29/QvC
b7VacTVrA8L6SoTZO2CLU9CcmRTf/2NO3/q0ApFCqfRZLBZQb5RYsyhobGxcTgwT4cPbVoRK
jn8dfVGaGn1+c0enMnfDVwur0XwS4SEmiJVC7RNi1+PWy99nOwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:01'!
xpfClockPlay

	^ Icons
		at: #'xpfClockPlay'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockPlayContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:00'!
xpfClockPlayContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANBSURBVDjLXZNrSFNhGMcPQQQRfYv60meJ
oiCtROuDZRcEA6MP3ckwS0tlZVlptnXRqavMaqZ5Ka1Jq1bOmWiXs466mqZzLs0103CmLp27HOdl
af+es2xFL/xe/jzv8/+/vA/nMACYsWpmDiEmjEQTMU+o/wvVFs+e64mAP3XGoWLmEtljzXv7vSMs
XM37bHp1ZEPyK6+WsM+ifa+O4tyGuJHxzjQ79euJpb4AWwWT6tLv/zY1VI3hd9GOD8oQXtowglvN
NhS3DfoQ9DWuB23K1R6nSeLh205+J18LMZex3mPOu41p9qH6aIfuQciPvHd9eGQcgIL7CrmqA3mP
O3DvdQ8Uhn6UvGXxSb11Ztz6eHro+TIzeQOYLwXMhq7C+ebGopWebLYHFfo+qNhedFtdGHHxGHaN
wdznQnldN0rqe/GoUgajIniys3BhK3kDfINILq7KSXlqQmFDL5R0m7BGnU58/jaICdIC/E/gjqYb
cq0F6UoO8aW6K74ZCNveghbtqScm3Kkxo5Nu9vz4Cd7jwe2SUtgoyD05iae1b8B9diJT2Q6hV/D4
A3bmcnaRohVZD42wjXsxOjmDKTo4K5bggaoSKRckqNPpwQ5acEKuh9ArePwB2zNr7LFFeohLDejj
vRQyA6vTjcuyqz4zZ2hHWtMJiOpjkfDmEGLL1BA8/oBt6U+0u66zkJS34K3FiQF6tNXtxQttI3rs
LgxNAymNiSjvzsfVVgkSa2MQmXWrxR8Qduq+OEL8HEl3dZAqzRimgY16AfcMQdpBASfZeJSY81BM
SBpTEK3cjUj55rW+gNAEeRDRseV8FUQFHLKUXTD0OsDTPHiPF0bShyujkd8hwyXDaeR9lCK57hjC
czb8/dbXHpYdiZOWe8LPPMMB2UuIbnJIvtEA0fV6HM9lsU+xG7ntGTjXlIgc40UkaGKwXrxmwh+g
0+nCTCYTXrPcdOixIqw5rsC6JJUPQe+4G4Ws1guQGtIRrz6EkPQgb+Dplb+foNFoFhG8xWKBuqrK
vmpPmmTFrlQtYZ9FG3Fj84Sk6QyOVh5EcGogDmTv2eEfYllZ2QKii5gilv//KwtslIaORuRuQvC5
QEjzM4apb4lQ/wXCx9fe4QKeWQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:02'!
xpfClockStop

	^ Icons
		at: #'xpfClockStop'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockStopContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:00'!
xpfClockStopContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMsSURBVDjLXZNrSBRhFIaHIIIyu1q/+hdY
JBVhJUmE0EWiC0U/ukM/KroRllGR1S4UWVnZTdJMS2ujrbZSK7ruNK5rm+m6bV7WNbfc1F3d2d3Z
cUxH7e18k1k08AyHb87zHuYwwwHgOp9yQwgd4SA+EMPY+b/Q2cSB5zYi9s85FzJxQ4kznRUbvqsB
M6SKjX5b0XJL6muVJ8QB+PdFq4SIfUegqzZNpH4bMUkL8N/ljki2TS09vqfoKN8S+micJ6dbArhS
4ceN6jYNVp8XmlBtnKWEnXpFrt7fTl4lMZTz3uSORhxpoq90S8h6e17vpfJm3HO0wiB8RZapBpfu
1+DmmyYY7N+R986MuqIl/V3e+32+x1Nd5MZyX7K5+fU5w11ludOVM+Ym3LU1w2T2oNErISDJ6JA6
4WqWUPiyEXmlHtx7kgGHIaG7Nie6itxYbRGpN4rPHnzoRI7FAyNNY1cwHEZDSxt+UM2QfwLXShqR
xbtxzChgZ771pLYDdtuQXckfeODEtecu1NJkpfcnZEXB1bx8+Cko0t2Nhy/eQmgI45TxE1gvcwYD
1mQKYoqhCqfvOODvUhHs7kcPPTis0+O26QkOHtfjpdUGZ1jFviwbWC9zBgNWnHoubsu1QZdvR7Os
Ukg/vOEITmSc02TB/gkdvcDHgIo9meVgvcwZDEg+9oBfe8EMfWEl3rnDaKWX9kZUPOPL0CRK8PUB
HgV49DmEfdnvwXqZMxiQdOCWbqnuMfZetyLd6EIHLSyoApF+guoQBUjr1kOeMAFSTAyCRGD8eLSN
G+fRAhL3ZMUTNYuPFiMlW8BpYz3snhBk2oesqHBQzURl9Wp0rlwJadkyhJKT8XXs2L/f+pytGdt3
pBcqCw89wuaMV0i5LCD1ogUpF0qxO9OsTWSiOHMm2uPi0J6UhLrRo/8GWK3WJKfTiTdmoS9xVy5m
7zZg7l6TBqu9NE1ctAhtU6agZfJktCYmoio6+rdcUlISQ8hutxtFxcXijPVp+ri1R3hCHIBvGDMG
vgULNNGbkIBv8fEoi4r6HVBQUBBF1BM9xLT/f2WGc9SoOjaxYuRITbQQ/IgRwV81l9Ohf930iQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 11/25/2009 10:32'!
xpfDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 11/25/2009 10:32'!
xpfDeleteIcon
	^ Icons
			at: #'xpfDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeleteContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:41'!
xpfDeveloperIsOffline

	^ Icons
		at: #'xpfDeveloperIsOffline'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeveloperIsOfflineContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:41'!
xpfDeveloperIsOfflineContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAACXBIWXMAAAsTAAALEwEAmpwY
AAADG2lDQ1BQaG90b3Nob3AgSUNDIHByb2ZpbGUAAHjaY2BgnuDo4uTKJMDAUFBUUuQe5BgZ
ERmlwH6egY2BmYGBgYGBITG5uMAxIMCHgYGBIS8/L5UBFTAyMHy7xsDIwMDAcFnX0cXJlYE0
wJpcUFTCwMBwgIGBwSgltTiZgYHhCwMDQ3p5SUEJAwNjDAMDg0hSdkEJAwNjAQMDg0h2SJAz
AwNjCwMDE09JakUJAwMDg3N+QWVRZnpGiYKhpaWlgmNKflKqQnBlcUlqbrGCZ15yflFBflFi
SWoKAwMD1A4GBgYGXpf8EgX3xMw8BUNTVQYqg4jIKAUICxE+CDEESC4tKoMHJQODAIMWgx9D
JcMqhgeM0oxRjPMYnzIZMjUwXWLWYG5kvstiwzKPlZk1m/UqmxPbJnYV9pkcAhydnKyczVzM
XG3c3NwTeaR4lvIa8x7iC+Z7xl8tICSwWtBN8JFQo7Ci8GGRdFFe0a1iceKc4lslUiSFJY9K
VUjrSj+RmSMbKicod1a+R8FHkVfxgtIU5SgVJZXXqlvVGtX9NGQ13mru05qonapjrSuk+0rv
iP58gxrDKCNLY0nj3yb3TA+brTDvt6iwTLTysbawUbUVsWOx+2r/3OG24wWnY857Xba6rndb
6b7UY5HnQq8F3gt9Fvsu81vlvz5ga+DeoGPB50NuhT4L+xLBFCkYpRRtHOMWGxWXF9+SMDtx
c9LZ5OepTGly6TYZUZlVWbOy9+Tcy2PKVy/wKSwuml18uORtmUS5S0Vh5byqs9V/a/Xq4usn
NRxr/N1s0JLeOq/teodgp3dXe/fhXoY++/66Cfsm/p/sOKV16onpvDOCZ86a9WiO1tySefsW
cC0MW7R48celDssmLH+40nhV6+qba3XXNa2/udFgU8fmB1uttk3d/mGn765Vezj2pu87fkD9
YOeh10f8jm4+Ln6i9uST095ntpyTPd9+4dOluMunrlpcW3ZD9Gbrra930u/evO/z4MAj08er
nyo+m/lC8GXXa+Y3dW9/vi/98OlTwed3X/O+vfuR//PD7+I/3/5V/f8PAC4MHYugPAkxAAAA
IGNIUk0AAHolAACAgwAA+f8AAIDpAAB1MAAA6mAAADqYAAAXb5JfxUYAAAF2SURBVHjabNG/
S9RxGAfw133O89ILi6OrE/qBmwhGgoI0JRFYgRBEEV0QDQ0F0eJiEf0XbbYUtBVEDSEFQeBS
kbZIUBBmGibpdXee3X0/Df5q6P1sr2d4w/OkovVMl+oX/vRWCqupWmVtNvP43N11T0VMdSbj
O4Z3atcq7bc57618yY+UPpKKpnOrr/YO7BM1RA1kZUx4u9TVU1oILN/JDRQ1BW065HVoWjJs
T/77fQLli3mJIIWGhqhVsOC4uSFaqBZyVgVpaxJRU1pZzUHVLC3UfvzcX/BZ2mstEstOKiv6
JtQJhIcfZDU9MqhfnxPuqTnkuV2TBNpuz8+80S2LtLRETp8JU/XiVQJnGu3n3y1O2o0myHvp
QaPnys1PG4divH/+ab3Y7YhoxhOx3Ht29AWIG3Pr9PDa5TgSh+LhmElGj216avMXDH49eiCx
ouzZYrWwqWFrrzbb5YZTOoVf27pVEY1d6qiERJKpXr+2rf9U/D9/BwA9Z5PtuXkkmQAAAABJ
RU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:42'!
xpfDeveloperIsOnline

	^ Icons
		at: #'xpfDeveloperIsOnline'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeveloperIsOnlineContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:43'!
xpfDeveloperIsOnlineContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAACXBIWXMAAAsTAAALEwEAmpwY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'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 15:51'!
xpfDone

	^ Icons
		at: #'xpfDone'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDoneContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 15:51'!
xpfDoneContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGrSURBVDjLvZPZLkNhFIV75zjvYm7VGFNC
qoZUJ+roKUUpjRuqp61Wq0NKDMelGGqOxBSUIBKXWtWGZxAvobr8lWjChRgSF//dv9be+9trCwAI
/vIE/26gXmviW5bqnb8yUK028qZjPfoPWEj4Ku5HBspgAz941IXZeze8N1bottSo8BTZviVWrEh5
46EO03EXpuJOdG63otJbjBKHkEp/Ml6yNYYzpuezWL4s5VMtT8acCMQcb5XL3eJE8VgBlR7BeMGW
9Z4yT9y1CeyucuhdTGDxfftaBO7G4L+zg91UocxVmCiy51NpiP3n2treUPujL8xhOjYOzZYsQWAN
yRYlU4Y9Br6oHd5bDh0bCpSOixJiWx71YY09J5pM/WEbzFcDmHvwwBu2wnikg+lEj4mwBe5bC5h1
OUqcwpdC60dxegRmR06TyjCF9G9z+qM2uCJmuMJmaNZaUrCSIi6X+jJIBBYtW5Cge7cd7sgoHDfD
aAvKQGAlRZYc6ltJlMxX03UzlaRlBdQrzSCwksLRbOpHUSb7pcsnxCCwngvM2Rm/ugUCi84fycr4
l2t8Bb6iqTxSCgNIAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfEdit

	^ Icons
		at: #'xpfEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfEditContents

	^ 'R0lGODlhEAAQAMQAAGB3lYivyMDf/XiZt+Ts9ajT/Mbh/UlVa/P2+bLY/FRlfu3x9ZzN++Xy
/rTR4ENLXN7v/tTk8Jm/1enx96jL3uDo7ykxQz5FVb2JAP+8Bv/RV6HQ/FSr9qfR+jhllf//
/yH5BAAAAAAALAAAAAAQABAAAAWV4CeOZClGjkNJUhAMsOdJohMRUz4RvNdxntrEQCQKGj6g
QkRBFAXHpAex/EicBijy54FQRddslAspfD8BhBZDLpgPovQRo8l0C50NAf4ZLBp0GRhleXoP
In4RdYN4GxsMFYd9CwkKlgoAAwybFReICAkJeAUDAKYAC54fABEIOzwEFbILDhaImJcHBw8P
FxcWVSbCIiEAOw=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/14/2009 14:26'!
xpfFeedback

	^ Icons
		at: #'xpfFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/14/2009 14:25'!
xpfFeedbackContents

	^ 'R0lGODlhEAAQAMQAAP/99v/qaOvOSem4M+zSSv/ypf/ug//1w//2zP/xnv/te//zrf/0uv/4
1/nWdufBMP/vkevTVf/rcv/0s//wlv/57OvRM//vi+/OQtaXIuuYEuvTLNyhJ+vHUP//////
/yH5BAEAAB8ALAAAAAAQABAAAAV+4CeOZEl6aKqWHhG9BIFZ1uaNnqN6QHMgCNsn50EwJotC
IkGBHCoWlO6YZEIuBgPggSIAkEoKVkE+cD2YClhsUEjelAEK06hC2pKAXsFBCRBJbHl6AQYZ
N2gIBw2KDHoUDIc4ApQdHQNIGpInOwMVGjcmLAOgoiYepaYsoR8hADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 16:22'!
xpfGridHoverIcon

	^ Icons
		at: #'xpfGridHover'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfGridHoverIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 16:22'!
xpfGridHoverIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAFBJREFUeNpi/P//PwMlgImBQsACY3R1dZHklLKyMkYUA6CA
EYn9nwCfOl6gXhggOZNYPuEwKC8vh3M6OzsZhmAYQJ1NfhgMjXTAOOC5ESDAAEdmGMAIlkPJ
AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 15:58'!
xpfGridIcon

	^ Icons
		at: #'xpfGrid'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfGridIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 15:57'!
xpfGridIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAADpJREFUeNpi/P//PwMlgImBQsACYzAyMpLkFKDLGVEMQBaE
GYiPTzUvUGwAIywWRsNgNAwG1AUAAQYAtb05E6xvSrgAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/30/2009 11:19'!
xpfHammerScrewdriverContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAq5JREFUeNp0k11Ik1EYx5+zsZaNSWxt0boQLYRgCtrVzESQ
IJAhFUKiEDSYu/DCjF7EuhBRECH6oiChLipBu1lS2YWLpKYLClorSppRG5q6cM5tuW/f/g9M
k1oHfjt7d57/b+fjPaK5uZm2N1mWubODLAiDlY2NjSBYAql0Ok25XG6rXmkwGKxFRUX1CJrA
l0wmwwWfwBK+myoqKo6Ul5cfi0Qi+9bX15WQrKAuuyUIBAL1brf7NvAuLy9PJxIJUqvVXBCF
ILCwsKBvb28/a7VaT2q12v1+v1+g5hv+IA0ZKVFocjqd3v7+/lafz1ccCoWmISIeTKVSWZBJ
JpNGs9lcazKZDpWWlu6ZnJycz2azfkAKCB7DOtTW1jbicDhasSSJB4LBIK2trVE0Gv0BcZBn
BjmVlJRY4vG4kcf4WbG5lrm5uSGbzTbS0dHRajQaJd6oxcVFWl1djSkUCiM/8wZiWapYLMZU
Qk7/tLKyMglLel9VVSUd1Wo11dXV0sTExHuLxXKZTwey7qmpqYBer7frdLoGKtSwTmlUkl66
NRqfz2YL8fO24UqWhMNhOX/cBduJu0S/5MFB2alSzd8U4vCsEOQA+dbAEvQHC4XPAO9wTY2M
itxKU1ME4fHPQpz3QnDrj6RguwQ+1NXV8fQSx4n6nhK9jdvtMsJP3gkheSC48h8Jb9JsY2Mj
h5Pg3Gl8PCIacEKS6OyUEX42I0T3cwgeYuzUtvBV8LWlpYXDaXCdfzQDhLl4YAySdE+PjLDL
JcRFFozkwzdA0I5p5i/Qg7+nxtftPiT3IMn19ckIvxol6t0U/Ozq6uIwX7FxYAC7wS6gBjuB
FugvEF27AwmfzjDRm2G+TEDn8Xhq0WO/qBfsAPyGspR3SwU0oHiG6OMBor3fXS7la6KxF0Qz
vwUYAHOGWZhFPrMZAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/30/2009 11:20'!
xpfHammerScrewdriverIcon

	^ Icons
		at: #'xpfHammerScrewdriver'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfHammerScrewdriverContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:39'!
xpfHistory

	^ Icons
		at: #'xpfHistory'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfHistoryContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfHistoryContents

	^ 'R0lGODlhDAANAMIEAAAAgICA/4+w1LTR4P///////////////yH5BAEKAAQALAAAAAAMAA0A
AAMhSLq8AaExQIMVeKgXpffcR1DQlW2QqKKdR1oBJmhEuH4JADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:20'!
xpfLogin

	^ Icons
		at: #'xpfLogin'
		ifAbsentPut: [Form fromBinaryStream:
			(Base64MimeConverter mimeDecodeToBytes: self xpfLoginContents readStream)]! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:29'!
xpfLoginContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEuSURBVDjLpZM9SgRBFIRr/EHX
wGVFAxUPYmTgMTyEoblX2NwjGG9i5B0EMTIQFWTBaHTeqyqDHmdX0FlhHzSvO6n+qvp1ZRvL
1AqWrLX5w93VuSXBJkhCKovMrpOJk4vr6lcBidg7PgVMWIYkWATEbv9wc/03AZkwiY/3J7i9
3STcEmxu7yOz6ReQCDFhFTExIRJWgox+gcwot2UUAmY5kzADzkBEL0Er0PUZReUGIhcRNAU5
muI/E1JiZzjF4cEbHp+HyIx+C2otdPgqfTodoP5c/w9BgNn8sPD6sgFzFVu76ieIaGYhMtrw
WiGVPRkLCLJkYJX0vyms8rQLMigWBqMj2IKZsFSWCbGM83xVtjGZTFzXNeL2spv3+fmf/QnC
Ju5HZwCA8XhcVct+5y9H3H2zjxE/HwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:20'!
xpfLogout

	^ Icons
		at: #'xpfLogout'
		ifAbsentPut: [Form fromBinaryStream:
			(Base64MimeConverter mimeDecodeToBytes: self xpfLogoutContents readStream)]! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:18'!
xpfLogoutContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJHSURBVDjLlZPNi81hFMc/z713
7p1mTCFvNZfGSzLIWNjZKRvFRoqNhRCSYm8xS3+AxRRZ2JAFJWJHSQqTQkbEzYwIM+6Yid/z
nJfH4prLXShOnb6r8/nWOd8Tcs78bz0/f+KMu50y05nK/wy+uHDylbutqS5extvGcxaWqtoG
DA8PZ3dnrs2srQc2Zko41UXLmLdyDW5OfvsUkUgbYGbU63UAQggdmvMzFmzZCgTi7CQmkZwd
EaX0JwDgTnGbTCaE0G4zw80omhPI92lcEtkNkdgJCCHwJX7mZvNaB0A14SaYJlwTrpHsTkoF
lV1nt2c3x5YYo1/vM9A/gKpxdfwyu/v3teCayKq4JEwT5EB2R6WgYmrs2bYbcUNNUVfEhIfF
Yy69uci+1fuRX84mkawFSxd/4nVWUopUVIykwlQxRTJBTIDA4Pp1jBZPuNW4wUAPmCqWIn29
X1k4f5Ku8g9mpKCkakRLVEs1auVuauVuyqHMo8ejNCe+sWPVTkQKXCMmkeZUmUZjETF1tc6o
oly+fgUVw9So1/tRN6YnZji46QghBFKKuAouERNhMlbAHZFE6e7pB+He8MMw+GGI4xtOMf1+
lsl3TQ4NHf19BSlaO1DB9BfMHdX0O0iqSgiBbJkjm491hClJbA1LxCURgpPzXwAHhg63necA
Ii3XngXLcRU0fof8ETMljIyM5LGxMcbHxzvy/6fuXdWgt6+PWncv1e4euqo1ZmabvHs5+jn8
yzufO7hiiZmuNpNBM13rbvVSpbrXJE7/BMkHtU9jFIC/AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:31'!
xpfMedal

	^ Icons
		at: #'xpfMedal'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfMedalContents readStream)]! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/12/2009 18:45'!
xpfMedalContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIHSURBVDjLfZKxa5NBGMZ/35dE
amtFMkgGpaAVQcTRLp1LoYubi6MOgqiTZOrQxYKjOIh/gIuim5YqdChKl4KbQ0XESoPYaGq+
fHff3fu+DklM2lRfeLg7uOd3z929iZnRL7l9y7hwkbi6isWIiaAhoL2xMj+PvVlj4u1K0veU
Gaphkw0ZNcbuOkasCMOWA4AQsRhR79EYu6AY/87LhwDSfYAiYN7D1BTiPeo94j3iHMn0NNrJ
saL4T4IiLNH+sFhZ2KFy9Qcc8aga0knR3S/oWrO751+A8p332+bSNmfuHmP8PEZKqjlJaKF7
HynGHrZ1wW0Pe5L+L8R3p2YwXjL9qGal42hsQvyNSYaJgyQBCbQ36w0puFK7Zhv73sAk1Dl9
r2blE1j8BZJj4nrKUP8d04yxczdrYY/6yBU0FrOliUtY3MPU9eR7cph20PCTdPwkIWN25BdU
pWppGdMc1PfkBhIH0gYLxILqKEAULIIWg+j902WQCPPE4pA+0ChNCy3MwoHobgBBkaJDyGmO
AoJbl90NkqS0P770Rguk6VHyna90WqyPAMSx3N6831C3C6UxzCImvSQoSXmS6BI+PX/VyDOW
R/oAYOdxckMCS5OXr9cq1bOQGBYzpGiRfdti6+nrRp6xOPfMnhwKAPj8IJkpWtSjY1Yi1eDB
dWi6jHURludedBuoX38Av56vLTwJJBoAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 15:58'!
xpfMoveCardIcon

	^ Icons
		at: #'xpfMoveCard'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfMoveCardIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 12/1/2009 15:59'!
xpfMoveCardIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAGJJREFUeNpi/P//PwMlgImBQkCxASy4JBgZGfH6Deh1RrwG
gBV9zcBuOPeMQRQGjOjRCPI7yH/EhgGKATDNZHkBWTOy7YRcgtMLxLqIiRLNKC4gx/8oLsDm
f7Kike4JCSDAACwsQxE2VhXfAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 5/6/2009 16:09'!
xpfOpenStories

	^ Icons
		at: #'xpfOpenStories'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfOpenStoriesContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 5/6/2009 16:09'!
xpfOpenStoriesContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAK8AAABkCAYAAADwvWACAAAACXBIWXMAAA7EAAAOxAGVKw4b
AAAKT2lDQ1BQaG90b3Nob3AgSUNDIHByb2ZpbGUAAHjanVNnVFPpFj333vRCS4iAlEtvUhUI
IFJCi4AUkSYqIQkQSoghodkVUcERRUUEG8igiAOOjoCMFVEsDIoK2AfkIaKOg6OIisr74Xuj
a9a89+bN/rXXPues852zzwfACAyWSDNRNYAMqUIeEeCDx8TG4eQuQIEKJHAAEAizZCFz/SMB
APh+PDwrIsAHvgABeNMLCADATZvAMByH/w/qQplcAYCEAcB0kThLCIAUAEB6jkKmAEBGAYCd
mCZTAKAEAGDLY2LjAFAtAGAnf+bTAICd+Jl7AQBblCEVAaCRACATZYhEAGg7AKzPVopFAFgw
ABRmS8Q5ANgtADBJV2ZIALC3AMDOEAuyAAgMADBRiIUpAAR7AGDIIyN4AISZABRG8lc88Suu
EOcqAAB4mbI8uSQ5RYFbCC1xB1dXLh4ozkkXKxQ2YQJhmkAuwnmZGTKBNA/g88wAAKCRFRHg
g/P9eM4Ors7ONo62Dl8t6r8G/yJiYuP+5c+rcEAAAOF0ftH+LC+zGoA7BoBt/qIl7gRoXgug
dfeLZrIPQLUAoOnaV/Nw+H48PEWhkLnZ2eXk5NhKxEJbYcpXff5nwl/AV/1s+X48/Pf14L7i
JIEyXYFHBPjgwsz0TKUcz5IJhGLc5o9H/LcL//wd0yLESWK5WCoU41EScY5EmozzMqUiiUKS
KcUl0v9k4t8s+wM+3zUAsGo+AXuRLahdYwP2SycQWHTA4vcAAPK7b8HUKAgDgGiD4c93/+8/
/UegJQCAZkmScQAAXkQkLlTKsz/HCAAARKCBKrBBG/TBGCzABhzBBdzBC/xgNoRCJMTCQhBC
CmSAHHJgKayCQiiGzbAdKmAv1EAdNMBRaIaTcA4uwlW4Dj1wD/phCJ7BKLyBCQRByAgTYSHa
iAFiilgjjggXmYX4IcFIBBKLJCDJiBRRIkuRNUgxUopUIFVIHfI9cgI5h1xGupE7yAAygvyG
vEcxlIGyUT3UDLVDuag3GoRGogvQZHQxmo8WoJvQcrQaPYw2oefQq2gP2o8+Q8cwwOgYBzPE
bDAuxsNCsTgsCZNjy7EirAyrxhqwVqwDu4n1Y8+xdwQSgUXACTYEd0IgYR5BSFhMWE7YSKgg
HCQ0EdoJNwkDhFHCJyKTqEu0JroR+cQYYjIxh1hILCPWEo8TLxB7iEPENyQSiUMyJ7mQAkmx
pFTSEtJG0m5SI+ksqZs0SBojk8naZGuyBzmULCAryIXkneTD5DPkG+Qh8lsKnWJAcaT4U+Io
UspqShnlEOU05QZlmDJBVaOaUt2ooVQRNY9aQq2htlKvUYeoEzR1mjnNgxZJS6WtopXTGmgX
aPdpr+h0uhHdlR5Ol9BX0svpR+iX6AP0dwwNhhWDx4hnKBmbGAcYZxl3GK+YTKYZ04sZx1Qw
NzHrmOeZD5lvVVgqtip8FZHKCpVKlSaVGyovVKmqpqreqgtV81XLVI+pXlN9rkZVM1PjqQnU
lqtVqp1Q61MbU2epO6iHqmeob1Q/pH5Z/YkGWcNMw09DpFGgsV/jvMYgC2MZs3gsIWsNq4Z1
gTXEJrHN2Xx2KruY/R27iz2qqaE5QzNKM1ezUvOUZj8H45hx+Jx0TgnnKKeX836K3hTvKeIp
G6Y0TLkxZVxrqpaXllirSKtRq0frvTau7aedpr1Fu1n7gQ5Bx0onXCdHZ4/OBZ3nU9lT3acK
pxZNPTr1ri6qa6UbobtEd79up+6Ynr5egJ5Mb6feeb3n+hx9L/1U/W36p/VHDFgGswwkBtsM
zhg8xTVxbzwdL8fb8VFDXcNAQ6VhlWGX4YSRudE8o9VGjUYPjGnGXOMk423GbcajJgYmISZL
TepN7ppSTbmmKaY7TDtMx83MzaLN1pk1mz0x1zLnm+eb15vft2BaeFostqi2uGVJsuRaplnu
trxuhVo5WaVYVVpds0atna0l1rutu6cRp7lOk06rntZnw7Dxtsm2qbcZsOXYBtuutm22fWFn
Yhdnt8Wuw+6TvZN9un2N/T0HDYfZDqsdWh1+c7RyFDpWOt6azpzuP33F9JbpL2dYzxDP2DPj
thPLKcRpnVOb00dnF2e5c4PziIuJS4LLLpc+Lpsbxt3IveRKdPVxXeF60vWdm7Obwu2o26/u
Nu5p7ofcn8w0nymeWTNz0MPIQ+BR5dE/C5+VMGvfrH5PQ0+BZ7XnIy9jL5FXrdewt6V3qvdh
7xc+9j5yn+M+4zw33jLeWV/MN8C3yLfLT8Nvnl+F30N/I/9k/3r/0QCngCUBZwOJgUGBWwL7
+Hp8Ib+OPzrbZfay2e1BjKC5QRVBj4KtguXBrSFoyOyQrSH355jOkc5pDoVQfujW0Adh5mGL
w34MJ4WHhVeGP45wiFga0TGXNXfR3ENz30T6RJZE3ptnMU85ry1KNSo+qi5qPNo3ujS6P8Yu
ZlnM1VidWElsSxw5LiquNm5svt/87fOH4p3iC+N7F5gvyF1weaHOwvSFpxapLhIsOpZATIhO
OJTwQRAqqBaMJfITdyWOCnnCHcJnIi/RNtGI2ENcKh5O8kgqTXqS7JG8NXkkxTOlLOW5hCep
kLxMDUzdmzqeFpp2IG0yPTq9MYOSkZBxQqohTZO2Z+pn5mZ2y6xlhbL+xW6Lty8elQfJa7OQ
rAVZLQq2QqboVFoo1yoHsmdlV2a/zYnKOZarnivN7cyzytuQN5zvn//tEsIS4ZK2pYZLVy0d
WOa9rGo5sjxxedsK4xUFK4ZWBqw8uIq2Km3VT6vtV5eufr0mek1rgV7ByoLBtQFr6wtVCuWF
fevc1+1dT1gvWd+1YfqGnRs+FYmKrhTbF5cVf9go3HjlG4dvyr+Z3JS0qavEuWTPZtJm6ebe
LZ5bDpaql+aXDm4N2dq0Dd9WtO319kXbL5fNKNu7g7ZDuaO/PLi8ZafJzs07P1SkVPRU+lQ2
7tLdtWHX+G7R7ht7vPY07NXbW7z3/T7JvttVAVVN1WbVZftJ+7P3P66Jqun4lvttXa1ObXHt
xwPSA/0HIw6217nU1R3SPVRSj9Yr60cOxx++/p3vdy0NNg1VjZzG4iNwRHnk6fcJ3/ceDTra
dox7rOEH0x92HWcdL2pCmvKaRptTmvtbYlu6T8w+0dbq3nr8R9sfD5w0PFl5SvNUyWna6YLT
k2fyz4ydlZ19fi753GDborZ752PO32oPb++6EHTh0kX/i+c7vDvOXPK4dPKy2+UTV7hXmq86
X23qdOo8/pPTT8e7nLuarrlca7nuer21e2b36RueN87d9L158Rb/1tWeOT3dvfN6b/fF9/Xf
Ft1+cif9zsu72Xcn7q28T7xf9EDtQdlD3YfVP1v+3Njv3H9qwHeg89HcR/cGhYPP/pH1jw9D
BY+Zj8uGDYbrnjg+OTniP3L96fynQ89kzyaeF/6i/suuFxYvfvjV69fO0ZjRoZfyl5O/bXyl
/erA6xmv28bCxh6+yXgzMV70VvvtwXfcdx3vo98PT+R8IH8o/2j5sfVT0Kf7kxmTk/8EA5jz
/GMzLdsAAAAgY0hSTQAAeiUAAICDAAD5/wAAgOkAAHUwAADqYAAAOpgAABdvkl/FRgAAEX9J
REFUeNrsnWuQHNV1x3/3dve89qFdJK0eu0IPTGzZsZEhRqYMtmVDBQEFAsrmQ74mPPwhAVsQ
x4ntMmU7wQXITtmm+OaUDa6Qh21ABkTZxVMKCCiEhLQWyHIUgd7LStqdZ/c9+dAz0u5qZ3Z2
puexPX2qtrSqnZ7pvv3v0/f87un/KBEhiijmYuhoCKKIxBtFFJF4o4giEm8UkXijiCISbxRR
ROKNIopIvFHM6bA7+eAvWXPhHy+//FML8rmsqy3BCKji34yAKIOIYFkKEVAICo2IhTEgeFjK
RqGKr/X837UCTPFHgdigPAD/7wS7MCRojFg4kkZrB48ulH2KmJqHtoy9Zcu247t2718ViTdE
cemnP973ox/f2wPjnJWtV/xdAwK4E7ZQxZ/SsJkJr7eK/04UpgcUAKeOoZYJ+1bpNR5gUXCX
kTVpTrke7+w7zppV5+G5/+hGmTdkYVkAYxhzmv37x3FdQalqBQWeB4sXJ+jri7Fv3xieN932
CowzRdQzhzFCX5/D4qUJjh3JceJEHq3VOa/p7nYYWuaAGcdY83j3UC8jCeEP+wq8/Zom7p1C
63DODjtavEsWnwcYXFfYuvU46bR7jkAqRS5n+PznB+jtdXjppWPkct7026vZ71s+b/joR7tZ
vHQh+/af4PU3ThGLTRZhoSCsXJFk6PwFiE7ikcfKnqYru5nMwV7+/PLP0Nc/THdKIvGGLcbH
s/4sVMHSpQlyOVNl5i2Jx9DdbaMUDA4mKBSk+u1FgSovKtc1nNefArqZNy/DsqECjjNZvJ4n
LFiQBObhkUZIU8iMcfDAB3SbeZhjmnHtkXcj8YYuRkZOAwrH0Xzxi0vqmJPCVVctrXFbmTCX
ni6yrF7dy+rVveXfQwy2JBCVIu2eRPWtJabHyB3eRvL8OOO5fCTesIXfDiqTRFhPzV9bqCq2
lxmSeAZUHiXzuWRNBjwXMYsQC2w7SSGXi8QbulATM56aQTiqDlGrWYhf1SB/hZg+EAs4ijE2
2hrHspKAQWE6V7xh5aEKuw/8fR4fzzO1L18EUikL29aMjxcwpvr9EQHH0SSTFul0oQqSMXvx
nv0MUJwGS/H+wR5++W8HuPmvLmRen8v8PoVo03fHrTeOhI0/VyXesPLQu792B+BRKBieeeYw
mcxkWlAoGL7whUUsW9bNc88dZWQkj2VVJ65CwbBqVTdXXLGIF188xpEjOWxbBSoO1xWWLUux
bt18MF2gT2PQFNylYHfhKQEMqWRSbdr07f5Wj3fQ/LmqPQ8rD3XFO3NReZ7geTIp+078f+nv
1YbnyZlM7XmUOeb6YtI+KQeIISZLITsCphsxfgIxRti7972Wj3fQ/Lkq8YaVh1oIYOE4iquv
XjLttKGrywIM69YtmpUARSjuh+Gzn104iwt+NgUnRXymird/RU+3zdrL+ujtNsRj/gEV8sLz
zx9t+XgHzZ+rEm9YeajxSnWbobfXKXM2/c/u6XFqvr12dzs0Ngyi00Ca/vOSXH39fOAESB/g
YWnF0FCy5eMdNH+uSrxh5aH+rVYHgqsag9GqDat4HN0ocUCNltIOEMdxNOvXD4aOP1cl3rDy
0Edtt1hM6jpQWAlD6YZl1crv758bVSqelTfhtfaE4lhaPt5B8+fqSs2Q8tCScN2C8M67J2ua
l154YQ+OoxgeHg28KDNG+NCHekilLIaHR8+Zbhkj9PY6rFjRNUVIegr1mW685j5/tqvbCR9v
hY2HZrO+eD0Ptm8/QTrtVV2IlsZgaCiJUjavvHKifCFaBwobGEiQSlm89toIY2PuOShv5cou
VqzorpgFReD06Xw78udmTBvcUPJQpXxGbVmwfHmKfH52mbN0krRWrFiRCpwoGCMkEn4WXb48
dc64e54wMBCvaoyfeOL9tuPP9c5AqxMvbih5aGmnbVvzuc8tLlO0TJ0Hqmkz07p1ixs05/Xf
/4orFtVVR5SOv534c+1TzFmIVys7lDzUmpRxhOpAqLSIKNT+/o6juf76wbbjz03JvKUCIGw8
1HHUDEINuiCl7mxTi7CVgnnzYi0f76n8WTUj857tYQgZDy1+ngiMjuaoZJjZ1+eglJrxdZW2
BxgdzQea4WIxTU+PXePYtpY/1xuzmPOGkYf6F2bBNTz77LmFaEkgSsGGDUPEYpqnnz40qxVC
EbAsxU03DSECv/3tIYwJ5lZdKoyuvHJxFULUbTDe0/HnhmfesPLQCTnCUliWKive0u3XshTG
MGvxnv0cUEoFcvz+e1dXQO3a9UEbjLeuUPg2TLy0LQ999Bc/5pNrVgMFbBuyOXPmQyf2GjuO
xrb1pF7j9Djc+Xf/jKV8BUzqNVal3lcf5r+23YLie9XS+/rqq6o4HlJ2fA0WtmTQyi72vp4m
pnpBubz++h5+/fgPpr3oZspgpYaqIFFYEPy5KeL1r6r25KEXrbmATf/6LcLuvXDfd+4llXJq
qhUsC1at6go08wbBn5uYeduTh255RtM53gu1ZTHb1lx55ZKApRMMf26aeNuRhy4a6KMTvBe6
klKXyBonpNY9Vl+DeNuLh6bTOTrLe0FNmOYwzb8TpihiFVe4Ko1n6/hzU8Xbjjy0U7wX0vk8
iJlQsU+ZR6up+1L63UYERkZygYx3tTqpnj83RbztyUPzeUNneC/kQcX9rCtqikBLRak+k5mF
PEopwKHgemze/H4g410tjaiePzdx2tB2PLRDvBcQw949/0ciaTM4NIhSHkobH9qJhzEGrZOI
KERyKKXwTBzb9pfzp3b5tQN/bqJ4fVZ6zTVLKk4HkkkfN1133dKadiiR8I/6hhuqe2xl+6v+
ak3YvRc8cUmfcjh2aJSjR0e45C8uApM/k2wtneTF51/lT/sPcOPN67Fs4VePPcXqjw2CwPbt
j9fIn8tFZS79yM/3sG7dg+0z51VAMulUlX3KM0mC3b74+HrYvRdAker/MO+f/BMjw1tZuXIF
8xd2gxiUsslk87x3KMPipcs5+N5htI6xYGAVx44fQ+kYmzb9U9O5dBvSBgn4dfVtH9Ze43O9
Fwy5zDGy7im6e+J098QQyaKUP1KJhIVjj3PgwGGWDnZhvDyHj+xlyWA/2nLYO3ykBVy67cTb
XhHWXuOpva+2ZbPv3ReZ39/H2nXriSeSQKY4W/anWuvXX8342EnmL1wA4rFgYCEDC8/n8d/s
5vmX3mszLi3NEu/E6tYA1pSdaK6Rm6D9biWBsPYaT+19zWXz/P65Pdgantj8Pxhxcd3SozQW
Ihpbg2VZ5F1BKxfHtlGWxY4dO7nm2vUt5NKV+HPDxVua35QGq7gjJbbY5EUWowwKjZYSGgq/
90IyGefBH94eAD1pJpeuzJ+bJN5S80rp9uaeEfL11/0DH1n9Z3iFAvU5SIIomaWDpJDOZOhc
74U259Iz8OdKd4HAxCuigC5QSUTGANcv8iXBhR9eyQ/u/yat6uq6687v0LneC+3LpRWmKv7c
cPHaVpzt214lnujn459cgsJGWT08+Z+/J5vJ0MquLp8GdJb3wlzg0qLNjPzZtmJNmDbYCfYd
OMbTTz7LtTddzI03rsXG5dCRD1g2OEAru7pcz18e7iTvhTnBpYUZ+XM64zVh2oBBO2N86tKP
cOnFHwPygIVlu5w8OUYru7reerN4IB3kvTAXuLRf3ZiK/NmJx5sg3rzhyzddi0gXSmWLJz/J
zbes51vf3EQru7qefVbPIIDweS/MBS6dSedk49ceOulvI4gIu/ccKt6NDG/utDECX7n12pFa
Lf+rEu/WbW+Mbvzqj+xMZtwVMSAOiEbHLNx8oa/Y5kTrurqocu4WNu+F9uXSqWRSPfDAN/pm
xq+1W/5XJd4db+0rewXcdusNI6D6K5/Uxnd1da73QntyaRFhePfhhi4v102KW+0g6X9ep3kv
tD+X9ozhd88dbKjlv11/5mitg2ShcHZpulO8F+YCl7Ytza1/s6Y4/02THj9F//z5IB4fnBwB
Brh74w/5/gNfqtnyv37xtkVXV3v2Gld9A67Se+Hll4/PGS6dyWT5+t8/UOy5UBN6Lgo4toMo
i507d+OwoGbL/7rF2+qurjde12eu97brNQ6wYLMsuOCCrjnDpZPJOA88eHuFo/WAPEp0zZb/
AbREtrara/KJa69e4yBjsvfC3ODSlYrsICz/AxBvWLq62jnKPWDavly63HJ2kJb/Ac15W9nV
1ca9xsrvo/JHRqbsb5DeCzOJr/lcutxydpCW/wFk3tY6SHpeqSutHXuNBVF+V546M1ZC0N4L
5aLVXHq64jxIy/+AHgNqXVeX65a+P/jcXmOU5f80MTSCYEC7IBpbikMsqrg/mqC8F2ZCe63k
0uWWs4O0/K9/kaLFDpI739KU6zX2RPDIN+i2Of2tVJk4jm3jMY5liX8diYdIjExG8d7BA4F5
L8wk3omkotlceubl7Pot/wN7ALNVXV3PPJUo22v82M82s3zRIjzTnHmvUorRk6dY+YkVbPz2
X+MxgtIGjIdbMPxh90E0sZq8F5KJOBs2zI4vt5JLz5w+67f8t4POPNXhkgC7uux42V7jL19z
I9dd/ZeQyTQn8VoWBw4e5uHfPArE/BMkoHWMw+8fxSJFsv+CmrwXsjlTA19uHZeuXIAHY/kf
sHib39VVqdf4ySe3cOzgYfKFQnPmu1pz+NgRsvZpIIvCRaMR8Uh2x3jzjT2sTPTW5L1gx2J1
oKvWYMZGW/4HJt5WdXWZXPle4zUXr0Qpt6lzXuOtZHBoqAjNekFpFB4LBxay9jMxtm2tzXvh
maeH5xyXbrTlvx1Uxm1VV9drrw9zz8afkMtl8HuN7TO9xnZMIbjF25NMLjLlLO2wtOU3/Cgh
nc6SSiV8QmxK+K2UDUwVI+E3WecLOYwHSvwPExSOE2d8LE1vd5LNT72C6xUmXFa6Qh+AZueu
txvCrBvJpRtt+R/otKEVXV2333FXAOgnWSwWhbvu3MT3vruRXPYU//7Y/prQ3y23LCOVsnnk
kf89B/3tePPX3Hf/10HGJjDfEpc++2Uwzbr7N4pLQ+Mt/+2grt+wdHU1Gv3t2ikdwaV9T4a2
+06K8qVamLq6GoX+Nj/ZOVy68nFI+4h3djs0V7q6gkd/lTwwwsSlLe1Mu5wdpOX/nHeJbPDp
DR79dQiXPnnKnXY5O0jL/4BaIsPW1dU49GekM7i0E49Nu5wdpOW/HYRcwtXV1Vj0lx93O4JL
P/3UcNnl7OqXlxsuXhOy6rmx6G/Hzr3cc/dPyGUz2A4gNoUc6JiFU4ZLn2sSWbz4VBFWq7Mv
kmJGdWxd5q7n72Q6kyWVjAM2nifk8jkU6hwu7RZcbK2KXNqdcAerzKV3vf32DIV1G4i3koPk
XKyeG43+Nmy4f8L2/vBnMm6go2BZinjcmj7RiAPK5qt3/gvf++5tLSh42wiVha169vuDw/9A
Z3uHNEe8lRwk52L1PNkUJbwPdJ6d8rVDgVyb5X8Az7CFq3pWqhMe9JTArplGLi83Xrz5cHV1
2XaMjnmgM4BiurHLyw0WbyUHSSdeXVeXmlA9y5TqefIJqq6ry3WFXD47TfWcOFM9/8d/vVDs
6ip9hv+NOpDtA0+F/YFOgGzBq/vSauzycoPFW8lBci7G7betHwGvP+yNM5lMlntvfbjlBXI9
lv/R8nDI0V+5zJaMJ/n+336j5QVyPZb/kXhDjv7KZTbPg4d/9kjLC+R6LP8j8YYc/ZXLbHlP
uPSWFS0vkMstL//qv3dE4u109Fcus4nS8vNf/m601QXydMvL2rbtF17YNjrjZ4tIpNgJccdt
Xxp56OF7+qeiv5OjJ9j3znAL0J/N4NAQi4tfGebPCTwgxZFDh9i29RX6+/tYe9mnSSTPZrYS
4kuPj0/KbMdHjjOw8Hy+csd9H/z0oV+cN5fPVSTeKXHRJy7441VXXrZgrqE/Ucwqs23Z8vLx
XW/PbVIUiTeKORs6GoIoIvFGEUUk3iiiiMQbRSTeKKKIxBtFFJF4o4giEm8Uczr+fwCSD04T
rTIZAQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/26/2009 18:10'!
xpfPassword

	^ Icons
		at: #'xpfPassword'
		ifAbsentPut: [Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfPasswordContents readStream)].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/26/2009 18:11'!
xpfPasswordContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH2SURBVDjLjZNLTxNRGIaJv6ZN
WeBwkZFLQtGAC4l/wKULV+7YILeSYukEUhJoSASVuCI0hpAYDSUQCJBSoAaC0wbBUi4aWphp
O52Zlpa+nnOqCAptJ3k3M3me73LOlAAoyZfDqQdOEvyO89/vRcGZ5HeWmySFYdWHVOQN0vE5
8jrLJMFJ82hewVU4+bMfqdPxP9VBn+A4D88wP59PwFqmsH7UgeTJEMlsTuIyI5uRsDfCMcmt
AtoyhVmOu5kkHZuFsiNA3XuEi+QCdhxluL0D/SvpoO+vhIksiItNiPqqyXgfIL403gjfoTsI
L70gQBdim3VQvz2FFnwOxf8E8kYF0rIVYqcRM70Vgf/Pe/ohwsutOJdcpBpP4Mek+jPEfbWQ
VzkG+7tNcNsqt68tkcLZTIzM6YZ21IbolgHq9j1o+z04nKhHRnlH2p6A32LCvFD55fIYr960
VHgSSqCFVDJBEeugh+zw2jnpc0/5rthuRMBaioWBqrVrFylXOUpankIi0AjJY0DC3wD9oA9r
Anc2bat+n++2UkH8XHaTZfGQlg3QdlsIbIVX4KSPAv+60L+SO/PECmJiI1lYM9SQBR7b3ein
fn6kEMwEIZd5Q48sQQt1Qv/xFqt2Tp5x3B8sBmYC71h926az6njdUR6hMy8O17wqFqb5Bd2o
/0SFzIZrAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 16:01'!
xpfPencil

	^ Icons
		at: #'xpfPencil'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfPencilContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 16:21'!
xpfPencilContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAFUSURBVDjLrZM/SAJxGIZdWwuDlnCplkAE
m1zkaIiGFFpyMIwGK5KGoK2lphDKkMDg3LLUSIJsSKhIi+684CokOtTiMizCGuzEU5K3vOEgKvtB
De/2Pc8H3x8NAM1fQlx4H9M3pcOWp6TXWmM8A7j0629v1nraiAVC0IrrwATKIgs5xyG5QiE+Z4iQ
doeU2oAsnqCSO1NSTu+D9VhqRLD8nIB8F0Q2MgmJDyipCzjvYJkIfpN2UBLG8MpP4dxvQ3ZzGuyy
BQ2H+AnOOCBd9aL6soh81A5hyYSGWyCFvxUcerqI4S+CvYVOFPMHxLAq8I3qdHVY5LbBhJzEsCrw
utpRFBlUHy6wO2tEYtWAzLELPN2P03kjfj3luqDycV2F8AgefWbEnVqEHa2IznSD6BdsVDNStB0l
fh0FPoQjdx8RrAqGzC0YprSgxzsUMOY2bf37N/6Ud1Vc9yYcH50CAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:23'!
xpfScreenDisconnect

	^ Icons
		at: #'xpfScreenDisconnect'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenDisconnectContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:21'!
xpfScreenDisconnectContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMySURBVHjaYvz//z8DPrD6+EeW
X3//SP369Vf6+48/ot9+/lID4rav33/t/fztpz9AALHg07zi6AdOoMa9f/7+tvz1+y/D379/
GFgYfjOI8zEzPPrxx+Pdp+8bAQIIrwHff/7KZWP+b8nPxcTw8/c/hp+/GIFiTAwfv/5k4GBl
ZHj74ZMzQAAx4vLC7J3P2b7+/PNRUoCV4/vPnwxvPv0AGcjw9ccfBl5OZoYbD94yPHz8vhQg
gJhw2Z7qLvnr07fvfQ9efQJq+sXADnTrhy8/GT5+/sbw5dt3hndvvjD8+vj1FkAAYXhh0cG3
cn/vbar7/fs3c11aWmLahBPfP33/Uy0hyMbBy8HE8PzNDwZmJnaGLx+BBnz+9hoggOBeWHbk
HScwoJb9/vjEU5bjJTsrKyvDhQsXFhQXFye6lm+z+fP95y4ZMV5Obh5WYHj8Zrh87B7Dj8/f
5AECCGwA0FYWoI3X2FkZVRn+/2V4fu/CHxXBnyxXr15d8P379xQg5j/xzkzr948fuySk+Tg/
v/3K8OrRm9v//v3SAgggcBh8//FL6vvPP6pcbAwMzIz/GFiF1VgO32f7dYvVbj5Q85xv374d
U/2//c7vz9/c7l989O3lo5cb/vz9oX/jQPkfgAACh8GXb7+kGRj+Ag36z/D07TcGbg5GBk4h
abbfN6/sUVJSYhUTE2NYs2bNAXmWnVY3v1ppAjU+goUZQACBDfj8/bsoMyMDMLT/Aw37wfDq
/W8Gfi4WBhlFFdajlw8x6H+5x/Dz58/jGzdufAdU/g450AECCGzAx8/f1Xg4mRiAehk+ffsJ
8hLDy3e/GDhYmBk4ZYwZtp48/vvPX/0sbNENEEDMr8X82IBpeq+oABvzp68/GNiATgHqY2Bh
YmT4++8vw6P7r4Fx/r/qzNbyg9gMAAgglg+fv3/h42Ji/fvnD8PX7z8ZHj/9yPD5/VeG719+
MPwAJpzvn74e//v372RcCQ4ggFg+fPm2l+k/q8e1N58Znjx59/v31x9Vf3/9ufX3x6/Xf379
evr3359n1/eV/MFlAEAAsXz7/C3o06vf64AJxfnP9188p1cn/mIgAQAEGAAHb6YRb+SXdQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenIndicateSharedContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJISURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
DWBA8gIIgw0BKQZ5CegVRqb/EHGwCxBeAAggsAEgDhMzODgYHj64TzAWmIFeghkAEEBwA9hY
WRg6UgyAUfqfgZWVleHVy5cM3Dx84MB9//4Ng4S4BMP379+hIY/wAkAAwQzoO3Bgvz1SKhMC
4n3S0tLJIP7t27fnAmknoNg7pFS5HqQXIIAYYdGHDPr7+/OBCvysbeyc+PkFGVYsX/wdyG9o
b2/vQlcLEEAoBkyePFkUaMsrVVU1BiFhEYa/fxiBiegPAzc3J8O9uzcZTp06+XXChAk8yAYA
BBALMgeYukxkZWUZPD09wM4EGQ7CTExMDCbGegzv3r3lTk9Pd585c+ZOmB6AAMLwQlNT0xmg
K4zRcyE0Z56eNWuWGbJ6gADCGgakAIAAAwD2s2ImVN243gAAAABJRU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenIndicatedShared

	^ Icons
		at: #'xpfScreenIndicateShared'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenIndicateSharedContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenShare

	^ Icons
		at: #'xpfScreenShare'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenShareContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:38'!
xpfScreenShareContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAK4SURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
vcCA5AUQBhsCUgzyEtArr/+lMzz7Hc3AyARyGcILAAEEdgGIw8QMNovh4YP7WENeVPsng7yY
JsMnlVaGf0yr4QYABBDcADZWFoaOFANglP5nYGVlZZhxNgno1N8Mv/79AQbgHwYpIVUGTQlz
hs8/vjKU73Fj0PodAjYAIIBgBvQdOLDfHimVCf3h+6Xoqh0PjDpg6vz3FxjI/xmefXzMoCtj
zfDl13eGo99n/ddrmcIPEEBgA8LDw4uRndvf35//48+vCSDND9/eZvgNdMUfoGt+//3N8Onn
ZwYDWVuGL7+/MZ68f+QtQACxIGucPHmyKND2V6qqagxnX/4Axv8fBnE+OaDmv2CXPP/4iEGI
R4Lh3OOjDEfvHnn96w+DG0AAoRgATF0msrKyDJ6eHgwL5uQzLDzeAwyDXwxA1zAoiWgxWCi5
MZx+eIRh761dL4CanZ+1/b8GEECMsBQIA01NTWeArjBGz4UHxWYyGMnbMRy4tffpr39gzTdB
6gECCMMAXECpjvHr33/MXN///VV61fYfHtcAAQYAJ6iM87Uv3U4AAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:17'!
xpfScreenUnShare

	^ Icons
		at: #'xpfScreenUnShare'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenUnShareContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:18'!
xpfScreenUnShareContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKjSURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
DWBA8gIIgw0BKQZ5CegVRqb/EHGwCxBeAAggsAEgDhMzODgYHj64TzAWmIFeghkAEEBwA9hY
WRg6UgyAUfqfgZWVleHVy5cM3Dx84MB9//4Ng+C9QwzfDi9l+P38IcOLejEGaQ5lsAEAAQQz
oO/Agf32SKlMCIj3SUtLJ4P4TIcWnBbl+mRiFpnJyK6ozfD90i4G/sO7/+12Yc0FCCBGWPQh
g/7+/nygRj9rGzsnfn5BhrtlVv9ds6oYOe8eYGB4eoSBgV+A4Q2LPMO5XYfvAwQQC7LGyZMn
iwJtfqWqqsYgJCzC8AcYti9evGbg/vGJkUNCkYHBqwiulqVBkoH5H6MCQAChGABMXSaysrIM
np4eYK+AXAfCp8UkGb5d2MrAvSmL4ef3FwzfgGo/f2Jm+MvM8AwggDC80NTUdAboCmPkHKjx
8TKDPvNjBnnh3wwsTE8YPr/+w/DgJfPf3z/+1wEEENYwwAaORshVfH33LJ35L6P8X+b/T4G6
prvv+tMGEGAAgiZr9QKg/AwAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:01'!
xpfTakeResponsibility

	^ Icons
		at: #'xpfTakeResponsibility'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfTakeResponsibilityContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:07'!
xpfTakeResponsibilityContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABUAAAAQCAMAAADOBMQXAAAABGdBTUEAALGOfPtRkwAAACBjSFJN
AAB6JQAAgIMAAPn/AACA6AAAdTAAAOpgAAA6lwAAF2+XqZnUAAABL1BMVEUAAAD////+/v/w8/nv
8vhRcamxv9hRcqlWdq1cfrS0wtrw8/jv8vdYe7FXea5fg7legbdhhbtghbpkiL5jh71mi8Bskshv
kMFojsNul8xwmc5yms91ntR6pNt5otiApNSHrd6Gq9xzndJ6ptx2oNV5o9l4oth7p9x6pNqHr9+F
rN2DqdmBp9aGrd2IsN95msSNtOOSueiNsd2RtOCRtN6dwOqcu+H+//8ARAAAPQAEVwALYQQecBg3
ijEUawsYaxAddhMdbxYkgBoldh40hSxcrlVhslpks11mtF9qt2JsuGRvuWdyvGotiiI0lCk8ni9D
pzU8jTJ1vWx7wHKBw3lJrjpOtD9SuUN5vm9/wnWFxXqIx3yKyH+NyoGPy4SSzIaUzYma0Y+Xzov+
/v7///+4j0A3AAAAZXRSTlP/////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////ABlo0oMAAADRSURBVBjTY0gxUlfWUJFRkpbST4EDBi1DOBBHiKojgChCVJYRDkQQoqqMXGZ6
mgqK2jrykmCTnUCicozGplBgADbZwQ4oKsaoBwLh4WGhAf5+vk4OgS5WKQysEmrM3Cw84YlJ8bHR
IcFB3p7uzhYMKSmqjGwm6mEJcTFRkRE+Xh5urjaWQFE5Rl1DQ6h2O2t7W0fLFKCoGCOKmy0sU0Ci
rBIobrZMAYuCTAYDc6ZkRiGIL0CEHCNMmFEAISqGMIEdIcoqISosyM/Jy8fBygoWBQDqrkpzV06O
hgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/14/2009 10:02'!
xpfUser

	^ Icons
		at: #'xpfUser'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfUserContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/14/2009 10:02'!
xpfUserContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJ3SURBVDjLpZNtSNNRFIcNKunF
1rZWBMJqKaSiX9RP1dClsjldA42slW0q5oxZiuHrlqllLayoaJa2jbm1Lc3QUZpKFmmaTMsa
Rp+kMgjBheSmTL2//kqMBJlFHx44XM7vOfdyuH4A/P6HFQ9zo7cpa/mM6RvCrVDzaVDy6C5J
JKv6rwSnIhlFd0R0Up/GwF2KWyl01CTSkM/dQoQRzAurCjRCGnRUUE2FaoSL0HExiYVzsQwc
j6RNrSqo4W5Gh6Yc4+1qDDTkIy+GhYK4nTgdz0H2PrrHUJzs71NQn86enPn+CVN9GnzruoYR
63mMPbkC59gQzDl7pt7rc9f7FNyUhPY6Bx9gwt4E9zszhWWpdg6ZcS8j3O7zCTuEpnXB+3MN
ZkUUZu0NmHE8XsL91oSWwiiEc3MeseLrN6woYCWa/Zl8ozyQ3w3Hl2lYy0SwlCUvsVi/Gv2J
wITnYPDun2Hy6jYuEzAF1jUBCVYpO6kXo+NuGMeBAgcgfwNkvgBOPgUqXgKvP7rBFvRhE1cr
p8Vq1noFYSlacVyqGk0D86gbART9BDk9BFnPCNJbCY5aCFL1Cyhtp0RWAp74MsKSrkq9guHy
vfMTtmLc1togpZoyqYmyNoITzVTYRJCiXYBIQ3CwFqi83o3JDhX6C0M8XsGIMoQ4OyuRlq1D
dZcLkmbgGDX1iIEKNxAcbgTEOqC4ZRaJ6Ub86K7CYFEo8Qo+GBQlQyXBczLZpbloaQ9k1NUz
/kD2myBBKxRZpa5hVcQslalatoUxizxAVVrN3CW21bFj9F858Q9dnIRmDyeuybM71uxmH9BN
BB1q6zybV7H9s1Ue4PM3/gu/AEbfqfWy2twsAAAAAElFTkSuQmCC'! !

MenuMorph subclass: #XpfMultiPointMenuMorph
	instanceVariableNames: 'hand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Taskbar'!

!XpfMultiPointMenuMorph commentStamp: 'mt 12/30/2009 12:31' prior: 0!
I am a hand-aware menu morph.!

!XpfMultiPointMenuMorph class methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:32'!
entitled: aString forHand: aHand

	| instance |
	instance := self entitled: aString.
	instance hand: aHand.
	^ instance! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:37'!
addInfoText: aString withIcon: anIcon

	self
		add: aString
		target: self
		selector: nil
		enabled: false
		icon: anIcon.! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:32'!
hand

	^ hand ifNil: [hand := ActiveHand]! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:32'!
hand: aHand

	hand := aHand! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:37'!
initialize

	super initialize.
	self initializeHandInfo.! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 14:14'!
initializeHandInfo

	self
		addInfoText: 'User: ', self hand login asString
		withIcon: #xpfUser;
		addInfoText: 'Project: ', self hand project asString
		withIcon: #flagBlueIcon.! !

StandardWindow subclass: #XpfClient
	instanceVariableNames: 'sidebar mainPanel userStoryPools historyPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:18'!
defaultHeight

	^ 480! !

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:19'!
defaultWidth

	^ 640! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:42'!
font: n at: size
	
	TTCFont registry isEmpty ifTrue: [TTCFont registerAll].
	^  TTCFont familyName: n pointSize: size emphasis: 0! !

!XpfClient class methodsFor: 'initialization' stamp: 'topa 5/18/2009 15:30'!
frameForCount: count index: index

	^ (LayoutFrame new)
		leftFraction: 0; 
		rightFraction: 1; 
		topFraction: (count - index ) * (1/count); 
		bottomFraction: (count - index) + 1 * (1/ count).
! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 17:22'!
monoFont

	^ self monoFontAt: 10! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:41'!
monoFontAt: aPointSize

	^ self font: 'BitstreamVeraSansMono' at: aPointSize! !

!XpfClient class methodsFor: 'user interface' stamp: 'cs 5/27/2009 11:14'!
open
	
	[^ self openProject: XpfLoginProcessor new project]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient class methodsFor: 'user interface' stamp: 'cs 6/12/2009 16:00'!
openProject: project
	
	| instance |
	[#(model open) do: [:step |
		World displayWorldSafely.
		step = #model ifTrue: [instance := self new model: project].
		step = #open ifTrue: [instance openInWorld]] displayingProgress: 'Opening client...'.

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 17:15'!
sansFont

	^ self sansFontAt: 11! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:42'!
sansFontAt: aPointSize

	^ self font: 'BitstreamVeraSans' at: aPointSize! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 15:13'!
buttonBar

	^ self newRow: {
		self createAddIterationButton.
		self createToggleHistoryButton.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 9/8/2009 16:42'!
createAddIterationButton

	^ IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfAddIteration;
		actionSelector: #createIteration;
		setBalloonText: 'Add new iteration'! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 15:15'!
createDeleteMorph
	
	^ XpfDeleteMorph new
		bottomLeft: 4@XpfClient defaultHeight + self topLeft;
		model: self model;
		yourself! !

!XpfClient methodsFor: 'initialization' stamp: 'mig 4/15/2009 14:07'!
createFeedbackButton

	| box |

	box := self createBox
		labelGraphic: MenuIcons xpf7LikeFeedback;
		actionSelector: #doFeedback;
		setBalloonText: 'give feedback to the developers'.
	
	"retain title bar height"
	box extent: box extent x @ self boxExtent y.

	labelArea addMorph: box behind: label.
! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 4/2/2009 11:17'!
createFirstIteration

	| result |
	result := self textEntry: 'No iteration found. Choose a name for the first iteration:' title: 'Add initial iteration'. 	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> (result ifNil: ['New Iteration'])})! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 4/2/2009 11:16'!
createIteration

	| result |
	result := self textEntry: 'Choose a name for the iteration:' title: 'Add iteration'. 
	
	result ifNil: [^ self].
	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> result})! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 4/17/2009 16:24'!
createToggleHistoryButton

	^ IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfHistory;
		actionSelector: #toggleHistory;
		setBalloonText: 'Toggle visibilty of history panel'! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 16:31'!
createUserStoryAddMorph
	
	^ XpfUserStoryAddMorph new
		topRight: XpfClient defaultWidth@5 + self topLeft;
		model: (self model iterations detect: [:iter | iter isXpfFutureIteration]);
		yourself! !

!XpfClient methodsFor: 'submorphs-add/remove' stamp: 'mig 4/3/2009 11:15'!
delete

	self model repository stopUpdating.
	super delete.
! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:26'!
deselectAllIterations

	self userStoryPools copy do: [:pool |
		self userStoryPools remove: pool.
		self mainPanel removeMorph: pool scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:26'!
deselectIteration: anXpfIteration

	| pool |
	pool := self userStoryPools detect: [:morph | morph model id = anXpfIteration id] ifNone: [nil].
	pool ifNotNil: [
		self userStoryPools remove: pool.
		self mainPanel removeMorph: pool scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'feedback' stamp: 'mig 4/15/2009 14:33'!
doFeedback

	| feedback |
	feedback := UIManager default
		multiLineRequest: 'Please enter your feedback:'
		centerAt: self center
		initialAnswer: ''
		answerHeight: Display height / 3.
		
	(feedback isNil or: [feedback isEmpty]) ifTrue: [^ self].
	
	(RestSocket postDocumentFromUrl: self feedbackUrl request: '' content: feedback) isOk
		ifTrue: [self message: 'Feedback was successfully sent to the server. Thank you!!' title: 'Feedback']
		ifFalse: [self abort: 'There was a problem sending the feedback to the server.' title: 'Feedback'].! !

!XpfClient methodsFor: 'feedback' stamp: 'SR 4/15/2009 14:30'!
feedbackUrl

	^ (self model baseUri, 'feedback/mail') asUrl! !

!XpfClient methodsFor: 'menu' stamp: 'mfp 4/29/2009 14:59'!
fullScreen

	super fullScreen.
	self bounds setOrigin: self bounds origin corner: ((self bounds origin x + 1200)@self bounds corner y).! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:16'!
historyPanel

	historyPanel ifNil:
		[historyPanel := (XpfHistoryMorph forProject: self model) client: self].
	^ historyPanel! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 5/18/2009 14:47'!
initialize

	super initialize.	
	self
		addMorph: ((self newDialogPanel listDirection: #leftToRight) layoutInset: 2; cellInset: 2)
			frame: (0@0 corner: 1@1);
		extent: self class defaultWidth @ self class defaultHeight;
		userStoryPools: OrderedCollection new;
		sidebar: XpfIterationSidebarMorph new;
		createFeedbackButton.! !

!XpfClient methodsFor: 'initialization' stamp: 'mfp 5/6/2009 11:20'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: (self newColumn: {
			(self newRow: {
				(self newColumn: {self userStoryButtons. self sidebar. self buttonBar}) hResizing: #shrinkWrap; cellInset: 1.
				self mainPanel}) vResizing: #spaceFill; cellInset: 0; yourself.
			self historyPanel}).! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:10'!
mainPanel
	
	mainPanel ifNil: [
		self mainPanel: ((self newColumn: {}) layoutInset: 1; cellInset: 4).
		self mainPanel changeProportionalLayout].
	^ mainPanel! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
mainPanel: anObject

	mainPanel := anObject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:10'!
model: anXpfProject

	super model: anXpfProject.
		
	self
		title: anXpfProject title;
		initializeUserInterface.

	(self sidebar)
		addDependent: self;
		model: self model.
	self model isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:31'!
selectIteration: anXpfIteration

	| pos newPool scrollPane |
	pos := self model iterations indexOf: anXpfIteration.
	newPool := XpfUserStoryPoolMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		model: anXpfIteration.
	anXpfIteration isXpfFutureIteration ifTrue: [newPool fillStyle: Color white].
	
	scrollPane := (newPool withScrollBars)
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		borderWidth: 0.


	self userStoryPools isEmpty
		ifTrue: [
			self userStoryPools add: newPool.
			self mainPanel addMorph: scrollPane]
		ifFalse: [
			self userStoryPools do: [:pool | 
				(self model iterations indexOf: pool model) > pos ifTrue: [
					self userStoryPools add: newPool before: pool.
					self mainPanel addMorph: scrollPane inFrontOf: pool scrollPane.
					^ self updateUserStoryPools]].
			self userStoryPools add: newPool.
			self mainPanel addMorphBack: scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/1/2009 13:53'!
sidebar

	^ sidebar! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
sidebar: anXpfIterationSidebarMorph

	sidebar := anXpfIterationSidebarMorph.! !

!XpfClient methodsFor: 'menu' stamp: 'cs 4/6/2009 17:47'!
toggleHistory

	self historyPanel
		visible: self historyPanel visible not;
		disableTableLayout: self historyPanel visible not.! !

!XpfClient methodsFor: 'updating' stamp: 'mt 4/28/2009 12:48'!
update: aSymbol
	
	aSymbol = #iterationDeselectAll ifTrue: [self deselectAllIterations].
	super update: aSymbol.! !

!XpfClient methodsFor: 'updating' stamp: 'mt 4/28/2009 12:49'!
update: aSymbol with: anObject
	
	aSymbol = #iterationSelected ifTrue: [self selectIteration: anObject].
	aSymbol = #iterationDeselected ifTrue: [self deselectIteration: anObject].
	
	super update: aSymbol with: anObject.! !

!XpfClient methodsFor: 'updating' stamp: 'topa 5/18/2009 15:27'!
updateUserStoryPools

	| uspCount |
	uspCount := self userStoryPools size.
	
	(uspCount > 0) ifTrue: [
		self userStoryPools withIndexDo: [:userStoryPool :index|
			userStoryPool withScrollBars layoutFrame:
				(self class frameForCount: uspCount index: index)].
		self mainPanel addPaneSplitters].! !

!XpfClient methodsFor: 'initialization' stamp: 'mfp 5/6/2009 11:25'!
userStoryButtons

	^ self newRow: {
		self newToolSpacer hResizing: #spaceFill.
		self createUserStoryAddMorph.
		self newToolSpacer hResizing: #spaceFill.
		self createDeleteMorph.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/27/2009 17:46'!
userStoryPools

	^ userStoryPools! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/27/2009 17:46'!
userStoryPools: anObject

	userStoryPools := anObject.! !

!String methodsFor: '*xpf-client' stamp: 'mt 4/28/2009 16:39'!
withoutLineEndings

	^ self withSqueakLineEndings
		copyReplaceAll: String cr
		with: ' '
		asTokens: false! !

!String methodsFor: '*xpf-client' stamp: 'mt 4/28/2009 16:40'!
withoutLineEndingsTruncatedTo: aNumber

	^ self withoutLineEndings truncateWithElipsisTo: aNumber! !

PluggableTextMorph subclass: #XpfSaveEditingTextMorph
	instanceVariableNames: 'isBlocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfSaveEditingTextMorph methodsFor: 'updating' stamp: 'topa 4/22/2009 15:22'!
update: aSymbol

	self hasUnacceptedEdits ifFalse: [super update: aSymbol].! !

!Object methodsFor: '*xpf-client' stamp: 'topa 4/20/2009 17:19'!
isValueBarWrapper

	^ false! !

Object subclass: #SSHTunnel
	instanceVariableNames: 'process server user localPort remotePort isLocalTunnel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Rfb'!

SSHTunnel class
	instanceVariableNames: 'tunnelList'!

SSHTunnel class
	instanceVariableNames: 'tunnelList'!

!SSHTunnel class methodsFor: 'initialization' stamp: 'SR 5/6/2009 10:58'!
initialize

	super initialize.
	self tunnelList: OrderedCollection new.
	
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
! !

!SSHTunnel class methodsFor: 'initialization' stamp: 'SR 5/6/2009 11:00'!
shutDown: aboutToQuit 

	self tunnelList do: [:each |
		each process isRunning ifTrue: [each process terminate]].
	super shutDown: aboutToQuit.! !

!SSHTunnel class methodsFor: 'initialization' stamp: 'SR 5/6/2009 10:58'!
startUp: aboutToQuit 

	self tunnelList: OrderedCollection new.
	super startUp: aboutToQuit.! !

!SSHTunnel class methodsFor: 'accessing' stamp: 'SR 5/6/2009 10:54'!
tunnelList

	^ tunnelList! !

!SSHTunnel class methodsFor: 'accessing' stamp: 'SR 5/6/2009 10:54'!
tunnelList: anObject

	tunnelList := anObject! !

!SSHTunnel methodsFor: 'as yet unclassified' stamp: 'mig 4/28/2009 10:35'!
execute

	| command |
	command := self generateExecutableString , self generateOptionsString.
	self process: (OSProcess command: command).
	self waitUntilProcessIsRunning.! !

!SSHTunnel methodsFor: 'private' stamp: 'mig 4/27/2009 13:35'!
generateExecutableString

	^ OSProcess isWindows 
		ifTrue: [ 'plink_silent.exe -batch ' ]
		ifFalse: [ 'ssh -o StrictHostKeyChecking=no ' ]! !

!SSHTunnel methodsFor: 'private' stamp: 'mig 4/28/2009 10:32'!
generateOptionsString

	^ '{1}@{2} -i "{3}/{1}_{2}.{4}" {5} -N'
		format: {self user.
			self server.
			FileDirectory dirPathFor: (SmalltalkImage current imageName).
			self keyFileEnding.
			self generateTunnelOptionsString.
			}.! !

!SSHTunnel methodsFor: 'private' stamp: 'SR 4/27/2009 14:25'!
generateTunnelOptionsString

	^ (self isLocalTunnel
			ifTrue: ['-L {1}:localhost:{2}']
			ifFalse: ['-R {2}:localhost:{1}']) format: {self localPort. self remotePort}.! !

!SSHTunnel methodsFor: 'initialize-release' stamp: 'topa 9/18/2009 09:56'!
initialize

	super initialize.
	self
		server: 'xpforums.hpi.uni-potsdam.de';
		user: 'vnc';
		isLocalTunnel: false.
	self class tunnelList add: self.! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
isLocalTunnel

	^ isLocalTunnel! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
isLocalTunnel: anObject

	isLocalTunnel := anObject! !

!SSHTunnel methodsFor: 'private' stamp: 'SR 4/27/2009 13:18'!
keyFileEnding

	^ OSProcess isWindows
		ifTrue: ['ppk']
		ifFalse: ['rsa']! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
localPort

	^ localPort! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
localPort: anObject

	localPort := anObject! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:08'!
process

	^ process! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:08'!
process: anObject

	process := anObject! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
remotePort

	^ remotePort! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
remotePort: anObject

	remotePort := anObject! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
server

	^ server! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
server: anObject

	server := anObject! !

!SSHTunnel methodsFor: 'as yet unclassified' stamp: 'SR 4/27/2009 13:08'!
terminate

	self process terminate.! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
user

	^ user! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
user: anObject

	user := anObject! !

!SSHTunnel methodsFor: 'as yet unclassified' stamp: 'mig 4/28/2009 10:17'!
waitUntilProcessIsRunning

	self process ifNil: [self error: 'could not establish SSH tunnel'].
	
	[self process isNotYetRunning] whileTrue: [
			(Delay forMilliseconds: 50) wait].
	
	(Delay forMilliseconds: 100) wait.
	
	self process isComplete ifTrue: [
		self error: 'could not establish SSH tunnel'].! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'projects currentProjectIndex users currentUserIndex currentProjectCandidateIndex currentProjectDeveloperIndex reposistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/16/2009 11:29'!
newWithRepository: aRepository

	^ self new repository: aRepository! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 4/16/2009 17:20'!
addDeveloperToProject

	self currentProject developers add: 
		(self currentProjectCandidates at: self currentProjectCandidateIndex).
			
	self currentProjectCandidateIndex: 0.
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
addProject
	| newProject |
	newProject := reposistory 
				addProject: (Dictionary newFrom: {  ('title' -> 'New Project')}).
	projects := nil.
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self indexOfProject: newProject);
		changed: #hasCurrentProject! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
addUser
	| newUser |
	newUser := reposistory 
				addUser: (Dictionary newFrom: { 
								('userName' -> 'New User').
								('login' -> 'new.user@email.de').
								('password' -> nil)}).
	users := nil.
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self indexOfUser: newUser);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:50'!
allProjectCandidateNames

	^ self currentProjectCandidates collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
allProjectDeveloperNames

	^ self currentProjectDevelopers collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:20'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/6/2009 13:40'!
changePassword: aDialog

	| newPassword |
	newPassword := UITheme current 
		textEntryIn: aDialog
		text: ('Enter new password for ''{1}''' format: {self currentUserName})
		title: 'Change Password'
		entryText: ''.
				
	newPassword ifNil: [^ self].
	
	self currentUserPassword: newPassword! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:36'!
currentProject

	^ self projects at: self currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectCandidateIndex

	^ currentProjectCandidateIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:38'!
currentProjectCandidateIndex: anObject

	currentProjectCandidateIndex := anObject.
	self
		changed: #currentProjectCandidateIndex;
		changed: #hasCurrentProjectCandidateIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectCandidates

	self hasCurrentProject ifFalse: [^ #()].
	
	^ self users reject: [:user | 
		self currentProject developers anySatisfy: [:dev | dev id = user id]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectDeveloperIndex

	^ currentProjectDeveloperIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:45'!
currentProjectDeveloperIndex: anObject

	currentProjectDeveloperIndex := anObject.
	self changed: #currentProjectDeveloperIndex.
	self changed: #hasCurrentProjectDeveloperIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectDevelopers

	self hasCurrentProject ifFalse: [^ #()].
	^ self currentProject developers ! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:34'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #hasCurrentProject;
		changed: #currentProjectIndex;
		changed: #currentProjectTitle;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:22'!
currentProjectTitle

	^ self hasCurrentProject
		ifTrue: [self allProjectTitles at: self currentProjectIndex]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:50'!
currentProjectTitle: aString

	self currentProject title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 15:37'!
currentUser

	^ self users at: self currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:34'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #hasCurrentUser;
		changed: #currentUserIndex;
		changed: #currentUserName;
		changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:04'!
currentUserLogin

	^ self hasCurrentUser
		ifTrue: [self currentUser login]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 6/3/2009 15:56'!
currentUserLogin: aString

	| oldLogin |
	oldLogin := (self users at: self currentUserIndex) login.
	(self users at: self currentUserIndex) login: aString.
	(self repository isRestProxy and: [self repository login = oldLogin])
		ifTrue: [self repository login: aString].
	self changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/12/2009 12:34'!
currentUserName: aString

	self currentUser userName: aString.
	
	self flag: #temporary. projects := nil.
	
	self
		changed: #currentUserName;
		changed: #allUserNames;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:58'!
currentUserPassword: aString

	(self users at: self currentUserIndex) password: aString.
	self repository login = self currentUserLogin
		ifTrue: [self repository password: aString].
	self changed: #currentUserPassword.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 3/9/2009 15:42'!
deleteDeveloper

	self currentProject developers remove: 
		(self currentProjectDevelopers at: self currentProjectDeveloperIndex).
			
	self currentProjectDeveloperIndex: (self currentProjectDeveloperIndex > self currentProject developers size 
			ifTrue: [self currentProject developers size] 
			ifFalse: [self currentProjectDeveloperIndex]).
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:00'!
deleteProject

	self currentProject delete.
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self currentProjectIndex > self projects size 
			ifTrue: [self projects size] 
			ifFalse: [self currentProjectIndex]);
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:01'!
deleteUser

	self currentUser delete.
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self currentUserIndex > self users size 
			ifTrue: [self users size] 
			ifFalse: [self currentUserIndex]);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:35'!
hasCurrentProject

	^ self currentProjectIndex notNil and: 
		[(self currentProjectIndex > 0) & (self currentProjectIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/12/2009 10:50'!
hasCurrentProjectCandidateIndex

	^ self currentProjectCandidateIndex notNil and: 
		[(self currentProjectCandidateIndex > 0) & (self currentProjectCandidateIndex <= self currentProjectCandidates size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectCandidates

	^ self currentProjectCandidates isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:01'!
hasCurrentProjectDeveloperIndex

	^ self hasCurrentProject and:
		[self currentProjectDeveloperIndex notNil and: 
		[(self currentProjectDeveloperIndex > 0) &
		(self currentProjectDeveloperIndex <= self currentProject developers size)]]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectDevelopers

	^ self currentProjectDevelopers isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 13:49'!
hasCurrentUser

	^ self currentUserIndex notNil and: 
		[(self currentUserIndex > 0) & (self currentUserIndex <= self users size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 14:05'!
hasProjects

	^ self projects isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 14:05'!
hasUsers

	^ self users isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:30'!
indexOfProject: aProject
	"returns the index of the specified project in the displayed list of projects"

	^ self projects indexOf: (self projects detect: [:each | each id = aProject id])! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:28'!
indexOfUser: aUser
	"returns the index of the specified user in the displayed list of users"

	^ self users indexOf: (self users detect: [:each | each id = aUser id])! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 16:20'!
initialize

	super initialize.
	self
		currentProjectIndex: 0;
		currentUserIndex: 0;
		currentProjectCandidateIndex: 0;
		currentProjectDeveloperIndex: 0.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 6/3/2009 15:50'!
projects

	^ projects ifNil: 
		[projects := reposistory projects asOrderedCollection
			sortBy: [:first :second | first title < second title]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository

	^ reposistory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository: anObject

	reposistory := anObject.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 6/3/2009 16:00'!
updateUser: someEntries 

	self currentUser deferCommit: [
		someEntries	do: [:entry | entry accept]].! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 6/3/2009 15:52'!
users

	^ users ifNil: 
		[users := reposistory users asOrderedCollection
			sortBy: [:first :second | first userName < second userName]]! !

Object subclass: #XpfChangePasswordModel
	instanceVariableNames: 'newPassword newPasswordRepeat user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'bs 9/9/2009 17:30'!
accept

	(self newPassword = self newPasswordRepeat) ifTrue: [
		self user password: self newPassword.
		ActiveHand login: ActiveHand login password: self newPassword.
		(self user respondsTo: #repository) ifFalse: [^ self].
		(self user login = self user repository login)
			ifTrue: [self user repository password: self newPassword]].! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword

	^ newPassword! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword: anObject

	newPassword := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat

	^ newPasswordRepeat! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat: anObject

	newPasswordRepeat := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user

	^ user! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user: anObject

	user := anObject.! !

Object subclass: #XpfColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfColorPalette commentStamp: 'mt 9/17/2009 10:57' prior: 0!
I provide some basic color roles to be used in ProjectTalk classes. I am an abstract class.

Orderd by brightness: light, midlight, mid, middark, dark, verydark
Others: base, text!

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
base

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
dark

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
light

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
mid

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:37'!
middark

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
midlight

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:32'!
text

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:40'!
verydark

	self subclassResponsibility! !

XpfColorPalette subclass: #XpfDefaultColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
base

	^ Color white! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:40'!
dark

	^ Color r: 0.7 g: 0.7 b: 0.7! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
light

	^ Color r: 0.98 g: 0.98 b: 0.98! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:38'!
mid

	^ Color r: 0.85 g: 0.85 b: 0.85! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:39'!
middark

	^ Color r: 0.8 g: 0.8 b: 0.8! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
midlight

	^ Color r: 0.92 g: 0.92 b: 0.92! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
text

	^ Color black! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:41'!
verydark

	^ Color r: 0.6 g: 0.6 b: 0.6! !

Object subclass: #XpfCommand
	instanceVariableNames: 'icon name description target selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
description

	^ description! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
description: anObject

	description := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
icon

	^ icon! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
icon: anObject

	icon := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:10'!
name

	^ name! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
name: anObject

	name := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
selector

	^ selector! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
selector: anObject

	selector := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
target

	^ target! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
target: anObject

	target := anObject.! !

Object subclass: #XpfDeveloperChooserModel
	instanceVariableNames: 'developerList selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:58'!
developer

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self developerList at: self selectionIndex]! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'cs 4/23/2009 15:06'!
developerList

	^ developerList! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:11'!
developerList: anObject

	developerList := anObject.
	self changed: #list.
	self developerList ifNotEmpty: [self selectionIndex: 1].! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:10'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:57'!
list

	self developerList ifNil: [^ #()].
	^(self developerList collect: [:each | each userName]).! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex

	^ selectionIndex! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfDeveloperListModel
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:48'!
developers

	self project ifNil: [^ #()].
	^ ((self project developers
		sortBy: [:dev1 :dev2 | dev1 userName asLowercase <= dev2 userName asLowercase])
		reject: [:dev | dev = dev repository currentUser])
		collect: [:developer | XpfDeveloperListEntryMorph forUser: developer]! !

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:49'!
project

	^ project! !

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:58'!
project: anObject

	project := anObject.
	self changed: #developers.! !

Object subclass: #XpfHistoryEntryModel
	instanceVariableNames: 'entity entry entityType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryEntryModel methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:38'!
asMorph

	^ XpfHistoryEntryMorph forEntry: self! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity

	^ entity! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity: anObject

	entity := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType

	^ entityType! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType: anObject

	entityType := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry

	^ entry! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry: anObject

	entry := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:57'!
new

	^ (self entry newVal ifNil: [self entry newRef]) asString withoutLineEndingsTruncatedTo: 20! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:57'!
old

	^ (self entry oldVal ifNil: [self entry oldRef]) asString withoutLineEndingsTruncatedTo: 20! !

Object subclass: #XpfHistoryModel
	instanceVariableNames: 'project showProject showTasks showUserStories individualEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:16'!
enableGlobal

	^ self individualEntity isNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:13'!
enableIndividual

	^ self individualEntity notNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 13:47'!
entries
	
	| result |
	result := OrderedCollection new.
	self showProject ifTrue: [result addAll: self projectEntries].
	self showUserStories ifTrue: [result addAll: self userStoryEntries].
	self showTasks ifTrue: [result addAll: self taskEntries].
	self showIndividual ifTrue: [result addAll: self individualEntries].
	^ result reversed sortBy: [:first :second | first entry timestamp > second entry timestamp]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:31'!
entriesAsMorphs
	
	^ self entries collect: [:entry | entry asMorph]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:10'!
individualEntity

	^ individualEntity! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 13:40'!
individualEntity: entity

	self individualEntity ifNotNil: [self individualEntity removeDependent: self].
	individualEntity := entity.
	self individualEntity ifNotNil: [self individualEntity addDependent: self].
	
	self
		changed: #enableGlobal;
		changed: #enableIndividual;
		changed: #showIndividual;
		changed: #showProject;
		changed: #showTasks;
		changed: #showUserStories;
		changed: #entriesAsMorphs;
		changed: #individualTitle.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
individualEntries
	
	(individualEntity isRestProxy and: [individualEntity history isLoaded not]) ifTrue:
		[individualEntity history reloadDepth: 3].
	^ individualEntity history collect: [:each |
			XpfHistoryEntryModel new
				entity: individualEntity;
				entry: each;
				entityType: #individual]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:19'!
individualTitle

	^ self enableIndividual
		ifTrue: [self individualEntity asString]
		ifFalse: ['']! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:03'!
project

	^ project! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:34'!
project: anObject

	self project isRestProxy ifTrue: [self project repository removeDependent: self].
	self project ifNotNil: [self project removeDependent: self].
	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self project isRestProxy ifTrue: [self project repository addDependent: self].! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
projectEntries
	
	(project isRestProxy and: [project history isLoaded not]) ifTrue:
		[project history reloadDepth: 3].
	^ project history collect: [:each |
			XpfHistoryEntryModel new
				entity: project;
				entry: each;
				entityType: #project]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:10'!
showIndividual

	^ self individualEntity notNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:21'!
showIndividual: anObject

	"if the checkbox is clicked, then the individual view will be deselected"
	self
		individualEntity: nil;
		changed: #enableGlobal;
		changed: #showIndividual;
		changed: #entriesAsMorphs;
		changed: #individualTitle.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:38'!
showProject

	showProject ifNil: [showProject := false].
	^ showProject and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:49'!
showProject: anObject

	showProject := anObject.
	self showProject
		ifTrue: [self project history addDependent: self]
		ifFalse: [self project history removeDependent: self].
	self
		changed: #showProject;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/22/2009 14:45'!
showTasks

	showTasks ifNil: [showTasks := false].
	^ showTasks and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:22'!
showTasks: anObject

	showTasks := anObject.
	self
		changed: #showTasks;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/22/2009 14:45'!
showUserStories

	showUserStories ifNil: [showUserStories := false].
	^ showUserStories and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 11:17'!
showUserStories: anObject

	showUserStories := anObject.
	self showUserStories
		ifTrue: [project iterations do: [:iteration | iteration history addDependent: self]]
		ifFalse: [project iterations do: [:iteration | iteration history removeDependent: self]].

	self
		changed: #showUserStories;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:51'!
taskEntries
	
	| allTasks allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all]
		displayingProgress: 'Collecting all userstories...'.
	
	allTasks := allStories
		inject: OrderedCollection new
		into: [:all :us | all addAll: us tasks. all]
		displayingProgress: 'Collecting all tasks...'. "This may take a while if not loaded."
		
	^ allTasks
		inject: OrderedCollection new
		into: [:old :eachTask |
			(eachTask isRestProxy and: [eachTask history isLoaded not])
				ifTrue: [eachTask history reloadDepth: 3].
			old addAll: (eachTask history
				collect: [:eachEntry |
					XpfHistoryEntryModel new
					entity: eachTask;
					entry: eachEntry;
					entityType: #task]). old]
		displayingProgress: 'Collecting all userstories...'.! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/29/2009 10:49'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #historyLoaded
		ifTrue: [self changed: #entriesAsMorphs].
	aSymbol = #title ifTrue: [self changed: #individualTitle].! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/17/2009 16:22'!
update: aSymbol with: argument

	super update: aSymbol with: argument.
	aSymbol = #showHistory
		ifTrue: [self individualEntity: argument].! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
userStoryEntries
	
	| allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all].
	
	^ allStories
		inject: OrderedCollection new
		into: [:old :eachUserStory |
			(eachUserStory isRestProxy and: [eachUserStory history isLoaded not])
				ifTrue: [eachUserStory history reloadDepth: 3].
			old addAll:
				(eachUserStory history collect: [:eachEntry |
					XpfHistoryEntryModel new
					entity: eachUserStory;
					entry: eachEntry;
					entityType: #userStory]). old]
		displayingProgress: 'Collecting all userstories...'.! !

Object subclass: #XpfIterationListModel
	instanceVariableNames: 'project selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:49'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'cs 4/20/2009 17:07'!
iteration

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self project iterations reversed at: self selectionIndex]! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'cs 4/20/2009 17:07'!
list

	self project  ifNil: [^ #()].
	^ (self project iterations collect: [:each | each title]) reversed.! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:36'!
project

	^ project! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:48'!
project: anObject

	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self changed: #list.	! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex

	^ selectionIndex! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfIterationTreeModel
	instanceVariableNames: 'iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mt 4/1/2009 11:36'!
iteration

	^ iteration! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mfp 4/29/2009 17:17'!
iteration: anXpfIteration

	self iteration ifNotNil: [self iteration userStories removeDependent: self].
	iteration := anXpfIteration.
	self iteration ifNotNil: [self iteration userStories addDependent: self].! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:49'!
rootItems

	| temp |
	temp :=  self iteration userStories collect: [:us | (XpfUserStoryItemWrapper with: nil model: us)].
	temp isEmpty
		ifTrue: [^ {ListItemWrapper with: ''}]
		ifFalse: [^ temp].! !

!XpfIterationTreeModel methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 17:15'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #userStoriesLoaded
		ifTrue: [self changed: #rootItems].! !

Object subclass: #XpfLoginProcessor
	instanceVariableNames: 'connectionString repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLoginProcessor class methodsFor: 'class initialization' stamp: 'mt 12/30/2009 11:09'!
initialize

	super initialize.
	Preferences addTextPreference: #xpfServer category: #xpf default: 'http://xpforums2.hpi.uni-potsdam.de:8082/' balloonHelp: 'Server name or address for ProjectTalk'.! !

!XpfLoginProcessor class methodsFor: 'accessing' stamp: 'topa 9/30/2009 14:04'!
serverString

	^ Preferences valueOfPreference: #xpfServer! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'topa 10/29/2009 11:54'!
connectionString

	ActiveHand ensureLoginAndPasswordExistAndDo: [:login :password | |url|
		url := self class serverString asUrl.
		^ 'http://{1}:{2}@{3}:{4}/{5}' format: {login encodeForHTTP. password. url authority. url port. url fullPath}].
	^ self class serverString! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'mt 6/11/2009 14:23'!
project

	| projectChooser selectedProject |
	self user projects isEmpty ifTrue: [
		UITheme current alertIn: World text: 'You are not a member of any project.' title: 'Error'.
		XpfClientOpenError signal].
	selectedProject := (self user projects size = 1)
		ifTrue: [selectedProject := self user projects first]
		ifFalse: [
			projectChooser := XpfProjectChooser new
			passwordChangeDialog: XpfChangePasswordDialog new.		
			projectChooser passwordChangeDialog model user: self user.
			projectChooser model projects: self user projects.	
			(World openModal: projectChooser) result ].
		
	^ selectedProject ifNil: [XpfClientOpenError signal]! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'mt 12/30/2009 15:25'!
projectForHand: aHand

	^ aHand providesProject
		ifTrue: [aHand project]
		ifFalse: [self project]
! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'cs 5/26/2009 16:42'!
repository

	repository ifNil: [
		self repository: (XpfProxyRepository fromString: self connectionString)].
	^ repository! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'cs 5/26/2009 16:41'!
repository: anObject

	repository := anObject.! !

!XpfLoginProcessor methodsFor: 'reseting' stamp: 'SR 7/22/2009 11:19'!
reset

	self
		repository: nil.! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'topa 9/30/2009 14:27'!
user

	| userResponse |
	userResponse := [RestSocket get: self connectionString , '/info']
		on: RestConnectionLostError
		do: [UITheme current
				alertIn: World
				text: 'Could not connect to the server.'
				title: 'Connection failed'.
			XpfClientOpenError signal].
	userResponse isOk ifFalse: [
		userResponse isUnauthorized ifTrue: [
			UITheme current
				alertIn: World
				text: 'You are not authorized to access any resource on the server.'
				title: 'Connection failed'.
			XpfClientOpenError signal]
			ifFalse: [RestProxyRepository errorForCode: userResponse responseCode]].
	^ (self repository getObject: userResponse content)! !

Object subclass: #XpfNewUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:18'!
color

	^ 'white'! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:16'!
positionX

	^ 0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:16'!
positionY

	^ 0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:17'!
tasks

	^ #()! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:17'!
timeEstimated

	^ 0.0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:15'!
title

	^ 'Drop me into iteration'! !

Object subclass: #XpfProgressEstimationSliderModel
	instanceVariableNames: 'timeEstimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:31'!
isEnabled
	^true! !

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:36'!
timeEstimated

	^ timeEstimated! !

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:39'!
timeEstimated: anObject

	timeEstimated := anObject.
	self changed: #timeEstimated.! !

Object subclass: #XpfProjectChooserModel
	instanceVariableNames: 'projects projectsModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfProjectChooserModel methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:58'!
initialize
	
	super initialize.
	
	projects := OrderedCollection new.
	projectsModel := ListModel new.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 14:04'!
project

	^ (self projectsModel selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self projects at: self projectsModel selectionIndex]! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 11:45'!
projects
	^ projects! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'mfp 3/19/2009 11:19'!
projects: anObject

	projects := anObject.
	projectsModel list: (self projects collect: [:e | e title]).
	projectsModel list ifNotEmpty: [projectsModel selectionIndex: 1]. 
	self changed.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:58'!
projectsModel
	^ projectsModel! !

Object subclass: #XpfSmoothMorphDeleter
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-Animations'!

!XpfSmoothMorphDeleter class methodsFor: 'as yet unclassified' stamp: 'mt 11/6/2009 20:50'!
delete: aMorph

	self new
		morph: aMorph;
		deleteMorph.! !

!XpfSmoothMorphDeleter methodsFor: 'deleting' stamp: 'mt 12/1/2009 20:08'!
deleteMorph

	self morph ifNil: [^ self].
	
	[
		self morph clipSubmorphs: true.
		[self morph width > 10 and: [self morph height > 10]]
			whileTrue: [
				(Delay forMilliseconds: 20) wait.
				self morph
					expandToLeft: -5;
					expandToRight: -5;
					expandToTop: -5;
					expandToBottom: -5].
				
		self morph delete.
	] fork.! !

!XpfSmoothMorphDeleter methodsFor: 'accessing' stamp: 'mt 11/6/2009 20:44'!
morph

	^ morph! !

!XpfSmoothMorphDeleter methodsFor: 'accessing' stamp: 'mt 11/6/2009 20:44'!
morph: anObject

	morph := anObject.! !

Object subclass: #XpfSmoothMorphMover
	instanceVariableNames: 'morph threshold stopped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-Animations'!

!XpfSmoothMorphMover class methodsFor: 'as yet unclassified' stamp: 'mt 11/1/2009 12:32'!
moveMorph: aMorph toTopLeft: aPoint

	self new
		morph: aMorph;
		moveTo: aPoint.! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 11/1/2009 12:23'!
morph

	^ morph! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 11/1/2009 12:23'!
morph: anObject

	morph := anObject.! !

!XpfSmoothMorphMover methodsFor: 'moving' stamp: 'mt 12/1/2009 10:41'!
moveTo: aPoint

	self morph ifNil: [self delete. ^ self].
	self stopped: false.
		
	[
		| vector oldDist currentDist |
		oldDist := self morph topLeft dist: aPoint.
		vector := (self morph topLeft - aPoint).
		(vector x = 0 or: [vector y = 0])
			ifTrue: [vector := vector // (vector abs max: (1@1))]
			ifFalse: [vector	:= vector normalized].

		[currentDist := self morph topLeft dist: aPoint.
		self stopped not
			and: [oldDist >= currentDist
			and: [oldDist := currentDist. currentDist > self threshold]]]
			whileTrue: [
				(Delay forMilliseconds: 20) wait.
				self morph topLeft: self morph topLeft - ((self speedForDistance: currentDist) * vector)].
			
		self morph topLeft: aPoint.
		
		self morph isUserStoryMorph ifTrue: [
			self morph owner ifNotNilDo: [:iterationMorph | iterationMorph expandToSubmorphs]]
	] fork.! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 12/1/2009 10:41'!
speed

	^ 10@10! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 12/1/2009 10:44'!
speedForDistance: aNumber

	| min max |
	min := 10@10.
	max := 50@50.
"	(max - min)"
	^ 10@10! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:38'!
stopped

	^ stopped ifNil: [stopped := true]! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:38'!
stopped: anObject

	stopped := anObject.! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:34'!
threshold
	"^ <Integer>"

	^ threshold ifNil: [threshold := 10]! !

!XpfSmoothMorphMover methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:06'!
threshold: aPoint

	threshold := aPoint.! !

Object subclass: #XpfWidgetFilter
	instanceVariableNames: 'name filterBlock result nextFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

XpfWidgetFilter subclass: #XpfTaskWidgetFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskWidgetFilter methodsFor: 'results' stamp: 'cs 5/13/2009 18:43'!
morphFor: task 

	^ XpfTaskListEntryMorph for: task! !

!XpfWidgetFilter methodsFor: 'results' stamp: 'cs 5/15/2009 13:06'!
createMorphListIn: aMorph

	aMorph addMorphBack: (('-- {1} ({2}) --' format: {self name. self result size}) asText asMorph lock).
	self result do: [:each | | widgetMorph |
		widgetMorph := (self morphFor: each).
		aMorph addMorphBack: widgetMorph.
		widgetMorph addDependent: aMorph].
	self nextFilter ifNotNilDo: [:filter | filter createMorphListIn: aMorph]! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
filterBlock

	^ filterBlock! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
filterBlock: anObject

	filterBlock := anObject.! !

!XpfWidgetFilter methodsFor: 'initialization' stamp: 'cs 5/13/2009 18:08'!
initialize

	super initialize.
	self
		result: OrderedCollection new;
		filterBlock: [:a| true].! !

!XpfWidgetFilter methodsFor: 'results' stamp: 'cs 5/13/2009 18:40'!
morphFor: anObject
	
	self subclassResponsibility.! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:08'!
name

	^ name! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:08'!
name: anObject

	name := anObject.! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:06'!
nextFilter

	^ nextFilter! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:50'!
nextFilter: anObject

	self nextFilter
		ifNil: [nextFilter := anObject]
		ifNotNilDo: [:filter | filter nextFilter: anObject].! !

!XpfWidgetFilter methodsFor: 'processing' stamp: 'cs 5/13/2009 20:07'!
process: anObject

	(self filterBlock value: anObject)
		ifTrue: [self result add: anObject]
		ifFalse: [self nextFilter ifNotNilDo: [:filter | filter process: anObject]].! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
result

	^ result! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
result: anObject

	result := anObject.! !

BorderedMorph subclass: #XpfListEntryMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:21'!
defaultColor

	self subclassResponsibility! !

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
for: aXpfObject

	^self new model: aXpfObject.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:22'!
createUserInterface

	self subclassResponsibility! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:40'!
delete

	self model ifNotNil: [self model removeDependent: self].
	super delete.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 12:35'!
initialize

	super initialize.
	self
		changeTableLayout;
		layoutInset: 0;
		cellInset: 0;
		borderWidth: XpfListWidget defaultBorderWidth;
		borderColor: (Color veryVeryLightGray alpha: 0.5);
		useRoundedCorners;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: self class defaultColor.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:07'!
model

	^model! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 17:50'!
model: anXpfUserStory

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfUserStory.
	self model ifNotNil: [
		self 
			removeAllMorphs;
			createUserInterface.
		self model addDependent: self].! !

XpfListEntryMorph subclass: #XpfTaskListEntryMorph
	instanceVariableNames: 'actionsMorph titleContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListEntryMorph class methodsFor: 'contants' stamp: 'cs 5/13/2009 15:56'!
defaultColor

	^ XpfTaskMorph defaultColor! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:09'!
actionsMorph

	^ actionsMorph ifNil: [
		actionsMorph := XpfTaskWidgetActionsContent forModel: self model].! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:08'!
actionsMorph: anObject

	actionsMorph := anObject! !

!XpfTaskListEntryMorph methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:32'!
createUserInterface

	self
		addMorph: ((self theme newRowIn: self for: {
			self titleContent.
			self actionsMorph})
				cellInset: 0;
				hResizing: #shrinkWrap);
		addMorphBack: ((XpfTaskDeveloperContent forModel: self model)
			hResizing: #rigid;
			extent: 160@10);
		addMorphBack: ((XpfTaskProgressContentForWidget withModel: self model)
			hResizing: #rigid;
			extent: 160@10);			
		updateStartedBorder.! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:52'!
model: myModel

	super model: myModel.
	self
		updateColor;
		updateStartedBorder.! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:47'!
titleContent

	titleContent ifNil: [self titleContent:
		(XpfTaskTitleContent forModel: self model)].
	^ titleContent! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:47'!
titleContent: anObject

	titleContent := anObject.! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'mt 5/14/2009 13:44'!
update: aSymbol

	aSymbol = #isStarted ifTrue: [self updateStartedBorder].
	aSymbol = #isDone ifTrue: [self updateColor].
	
	(#(isDone responsibleDeveloper developers) includes: aSymbol)
		ifTrue: [self changed: #requestSorting].
	
	super update: aSymbol.! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'cs 5/13/2009 15:56'!
updateColor

	self color:
		(self model isDone 
			ifTrue: [XpfTaskMorph defaultDoneColor]
			ifFalse: [XpfTaskMorph defaultColor]).! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'SR 4/28/2009 18:38'!
updateStartedBorder

	self model isStarted 
		ifTrue: [
			self borderWidth: 2.
			self borderColor: Color red]
		ifFalse: [
			self borderWidth: 0.
			self borderColor: Color black].! !

XpfListEntryMorph subclass: #XpfUserStoryListEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 18:08'!
defaultColor

	^ Color lightYellow alpha: 0.85! !

!XpfUserStoryListEntryMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/23/2009 14:25'!
createUserInterface

	self
		addMorph: ((XpfUserStoryTitleContent forModel: self model) width: XpfListWidget defaultWidth);
		addMorphBack: (XpfUserStoryProgressEstimationSliderContent withModel: self model).! !

BorderedMorph subclass: #XpfWidget
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

XpfWidget subclass: #XpfDeveloperListWidget
	instanceVariableNames: 'shareButton devList devListModel serverTunnel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfDeveloperListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 14:29'!
defaultHeight

	^ 250! !

!XpfDeveloperListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:37'!
defaultWidth

	^ 250! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:09'!
createVncServerTunnelToHub: hubPort
	
	serverTunnel := SSHTunnel new 
				isLocalTunnel: false; 
				localPort: 5900;
				remotePort: hubPort;
				server: self model repository url authority.
	serverTunnel execute.
	
	(0 to: 10) 
		do: [:ignore | (Delay forMilliseconds: 600) wait]
		displayingProgress: 'Giving SSH connection some time...'. ! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:21'!
destroyVncServerTunnelToHub
	
	serverTunnel ifNotNil: [
		serverTunnel terminate.
		serverTunnel := nil].! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'cs 5/5/2009 10:34'!
devList

	devList ifNil: [self devList: 
		((self theme newMorphListIn: self  
		for: self devListModel
		list: #developers
		getSelected: nil
		setSelected: nil
		getEnabled: nil 
		help: 'See online status and screen share availability of co-developers' )
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		layoutInset: 2)].
	^ devList! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:01'!
devList: anObject
	devList := anObject! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:50'!
devListModel

	devListModel ifNil: [devListModel := XpfDeveloperListModel new].
	^ devListModel! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:48'!
devListModel: anObject

	devListModel := anObject.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:56'!
doShareOrUnshare

	self isSharing ifTrue: [self unshare] ifFalse: [self share]! !

!XpfDeveloperListWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 15:05'!
initializeUserInterface

	self
		addMorphBack: self devList;
		addMorphBack: self shareButton.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:48'!
isSharing

	^ RFBServer server isNil not! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:51'!
model: anXpfProject.

	super model: anXpfProject.
	self devListModel project: anXpfProject.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:18'!
registerHubPortForCurrentUser: hubPort
	
	| response userProxy |
	response := RestSocket get: self xpfServerUrl , '/info'.
	userProxy := (XpfProxyRepository fromString: self xpfServerUrl) getObject: response content.
	userProxy sharingPort: hubPort.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:14'!
requestAvailableHubPort

	| response |
	response := (RestSocket get: self xpfServerUrl, '/rfb').
	response isOk ifFalse: [self error: response content].
	^ response content asInteger.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:08'!
resetHubPortForCurrentUser

	self model repository currentUser sharingPort: nil.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:19'!
share
	
	| hubPort |
	hubPort := self requestAvailableHubPort.
	self createVncServerTunnelToHub: hubPort.
	RFBServer start: 0.
	self registerHubPortForCurrentUser: hubPort.
	self changed: #shareLabel.! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'bs 4/27/2009 17:06'!
shareButton

	shareButton ifNil: [self shareButton:
		(self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #doShareOrUnshare
			arguments: nil
			getEnabled: nil
			getLabel: #shareLabel
			help: '')].
	^ shareButton! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:01'!
shareButton: anObject
	shareButton := anObject! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:48'!
shareLabel

	^ self isSharing
		ifFalse: ['Share']
		ifTrue: ['Unshare']! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:22'!
unshare
	
	| |

	self resetHubPortForCurrentUser.
	RFBServer stop.
	self destroyVncServerTunnelToHub.
	self changed: #shareLabel.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:07'!
xpfServerUrl

	^ self model repository url asString! !

XpfWidget subclass: #XpfListWidget
	instanceVariableNames: 'iterationList elementList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListWidget class methodsFor: 'constants' stamp: 'SR 4/10/2009 19:25'!
elementListClass

	self subclassResponsibility! !

!XpfListWidget methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:17'!
elementList

	elementList ifNil: [self elementList: self class elementListClass new].
	^ elementList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
elementList: anObject

	elementList := anObject! !

!XpfListWidget methodsFor: 'initialization' stamp: 'mt 5/12/2009 17:24'!
initializeUserInterface

	self
		addMorphBack: self iterationList;
		addMorphBack: self seperator;
		addMorphBack: self elementList withScrollBars.! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mt 5/12/2009 18:09'!
iterationList

	iterationList ifNil: [
		self iterationList: (self theme
							newDropListIn: self
							for: (XpfIterationListModel new project: self model)
							list: #list
							getSelected: #selectionIndex
							setSelected: #selectionIndex:
							getEnabled: nil
							useIndex: true
							help: '').
		self iterationList
			hResizing: #rigid;
			extent: self class defaultWidth @ 20.
		self iterationList model addDependent: self.].
	^ iterationList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
iterationList: anObject

	iterationList := anObject! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 11:55'!
model: aXpfProject

	super model: aXpfProject.
	self iterationList model project: self model.
	self model iterations size > 1
		ifTrue: [self iterationList listSelectionIndex: 2]
		ifFalse: [self iterationList listSelectionIndex: 1].

	self layoutChanged.! !

!XpfListWidget methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:37'!
seperator

	^ SeparatorMorph new height: 2.! !

!XpfListWidget methodsFor: 'updating' stamp: 'cs 4/14/2009 17:29'!
update: aSymbol

	aSymbol = #selectionIndex ifTrue: [| newIteration |
		newIteration := self iterationList model iteration.
		self elementList model: newIteration].
	^ super update: aSymbol.! !

XpfListWidget subclass: #XpfTaskListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:01'!
elementListClass

	^ XpfTaskListMorph2! !

XpfListWidget subclass: #XpfUserStoryListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:30'!
defaultWidth 

	^ 200! !

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:56'!
elementListClass

	^ XpfUserStoryListMorph! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 4/27/2009 11:57'!
defaultBorderWidth

	^ 3! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 5/12/2009 17:56'!
defaultExtent

	^ self defaultWidth @ self defaultHeight! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 4/27/2009 14:29'!
defaultHeight

	^ 500! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 5/12/2009 17:58'!
defaultWidth 

	^ 180! !

!XpfWidget class methodsFor: 'instance creation' stamp: 'cs 5/27/2009 11:15'!
open
	
	[^ self openProject: XpfLoginProcessor new project]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfWidget class methodsFor: 'instance creation' stamp: 'cs 6/12/2009 16:00'!
openProject: project
		
	| instance |
	[#(model open) do: [:step |
		World displayWorldSafely.
		step = #model ifTrue: [instance := self new model: project].
		step = #open ifTrue: [instance openInHand]] displayingProgress: 'Opening widget...'.

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfWidget methodsFor: 'as yet unclassified' stamp: 'cs 4/27/2009 17:09'!
delete

	self model ifNotNil: [self model repository stopUpdating].
	^ super delete! !

!XpfWidget methodsFor: 'initialization' stamp: 'mt 5/12/2009 17:18'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 0;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.5);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		initializeUserInterface.! !

!XpfWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 12:52'!
initializeUserInterface

	self subclassResponsibility.! !

!XpfWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 11:55'!
model

	^ model! !

!XpfWidget methodsFor: 'accessing' stamp: 'SR 4/28/2009 17:16'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	anObject repository startUpdating.
	self model ifNotNil: [self model addDependent: self].! !

!Date methodsFor: '*xpf-client' stamp: 'mt 4/29/2009 11:41'!
printRelativeDate
	"Returns 'Today' or 'Yesterday' or 'MM-DD-YYYY' as String for the date."
	
	self = Date today ifTrue: [^'Today'].
	self = Date yesterday ifTrue: [^'Yesterday'].
	
	^(self printFormat: #(1 2 3 $- 1 1 2))! !

!PluggableTextFieldMorph methodsFor: '*xpf-client-override' stamp: 'SR 7/1/2009 12:47'!
getText
	"Retrieve the current model text. Set the converter to
	convert between the class of the returned object and string form."

	| newObj |
	getTextSelector ifNil: [^super getText].
	model ifNil: [^ ''].
	
	newObj := model perform: getTextSelector.
	newObj ifNil: [^Text new].
	self converter isNil
		ifTrue: [self convertTo: newObj class].
	^(self converter objectAsString: newObj) shallowCopy! !

PluggableTextFieldMorph subclass: #XpfCardEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfCardEdit methodsFor: 'as yet unclassified' stamp: 'bs 6/17/2009 11:28'!
fillStyleToUse
	^ Color transparent! !

PluggableDialogWindow subclass: #XpfDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

XpfDialog subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry userLoginEntry saveProjectButton saveUserButton projectAddButton userAddButton projectDeleteButton userDeleteButton userPasswordButton projectDeveloperList projectUserDropList projectAddDeveloperButton projectDeleteDeveloperButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 10:21'!
createProjectAddButtonFor: myModel 

	self projectAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addProject
		arguments: nil
		getEnabled: nil
		label: 'Add Project'
		help: 'Add new project').
	^ self projectAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 16:37'!
createProjectAddDeveloperButtonFor: myModel 

	self projectAddDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addDeveloperToProject
		arguments: nil
		getEnabled: #hasCurrentProjectCandidateIndex
		label: 'Add'
		help: 'Add the candidate as developer to this project.').
	^ self projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:15'!
createProjectDeleteButtonFor: myModel 

	self projectDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteProject
		arguments: nil
		getEnabled: #hasProjects
		label: 'Delete Project'
		help: 'Delete project').
	^ self projectDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:29'!
createProjectDeleteDeveloperButtonFor: myModel 

	self projectDeleteDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteDeveloper
		arguments: nil
		getEnabled: #hasCurrentProjectDeveloperIndex
		label: 'Remove'
		help: 'Remove the selected developer from the current project. The user remains in the database.').
	^ self projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:48'!
createProjectDeveloperListFor: aModel

	self projectDeveloperList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectDeveloperNames
		selected: #currentProjectDeveloperIndex
		changeSelected: #currentProjectDeveloperIndex:
		getEnabled: nil
		help: 'Shows all developers of this project.').
	^ self projectDeveloperList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:21'!
createProjectListFor: aModel

	self projectList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		getEnabled: nil
		help: 'Shows all projects.').
	^ self projectList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:20'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
		class: String
		getEnabled: #hasCurrentProject
		help: 'Enter a short descriptive title for this project.') maxLength: 100).
	^ self projectTitleEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:49'!
createProjectUserDropListFor: aModel

	self projectUserDropList: (UITheme current
		newDropListIn: self
		for: aModel
		list: #allProjectCandidateNames
		getSelected: #currentProjectCandidateIndex
		setSelected: #currentProjectCandidateIndex:
		getEnabled: #hasCurrentProjectCandidates
		useIndex: true
		help: 'All available users for this project').
	^ self projectUserDropList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:39'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButton}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Developers:'.
			self createHFiller.
			self createProjectDeleteDeveloperButtonFor: myModel}.
		self createProjectDeveloperListFor: myModel.
		self createRow: {
			self createLabel: 'Candidate:'. 
			self createProjectUserDropListFor: myModel. 
			self createProjectAddDeveloperButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createProjectListFor: myModel. 
			self createRow: {
				self createProjectAddButtonFor: myModel. 
				self createProjectDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mig 3/13/2009 16:02'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:30'!
createSaveProjectButton

	self saveProjectButton: (UITheme current 
		newButtonIn: self
		for: self projectTitleEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: #enabled
		label: 'Save'
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:35'!
createSaveUserButtonFor: myModel

	self saveUserButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #updateUser:
		arguments: {{self userNameEntry. self userLoginEntry}}
		getEnabled: #hasCurrentUser
		label: 'Save'
		help: 'Save changed user data').
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 11:00'!
createUserAddButtonFor: myModel 

	self userAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addUser
		arguments: nil
		getEnabled: nil
		label: 'Add User'
		help: 'Add new user').
	^ self userAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:05'!
createUserDeleteButtonFor: myModel 

	self userDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteUser
		arguments: nil
		getEnabled: #hasUsers
		label: 'Delete User'
		help: 'Delete User').
	^ self userDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserListFor: aModel

	self userList: (UITheme current
		newListIn: self
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		getEnabled: nil
		help: 'Shows all users.').
	^ self userList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:03'!
createUserLoginEntryFor: myModel

	self userLoginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserLogin
		set: #currentUserLogin:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter a valid email address') maxLength: 100).
	^ self userLoginEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserNameEntryFor: myModel

	self userNameEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserName
		set: #currentUserName:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter the name of the user.') maxLength: 100).
	^ self userNameEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:35'!
createUserPasswordButtonFor: myModel 

	self userPasswordButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #changePassword:
		arguments: {self}
		getEnabled: #hasCurrentUser
		label: 'Change Password...'
		help: 'Change the current password').
	^ self userPasswordButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:36'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {
			self createLabel: 'Name:'. 
			self createUserNameEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Login/E-Mail:'. 
			self createUserLoginEntryFor: myModel}.
		self createRow: {
			self createUserPasswordButtonFor: myModel.
			self createHFiller. 
			self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createUserListFor: myModel. 
			self createRow: {
				self createUserAddButtonFor: myModel. 
				self createUserDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'submorphs-add/remove' stamp: 'cs 6/3/2009 15:54'!
delete

	self model repository isRestProxy ifTrue: [
		self model repository stopUpdating].
	super delete.! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:26'!
initializeUserInterface: myModel

	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'cs 6/3/2009 15:52'!
initializeWith: aRepository 

	| myModel |
	myModel := XpfAdminToolModel newWithRepository: aRepository.
	self
		buttons: {  (self createQuitButton)};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'.
	aRepository isRestProxy ifTrue: [aRepository startUpdating].! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton
	^ projectAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton: anObject
	projectAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton
	^ projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton: anObject
	projectAddDeveloperButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton
	^ projectDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton: anObject
	projectDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:25'!
projectDeleteDeveloperButton
	
	^ projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:24'!
projectDeleteDeveloperButton: anObject

	projectDeleteDeveloperButton := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList
	^ projectDeveloperList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList: anObject
	projectDeveloperList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList
	^ projectUserDropList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList: anObject
	projectUserDropList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton
	^ userAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton: anObject
	userAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton
	^ userDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton: anObject
	userDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry
	^ userLoginEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry: anObject
	userLoginEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton
	^ userPasswordButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton: anObject
	userPasswordButton := anObject! !

XpfDialog subclass: #XpfChangePasswordDialog
	instanceVariableNames: 'okButton cancelButton oldPasswordEntry newPasswordEntry newPasswordRepeatEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:03'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Abandons your new password and closes the window'].
	^ cancelButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordEntryFor: anXpfChangePasswordModel

	self newPasswordEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPassword
		set: #newPassword:
		class: String
		getEnabled: nil
		help: 'Enter new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordRepeatEntryFor: anXpfChangePasswordModel

	self newPasswordRepeatEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPasswordRepeat
		set: #newPasswordRepeat:
		class: String
		getEnabled: nil
		help: 'Repeat new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordRepeatEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:57'!
initialize

	| myModel |
	super initialize.
	myModel := XpfChangePasswordModel new.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Change Password'.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 5/4/2009 12:57'!
initializeUserInterface: anXpfChangePasswordModel

	^ self createCol: {
		self newLabel: 'Please DO NOT use an existing password.'.
		self newLabel: 'Your credentials will be transmitted in plain text.'.
		self createRow: {
			self createLabel: 'New:'.
			self createNewPasswordEntryFor: anXpfChangePasswordModel}.
		self createRow: {
			self createLabel: 'Confirm:'.
			self createNewPasswordRepeatEntryFor: anXpfChangePasswordModel}}! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry

	^ newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry: anObject

	newPasswordEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry

	^ newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry: anObject

	newPasswordRepeatEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:47'!
ok

	self newPasswordEntry accept.
	self newPasswordRepeatEntry accept.
	self model accept.
	super ok.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:02'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Saves your new password'.
		okButton isDefault: true].
	^ okButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
okButton: anObject

	okButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
oldPasswordEntry: anObject

	oldPasswordEntry := anObject.! !

XpfDialog subclass: #XpfDeveloperChooser
	instanceVariableNames: 'okButton cancelButton developerDropList result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:09'!
for: aXpfTask

	^self new model: aXpfTask! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'user interface helper' stamp: 'SR 4/12/2009 17:36'!
createDeveloperDropList: myModel

	self developerDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self developerDropList minWidth: 200.
	^ self projectDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:02'!
developerDropList

	developerDropList ifNil: [
		self developerDropList: (UITheme current 
			newDropListIn: self
			for: XpfDeveloperChooserModel new
			list: #list
			getSelected: #selectionIndex
			setSelected: #selectionIndex:
			getEnabled: nil
			useIndex: true
			help: 'Enter developer').
		self developerDropList minWidth: 200].
	^ developerDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
developerDropList: anObject

	developerDropList := anObject.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:53'!
initialize

	| |
	super initialize.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Specify Co-Developer'.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:40'!
initializeUserInterface

	^ self createCol: {
		self createRow: {
			self createLabel: 'Developer:'.	self developerDropList}}! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'topa 4/23/2009 16:59'!
model: anXpfTask

	super model: anXpfTask.
	self developerDropList model developerList: 
		(anXpfTask userStory iteration project developers reject: [:d | d = anXpfTask responsibleDeveloper]).! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/12/2009 18:11'!
ok

	self result: self developerDropList model developer.
	
	^ super ok! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
okButton: anObject

	okButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result

	^ result! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result: anObject

	result := anObject.! !

!XpfDialog class methodsFor: 'user interface' stamp: 'mt 12/30/2009 15:53'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createCol: someElements

	^ UITheme current newColumnIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createHFiller

	^ (UITheme current newToolSpacerIn: self) hResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createHSeparator

	^ UITheme current newSeparatorIn: self! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createLabel: aString

	^ UITheme current
		newLabelIn: self
		label: aString! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createRow: someElements

	^ UITheme current newRowIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVFiller

	^ (UITheme current newToolSpacerIn: self) vResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVSeparator

	^ (UITheme current newSeparatorIn: self) hResizing: #rigid; vResizing: #spaceFill! !

!XpfDialog methodsFor: 'initialization' stamp: 'topa 3/6/2009 14:53'!
initializeUserInterface: aModel

	self subclassResponsibility.! !

XpfDialog subclass: #XpfProjectChooser
	instanceVariableNames: 'okButton cancelButton changePasswordButton projectDropList result passwordChangeDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:32'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:11'!
changePasswordButton

	changePasswordButton ifNil: [
		changePasswordButton := UITheme current 
			newButtonIn: self
			for: [self openModal: self passwordChangeDialog]
			getState: nil
			action: #value
			arguments: nil
			getEnabled: nil
			label: 'Change Password'
			help: 'Change your password'].
	^ changePasswordButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:07'!
changePasswordButton: anObject

	changePasswordButton := anObject.! !

!XpfProjectChooser methodsFor: 'user interface helper' stamp: 'SR 3/10/2009 14:01'!
createProjectDropList: myModel

	self projectDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self projectDropList minWidth: 200.
	^ self projectDropList! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'mt 3/31/2009 13:12'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfProjectChooserModel new.
	
	self
		buttons: {self okButton. self cancelButton. self changePasswordButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Specify Project'.! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:54'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Project:'.	self createProjectDropList: myModel}}! !

!XpfProjectChooser methodsFor: 'actions' stamp: 'SR 3/10/2009 14:00'!
ok

	self result: self model project.
	
	^ super ok! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Project Id'.
		okButton isDefault: true].
	^ okButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
okButton: anObject

	okButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog

	^ passwordChangeDialog! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog: anObject

	passwordChangeDialog := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList

	^ projectDropList! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList: anObject

	projectDropList := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result

	^ result! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result: anObject

	result := anObject.! !

XpfDialog subclass: #XpfTaskDeveloperDialog
	instanceVariableNames: 'okButton developerList responsibleDeveloper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList

	developerList ifNil: [
		self developerList: (self theme 
				newListIn: self
				for: XpfDeveloperChooserModel new
				list: #list
				selected: nil
				changeSelected: nil
				getEnabled: nil
				help: 'Participating developer').
		].
	^ developerList! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList: anObject

	developerList := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'cs 4/23/2009 15:09'!
initialize

	super initialize.
	self
		buttons: {self okButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Developers of this Task'.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:26'!
initializeUserInterface

	^ self createCol: {
		self createRow: {self createLabel: 'Responsible Developer:'. self responsibleDeveloper}.
		self createLabel: 'Developers:'.
		self developerList}! !

!XpfTaskDeveloperDialog methodsFor: 'as yet unclassified' stamp: 'cs 4/23/2009 15:07'!
model: aXpfTask

	super model: aXpfTask.
	self responsibleDeveloper contents: (aXpfTask responsibleDeveloper isNil
		ifTrue: ['(not set)'] 
		ifFalse: [self model responsibleDeveloper userName]).
	self developerList model developerList: aXpfTask developers.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton: anObject

	okButton := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper

	responsibleDeveloper ifNil: [
		self responsibleDeveloper: (self createLabel: '(not set)')].
	^ responsibleDeveloper! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper: anObject

	responsibleDeveloper := anObject! !

PluggableButtonMorphPlus subclass: #XpfMultiPointButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Taskbar'!

!XpfMultiPointButton commentStamp: 'mt 12/30/2009 11:59' prior: 0!
I am aware of the hand that clicked me.!

!XpfMultiPointButton methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:17'!
mouseUp: evt

	|all|
	all := allButtons copy.
	all ifNotNil: [all do: [:m |
		m showSelectionFeedback: false; changed]].
	all ifNil: [^ self].
	allButtons := nil.
	all do: [:m |
		(m containsPoint: evt cursorPoint) ifTrue: [m performActionForHand: ActiveHand]].
	self changed
! !

!XpfMultiPointButton methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:10'!
performActionForHand: aHand
	"Only allow selectors that expect one argument."

	model perform: actionSelector with: aHand.! !

!TaskbarMorph methodsFor: '*xpf-client-override' stamp: 'mt 4/20/2009 20:41'!
updateTaskButtons
	"Make buttons for the ordered tasks."
	
	|button oldButtons xpfExtension|
	(self submorphs size > 0 and: [self submorphs first isKindOf: PanelMorph])
		ifTrue: [
			xpfExtension := self submorphs first.
			oldButtons := self submorphs allButFirst]
		ifFalse: [oldButtons := self submorphs copy].

	self removeAllMorphs.
	WorldState addDeferredUIMessage: [oldButtons do: [:b | b model: nil] fixTemps]. "release dependency after event handling"
	self orderedTasks do: [:t |
		button := t taskbarButtonFor: self.
		button ifNotNil: [self addMorphBack: button]].
	
	xpfExtension ifNotNil: [self addMorphFront: xpfExtension].! !

RestPrefetchProxyRepository subclass: #XpfProxyRepository
	instanceVariableNames: 'updateProcess updateCounter currentUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:32'!
proxyCollectionClass

	^ XpfProxyCollection! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:26'!
proxyObjectClass

	^ XpfProxyObject! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 10:56'!
reloadInterval
	"reload interval in seconds"
	
	^ 10! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 6/3/2009 15:33'!
addProject: aProject 

	^ self projects addNew: aProject! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 6/3/2009 15:51'!
addUser: aUser 

	^ self users addNew: aUser! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/1/2009 16:51'!
changesUrl
	
	^ (self url asString, '/changes') asUrl! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 5/26/2009 16:40'!
currentUser

	^ currentUser! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:37'!
currentUser: anXpfUser
	
	currentUser := anXpfUser.! !

!XpfProxyRepository methodsFor: 'initialization' stamp: 'cs 5/28/2009 12:45'!
initialize

	super initialize.
	self updateCounter: 0.! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 6/3/2009 15:32'!
projects

	^ self getCollection: '/projects/'! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:55'!
pvtUpdateProcess

	^ updateProcess! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:54'!
pvtUpdateProcess: anObject

	updateProcess := anObject.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'SR 7/22/2009 22:14'!
reload
	"Sends the URIs of all loaded proxies to the server and retrieves the updates"

	| response |
	response := RestProxyObject socketClass postDocumentFromUrl: self changesUrl request: '' content: 
		(Json render: (Dictionary newFrom:
			((self cache associations
				reject: [:assoc | assoc value revision isNil])
				select: [:assoc | assoc value needsUpdate]
				thenCollect: [:assoc | assoc key -> assoc value revision]))).
	response isOk
		ifTrue: [
			(Json readFrom: (response content readStream))
				do: [:uri |
					(self cache includesKey: uri) "Check this because the cache will be modified during the iteration."
						ifTrue: [(self cache at: uri) reloadNeeded]]]
		ifFalse: [self inform: response content].! !

!XpfProxyRepository methodsFor: 'initialization' stamp: 'cs 5/28/2009 12:46'!
startUpdating
	
	self pvtUpdateProcess ifNil: [self pvtUpdateProcess: self updater fork].
	self updateCounter: self updateCounter + 1.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mt 12/8/2009 15:53'!
stopUpdating

	self updateCounter: self updateCounter - 1.
	(self updateCounter <= 0 & self pvtUpdateProcess notNil) ifTrue: [
		self pvtUpdateProcess terminate.
		self pvtUpdateProcess: nil.
		self changed: #reloadStopped].! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mt 6/2/2009 14:43'!
updateCounter

	^ updateCounter
		ifNil: [updateCounter := 0]! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:45'!
updateCounter: anObject

	updateCounter := anObject.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mt 12/8/2009 16:27'!
updater

	^ [
		[
			self reload.
			self changed: #nextReload with: self class reloadInterval.
			(Delay forSeconds: self class reloadInterval) wait
		] repeat
	]! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 6/3/2009 15:32'!
users

	^ self getCollection: '/users/'! !

PasteUpMorph subclass: #XpfIterationMorph
	instanceVariableNames: 'leftSizeGrip rightSizeGrip gridMorph titleLabel commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfIterationMorph commentStamp: 'mt 10/4/2009 14:31' prior: 0!
I provide a container for user stories. My size grips (left & right) offer resizing capabilities. I will be aware that all of my user stories will be visible at anytime. I have a grid.!

!XpfIterationMorph class methodsFor: 'examples' stamp: 'mt 9/29/2009 14:45'!
exampleIteration

	^ self new
		addMorph: (XpfDraggableCardMorph new position: 100@50);
		addMorph: (XpfDraggableCardMorph new position: 300@100);
		addMorph: (XpfDraggableCardMorph new position: 150@200);
		addMorph: (XpfDraggableCardMorph new position: 225@75)! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 19:08'!
acceptDroppingMorph: aUserStoryMorph event: evt 

	| cell |
	cell := self gridMorph calculateCell: evt hand position.	

	aUserStoryMorph formerOwnerStillUsesModel
		ifTrue: [aUserStoryMorph delete. ^ self].		

	super
		acceptDroppingMorph: aUserStoryMorph
		event: evt.

	self updatePositionFor: aUserStoryMorph at: cell
! !

!XpfIterationMorph methodsFor: 'testing' stamp: 'topa 8/24/2009 13:01'!
acceptsUserStories

	^ true! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 16:48'!
addMorph: aMorph
	"IMPORTANT: If the morph to be added has strange coordinates the result can look unexpected."

	self addMorphs: {aMorph}.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/11/2009 14:19'!
addMorphSilent: aMorph
	"Just like the normal version of this method."

	super addMorph: aMorph.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 14:47'!
addMorphs: someMorphs
	"Not so expensive like calling #addMorph: manually for each morph."
	
	someMorphs do: [:m |
		self addMorphSilent: m.
		self gridMorph fixMorphPosition: m].
	
	self
		expandToSubmorphs;
		moveDistantSubmorphsVertically.! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 11/13/2009 20:21'!
addNewUserStory: aCellIndex
	"Add a new user story to the iteration at the given point/position."

	self iteration addNewUserStory: (XpfUserStoryAddMorph emptyUserStoryAt: aCellIndex).! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 11/7/2009 11:57'!
addUserStory: anXpfUserStory

	| m |
	(self includesUserStoryAsMorph: anXpfUserStory)
		ifTrue: [^ self].
	
	self gridMorph withoutSmoothMoving: [
		m := (XpfUserStoryMorph forUserStory: anXpfUserStory).
		self addMorph: m.
		m updatePosition].! !

!XpfIterationMorph methodsFor: 'submorphs-positioning' stamp: 'mt 10/7/2009 08:43'!
comeToFront
	"Override to get the owner to front. Needed for resizing via resize grip morphs."

	super comeToFront.
	self owner ifNotNilDo: [:o |
		o comeToFront]! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 11/27/2009 11:01'!
commands
	"^ <Array with: <XpfCommand>* >"
	
	^ commands ifNil: [commands := {
		XpfCommand new name: 'New story'; target: self; selector: #createNewUserStoryAtHand; icon: #xpfAddTask.
		nil.	
		XpfCommand new name: 'Edit name'; target: self; selector: #editName; icon: #xpfPencil.
		XpfCommand new name: 'Delete'; target: self; selector: #remove; icon: #xpfDeleteIcon.

		}]! !

!XpfIterationMorph methodsFor: 'accessing-morphs' stamp: 'mt 10/28/2009 19:11'!
contextMenu
	"^ <MenuMorph>"
	
	| menu |
	menu := MenuMorph entitled: 'Iteration'.
	self commands do: [:cmd |
		cmd
			ifNil: [menu addLine]
			ifNotNil: [menu 
				add: cmd name
				target: cmd target
				selector: cmd selector
				enabled: true
				icon: cmd icon]].
	^ menu! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 19:31'!
createNewUserStoryAtHand

	self iteration ifNil: [World hands first addMorph: (XpfDraggableCardMorph new topLeft: World hands first topLeft). ^ self].

	World hands first addMorph: ((XpfUserStoryMorph forUserStory: XpfNewUserStory new)
		topLeft: World hands first topLeft).! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:00'!
drawOn: aCanvas

	aCanvas
		fillRectangle: self bounds
		color: self palette midlight.
		
	aCanvas
		line: self topLeft
		to: self bottomLeft
		color: self palette light.
		
	aCanvas
		line: self topRight - (1@0)
		to: self bottomRight - (1@0)
		color: self palette middark.! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 10/4/2009 15:11'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb

	| miniCardSize |
	miniCardSize := ((XpfUserStoryMorph defaultWidth @ XpfUserStoryMorph defaultHeight) * aFactor) asIntegerPoint max: 5@5.
	self submorphs
		reject: [:m | self supportMorphs includes: m]
		thenDo: [:morph | | pt |
			pt := ((morph center - self topLeft) * aFactor) + bb topLeft. "scale and move"
			aCanvas
				fillRectangle: (Rectangle center: pt extent: miniCardSize)
				fillStyle: (SolidFillStyle color: morph color)
				borderStyle: (SimpleBorder new color: Color black; width: 1)].
! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 11:47'!
editName

	| newName |
	self iteration ifNil: [^ self].

	newName := FillInTheBlankMorph
		request: 'Enter a new name for the iteration:'
		initialAnswer: self iteration title.
		
	newName ifNotEmpty: [self iteration title: newName]	! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 9/29/2009 11:22'!
expandToLeft: aNumber
	"OVERRIDE: Ensure to keep space for size grips and all submorphs."
	
	| delta smBounds |
	self hideSupportMorphs. "To be ignored by submorph bounds calculation."
	smBounds := self submorphs size <= self supportMorphCount
		ifTrue: []
		ifFalse: [self submorphBounds].
	
	"Keep space for both size grips minimum."
	delta := (self width - self leftSizeGrip width - self rightSizeGrip width) negated
		max: aNumber.
		
	"Always show all submorphs."
	(smBounds notNil and: [(self left - delta) > (smBounds left - self leftSizeGrip width)])
		ifTrue: [delta := self left - smBounds left + self leftSizeGrip width].
	
	delta := (self gridMorph proposeNewExtent: (self width + delta @ self height))
		x - self width.
	
	super expandToLeft: delta.
	self changed: #resizedLeft with: delta.

	"recover positions of grips"
	self showSupportMorphs.! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'topa 10/7/2009 12:07'!
expandToRight: aNumber
	"OVERRIDE: Ensure to keep space for size grips and all submorphs."
	
	| delta smBounds |
	self hideSupportMorphs. "To be ignored by submorph bounds calculation."
	smBounds := self submorphs size <= self supportMorphCount
		ifTrue: [nil]
		ifFalse: [self submorphBounds].
	
	"Keep space for both size grips minimum."
	delta := (self width - self leftSizeGrip width - self rightSizeGrip width) negated
		max: aNumber.

	"Always show all submorphs."
	(smBounds notNil and: [(self right + delta) < (smBounds right + self rightSizeGrip width)])
		ifTrue: [delta := smBounds right + self rightSizeGrip width - self right].
	
	delta := (self gridMorph proposeNewExtent: (self width + delta @ self height))
		x - self width.
	
	super expandToRight: delta.
	self changed: #resizedRight with: delta.

	"recover positions of grips"
	self showSupportMorphs.! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 8/20/2009 11:34'!
expandToSubmorphs
	"Expand me to left or right to show all submorphs and keep space for the size grips."
	
	self
		expandToLeft: 0;
		expandToRight: 0.! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 10/7/2009 08:47'!
extent: aPoint
	"Should be used by #width: and #height:. Update my grips and grid."
	
	super extent: aPoint.
	self gridMorph updateExtent.
	self updateTitle.
	
	self leftSizeGrip
		height: aPoint y;
		topLeft: self topLeft.
	self rightSizeGrip
		height: aPoint y;
		bottomRight: self bottomRight! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 10/8/2009 11:23'!
fitToSubmorphs
	"Resize me to fit my submorphs plus some space for my size grips."
	
	self
		expandToLeft: self width negated;
		expandToRight: self width negated.
		
	self width < self gridMorph hStep
		ifTrue: [self widthGrid: self gridMorph hStep]! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 9/17/2009 11:51'!
gridMorph

	gridMorph ifNil: [gridMorph := XpfUserStoryGridMorph forMorph: self].
	^ gridMorph! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 18:43'!
handleDropMorph: evt

	| cell morph |
	morph := evt contents.
	cell := self gridMorph calculateCell: evt hand position.
	
	super handleDropMorph: evt.
	
	evt wasHandled
		ifTrue: [^ self].
		
	(morph isUserStoryMorph and: [self includesUserStoryAsMorph: morph model])
		ifTrue: [			
			self updatePositionFor: (self submorphs detect: [:m |
				m isUserStoryMorph and: [m model id = morph model id]]) at: cell].! !

!XpfIterationMorph methodsFor: 'event handling' stamp: 'mt 8/27/2009 16:01'!
handleMouseLeave: evt

	self leftSizeGrip isHighlighted: false.
	self rightSizeGrip isHighlighted: false.! !

!XpfIterationMorph methodsFor: 'event handling' stamp: 'mt 9/17/2009 10:42'!
handleMouseMove: evt
	"Create a appear-on-hover effect for the size grip morphs. Ensure that these grip morphs are always on top."
	
	evt translateBy: self position negated.
	
	evt position x < self leftSizeGrip width
		ifTrue: [self leftSizeGrip isHighlighted: true. self comeToFront.]
		ifFalse: [self leftSizeGrip isHighlighted: false].

	evt position x > (self width - self rightSizeGrip width)
		ifTrue: [self rightSizeGrip isHighlighted: true. self comeToFront.]
		ifFalse: [self rightSizeGrip isHighlighted: false].! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 9/29/2009 15:04'!
heightGrid: aNumber
	"Should be used instead of #width: and #height: to regard the grid. Normally you should use #expandTo*:."
	
	self height: (self gridMorph proposeNewExtent: (0 @ aNumber)) y.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/4/2009 14:26'!
hideSupportMorphs
	"Hide morphs that are for supporting this object, e.g., size grips, a grid a.s.o."

	self leftSizeGrip hide.
	self rightSizeGrip hide.
	self gridMorph hide.
	self titleLabel hide.! !

!XpfIterationMorph methodsFor: 'testing' stamp: 'mt 11/1/2009 18:17'!
includesUserStory: userStory

	self iteration ifNil: [^ false].
	^ self iteration userStories anySatisfy: [:myStory |
		myStory id = userStory id]! !

!XpfIterationMorph methodsFor: 'testing' stamp: 'mt 11/1/2009 18:20'!
includesUserStoryAsMorph: userStory

	^ self submorphs anySatisfy: [:m |
		m isUserStoryMorph and: [m model id = userStory id]]! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 10/29/2009 10:41'!
initialize

	super initialize.
	self
		clipSubmorphs: false;
		borderWidth: 1;
		borderColor: Color black;
		color: Color lightGray;
		extent: 0 @ XpfTapeMorph tapeHeight;
		initializeSizeGrips;
		initializeGrid;
		initializeTitle;
		fitToSubmorphs.! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 9/11/2009 14:19'!
initializeGrid

	self addMorphSilent: self gridMorph.
	self gridMorph
		updateExtent;
		margin: (self leftSizeGrip width @ 0 corner: self rightSizeGrip width @ 0).! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 9/29/2009 10:17'!
initializeSizeGrips

	self
		addMorphSilent: self leftSizeGrip;
		addMorphSilent: self rightSizeGrip.

	(self leftSizeGrip)
		orientation: #toLeft;
		height: self height;
		topLeft: self topLeft;
		overlayColor: self color.
		
	(self rightSizeGrip)
		orientation: #toRight;
		height: self height;
		bottomRight: self bottomRight;
		overlayColor: self color.! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 10/4/2009 15:38'!
initializeTitle

	self addMorphSilent: self titleLabel.
	self titleLabel lock.
	self updateTitle.
! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 10/7/2009 08:51'!
iteration
	"Use this convenient accessor for more readable code."
	
	^ self model! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 8/6/2009 12:43'!
leftSizeGrip

	leftSizeGrip ifNil: [
		leftSizeGrip := XpfResizeGrip new.
		leftSizeGrip addDependent: self].
	^ leftSizeGrip! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 10/4/2009 14:32'!
model
	"Override to avoid to create a custom model on demand."
	
	^ model! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 09:57'!
model: anXpfIteration

	self model ifNotNilDo: [:mod |
		mod removeDependent: self.
		mod userStories removeDependent: self].

	model := anXpfIteration.
		
	self model ifNotNilDo: [:mod |		
		mod addDependent: self.
		mod userStories addDependent: self].
	
	self processModel.! !

!XpfIterationMorph methodsFor: 'event handling' stamp: 'mt 10/28/2009 11:43'!
mouseDown: evt
	"Do nothing for now."
	
	evt yellowButtonChanged ifTrue: [self contextMenu popUpInWorld]! !

!XpfIterationMorph methodsFor: 'submorphs-positioning' stamp: 'mt 8/20/2009 12:12'!
moveDistantSubmorphsVertically
	"Move submorphs which are not in my bounds (vertically). Horizontal fix is not necessary because of the size grip feature. See #expandToSubmorphs and #fitToSubmorphs."
	
	self submorphs do: [:m |
		m top < self top ifTrue: [m top: self top].
		m bottom > self bottom ifTrue: [m bottom: self bottom]].! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 11/6/2009 20:17'!
processModel

	self removeAllSubmorphs.

	self addMorphs:
		(self iteration userStories collect:[:us| 
			XpfUserStoryMorph forUserStory: us]).
	
	self
		fitToSubmorphs;
		updateTitle.
		
	self gridMorph smoothMoving: true.! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 18:09'!
remove

	| answer |
	self iteration ifNil: [^ self].
	
	answer := FillInTheBlankMorph
		request: 'Enter ''yes'' if you really want to remove the iteration: '.

	answer = 'yes' ifTrue: [self iteration delete].! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 10:40'!
removeAllSubmorphs

	self
		removeAllMorphsIn: (self submorphs reject: [:m | self supportMorphs includes: m]);
		fitToSubmorphs.! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 19:21'!
removeMorph

	self owner ifNotNilDo: [:releaseTape |
		releaseTape removeMorph: self]! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 10:36'!
repelsMorph: morph event: evt

	^ false! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 8/6/2009 12:43'!
rightSizeGrip

	rightSizeGrip ifNil: [
		rightSizeGrip := XpfResizeGrip new.
		rightSizeGrip addDependent: self].
	^ rightSizeGrip! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 19:13'!
showMessage: aString

	XpfOverlayMessage showAtAllHands: aString.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/4/2009 14:28'!
showSupportMorphs
	"Show morphs that are for supporting this object, e.g., size grips, a grid a.s.o."

	self gridMorph
		show;
		topLeft: self topLeft.
	self leftSizeGrip
		show;
		comeToFront;
		topLeft: self topLeft.
	self rightSizeGrip
		show;
		comeToFront;
		bottomRight: self bottomRight.
	self titleLabel
		show;
		top: self top;
		left: self left + self leftSizeGrip width.
	! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/4/2009 15:09'!
supportMorphCount

	^ self supportMorphs size! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/4/2009 15:09'!
supportMorphs

	^ {self gridMorph. self leftSizeGrip. self rightSizeGrip. self titleLabel}! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 10/4/2009 14:22'!
titleLabel

	^ titleLabel ifNil: [titleLabel := TextMorph new].! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 11/19/2009 16:30'!
update: aSymbol

	aSymbol = #title ifTrue: [
		self showMessage: 'Iteration title changed.'.
		self updateTitle].
	"aSymbol = #userStoriesLoaded ifTrue: [self updateUserStoryMorphs]."
	aSymbol = #deleted ifTrue: [
		self showMessage: 'Iteration deleted.'.
		self removeMorph].
	
	"Transcript show: self owner owner name, ' ', aSymbol; cr."! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 11/15/2009 22:33'!
update: aSymbol with: anArray
	
	aSymbol = #resized ifTrue: [		
		anArray first orientation = #toLeft "first = grip, second = number"
			ifTrue: [self expandToLeft: anArray second]
			ifFalse: [self expandToRight: anArray second]].
		
	aSymbol = #fitToSubmorphs ifTrue: [ "first = grip, second = number"
		anArray first orientation = #toLeft
			ifTrue: [self expandToLeft: self width negated]
			ifFalse: [self expandToRight: self width negated]].	
		
	aSymbol = #userStoriesAdded ifTrue: [
		self showMessage: 'Story added.'.
		self addUserStory: anArray].
	
	"Transcript show: self owner owner name, ' ', aSymbol; cr."! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 19:13'!
updatePositionFor: aUserStoryMorph at: aCellPoint

	"Model (position) update AFTER dropping."
	(self includesUserStory: aUserStoryMorph model)
		ifTrue: [aUserStoryMorph updateModelPosition: aCellPoint]
		ifFalse: [	
			aUserStoryMorph
				updateModelPosition: 0@0;
				moveTo: self iteration;
				updateModelPosition: aCellPoint].

	self gridMorph
		fixMorphPosition: aUserStoryMorph
		targetCell: aCellPoint.
		
	self submorphs do: [:m |
		(m isUserStoryMorph and: [m ~= aUserStoryMorph])
			ifTrue: [m updateModelPosition]].! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 12/1/2009 18:49'!
updateTitle

	self model
		ifNil: [self titleLabel contents: '(unnamed)']
		ifNotNil: [self titleLabel contents: self model title "self titleLabel contents: self model id asString"].
	
	self right < self titleLabel right
		ifTrue: [self titleLabel contents: '...'].! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 10/25/2009 20:30'!
updateUserStoryModelPosition
	
	self submorphs do: [:m |
		m isUserStoryMorph ifTrue: [m updateModelPosition]].! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 10/28/2009 19:35'!
updateUserStoryMorphs
	"Aggregate all stories that belong to this iteration and add missing morphs, delete the obsolete ones."

	| allStories |
	
	allStories := (self userStoryMorphs, self userStoryMorphsAtHand)
		collect: [:userStoryMorph |
			(self iteration userStories includes: userStoryMorph model)
				ifFalse: [userStoryMorph delete].
			userStoryMorph model].
				
	self iteration userStories do: [:userStory |
		(allStories includes: userStory)
			ifFalse: [self addMorph: (XpfUserStoryMorph forUserStory: userStory)]].
		
	self expandToSubmorphs.! !

!XpfIterationMorph methodsFor: 'accessing-morphs' stamp: 'mt 10/26/2009 13:46'!
userStoryMorphs

	^ self submorphs select: [:m | m isUserStoryMorph]! !

!XpfIterationMorph methodsFor: 'accessing-morphs' stamp: 'mt 10/26/2009 13:47'!
userStoryMorphsAtHand

	^ World hands 
		inject: OrderedCollection new 
		into: [:morphs :hand | 
			morphs, (hand submorphs select: [:m |
				m isUserStoryMorph and: [m model iteration = self iteration]])]! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 18:45'!
wantsDroppedMorph: aMorph event: evt

	aMorph isUserStoryMorph
		ifTrue: [
			| cell |
			cell := self gridMorph calculateCell: evt hand position.
	
			aMorph isNew
				ifTrue: [self addNewUserStory: cell.
				aMorph delete. 
				evt wasHandled: true.
				^ false].
					
			^ (self includesUserStoryAsMorph: aMorph model) not	].
		
	^ false! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 9/29/2009 15:03'!
widthGrid: aNumber
	"Should be used instead of #width: and #height: to regard the grid. Normally you should use #expandTo*:."
	
	self width: (self gridMorph proposeNewExtent: (aNumber @ 0)) x.! !

XpfIterationMorph subclass: #XpfOpenStoriesMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfOpenStoriesMorph commentStamp: 'mt 10/4/2009 16:23' prior: 0!
Just override the appearance.!

!XpfOpenStoriesMorph methodsFor: 'drawing' stamp: 'mt 10/4/2009 16:24'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb

	aCanvas
		fillRectangle: (bb translateBy: (1@0))
		color: self palette dark.
		
	super
		drawScaledOn: aCanvas
		factor: aFactor
		boundingBox: bb.
! !

PasteUpMorph subclass: #XpfTaskListMorph
	instanceVariableNames: 'updateIsLocked scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 13:21'!
acceptDroppingMorph: aMorph event: evt 

	self doWithoutUpdates: [
		(aMorph isTaskMorph and: [self model noneSatisfy: [:a | a id = aMorph model id]])
				ifTrue: [self model add: aMorph model].
		super acceptDroppingMorph: aMorph event: evt].! !

!XpfTaskListMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 14:41'!
acceptsTasks

	^ true! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mt 5/14/2009 17:34'!
createUserInterface

	submorphs ifNotNilDo: [:s |
		s do: [:m | m
			removeDependent: self;
			delete]].
	
	self model do: [:task | |taskMorph|
		taskMorph := (XpfTaskMorph forTask: task) width: self width - 2.
		taskMorph addDependent: self.
		self addMorphBack: taskMorph].

	2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"
	
	submorphs ifNotEmpty: [
		self scrollPane scrollToShow: submorphs last bounds].! !

!XpfTaskListMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/22/2009 13:42'!
doWithoutUpdates: aBlock

	self updateIsLocked: true.
	^ aBlock ensure: [self updateIsLocked: false]
	! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mt 5/14/2009 17:08'!
initialize

	super initialize.
	self
		changeTableLayout;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		color: Color transparent;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 2;
		cellInset: 2;
		extent: XpfTaskTitleContent defaultExtent + XpfTaskActionsContent defaultExtent * (1@2).! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'SR 4/18/2009 11:12'!
model

	^ model! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 17:29'!
model: anXpfTaskCollection

	self model ifNotNil: [
		self model removeDependent: self].
	model := anXpfTaskCollection.
	self model ifNotNil: [
		self createUserInterface.
		self model addDependent: self]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 16:29'!
scrollPane

	^ scrollPane ifNil: [scrollPane := GeneralScrollPane new]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 16:29'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mt 5/14/2009 17:31'!
update: anObject

	self updateIsLocked ifFalse: [
		(anObject = #tasksLoaded) | (anObject = #tasksAdded) ifTrue: [
			self createUserInterface]].
	
	anObject = #zoomIn | (anObject = #zoomOut) ifTrue: [
		2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"].
	
	super update: anObject.! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'topa 4/22/2009 13:41'!
updateIsLocked

	^ updateIsLocked ifNil: [self updateIsLocked: false. updateIsLocked]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'topa 4/22/2009 13:41'!
updateIsLocked: anObject

	updateIsLocked := anObject.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'mt 5/14/2009 16:30'!
withScrollBars

	self scrollPane
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35);
		scrollTarget: self.
	^ self scrollPane! !

PasteUpMorph subclass: #XpfUserStoryPoolMorph
	instanceVariableNames: 'userStoryAddMorph deleteMorph titleMorph scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryPoolMorph commentStamp: 'mt 10/26/2009 13:28' prior: 0!
Also known as: iteration morph!

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mig 4/17/2009 18:10'!
defaultGridSize

	^ 20@20! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'SR 4/12/2009 21:52'!
defaultMaxTime

	^ 50! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mt 3/31/2009 15:39'!
for: anXpfIteration

	^ self new model: anXpfIteration! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:51'!
acceptDroppingMorph: aUserStoryMorph event: evt 

	aUserStoryMorph hasNewUserStory 
		ifTrue: [ self acceptNewUserStory: aUserStoryMorph ]
		ifFalse: [
			(self acceptExistentUserStory: aUserStoryMorph)
				ifTrue: [super acceptDroppingMorph: aUserStoryMorph event: evt]]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mig 7/23/2009 15:22'!
acceptExistentUserStory: aUserStoryMorph 

	(self isDuplicateMorph: aUserStoryMorph)
		ifTrue: [ aUserStoryMorph delete. ^ self ].
	aUserStoryMorph position: (self gridPoint: aUserStoryMorph position).
	self positionUserStory: aUserStoryMorph model droppedMorph: aUserStoryMorph.
	(self includesUserStory: aUserStoryMorph model)
		ifTrue: [ self moveToNewIteration: aUserStoryMorph. ^ false]
		ifFalse: [^ true]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mig 7/23/2009 15:17'!
acceptNewUserStory: anUserStoryMorph 

	| userStory |
	userStory := self model addNewUserStory: XpfUserStoryAddMorph emptyUserStory.
	
	userStory ifNil: [
		anUserStoryMorph delete.
		^ self].
	
	self positionUserStory: userStory droppedMorph: anUserStoryMorph.
	anUserStoryMorph delete.! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'cs 3/10/2009 16:14'!
acceptsUserStories

	^ true! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/10/2009 09:50'!
addNewUserStoryToIteration

	| userStoryData |
	userStoryData := Dictionary newFrom: 
		{'title' -> 'Please enter content for new user story'}.
	^ self model addNewUserStory: userStoryData! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/28/2009 11:14'!
addUserStorySubmorph: userStory

	^ self addMorph: (XpfUserStoryMorph forUserStory: userStory)! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:08'!
adjustLayoutBounds
	"Adjust the receivers bounds depending on the resizing strategy imposed"
	| hFit vFit box myExtent extent |
	
	hFit := self hResizing.
	vFit := self vResizing.
	
	(hFit = #rigid and: [vFit = #rigid]) ifTrue: [^self].
	
	box := self layoutBounds.
	myExtent := box extent.
	extent := self submorphBounds corner - box origin.
	
	hFit = #growWrap ifTrue: [
		(extent x > owner owner bounds width)
			ifFalse: [hFit := #spaceFill]
			ifTrue: [hFit := #shrinkWrap]].
	
	vFit = #growWrap ifTrue: [
		(extent y > owner owner bounds height)
			ifFalse: [vFit := #spaceFill]
			ifTrue: [vFit := #shrinkWrap]].
		
	hFit == #shrinkWrap ifTrue:[myExtent := extent x @ myExtent y].
	hFit == #spaceFill ifTrue: [myExtent := owner owner bounds width @ myExtent y].
	
	vFit == #shrinkWrap ifTrue:[myExtent := myExtent x @ extent y].
	vFit == #spaceFill ifTrue: [myExtent := myExtent x @ owner owner bounds height].
	
	"Make sure we don't get smaller than minWidth/minHeight"
	myExtent x < self minWidth ifTrue:[
		myExtent := (myExtent x max: 
			(self minWidth - self bounds width + self layoutBounds width)) @ myExtent y].
	myExtent y < self minHeight ifTrue:[
		myExtent := myExtent x @ (myExtent y max:
			(self minHeight - self bounds height + self layoutBounds height))].
	self layoutBounds: (box origin extent: myExtent).! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustLeft: aMorph

	^ 0 max: ((aMorph left - self left) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustTop: aMorph

	^ 0 max: ((aMorph top - self top) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/28/2009 11:15'!
buildUserStorySubmorphs

	self model ifNotNil: [
		self model userStories do: [ :userStory| 
			self addUserStorySubmorph: userStory]].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:41'!
deleteMorph

	^ deleteMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 18:07'!
deleteMorph: aMorph

	deleteMorph := aMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'mig 7/23/2009 15:16'!
doubleClick: anEvent

	| userStory |
	userStory := self addNewUserStoryToIteration.
	userStory ifNil: [^self].
	self positionUserStory: userStory to: anEvent cursorPoint.! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:59'!
generateProgress: value with: aCharacter

	value < 0 ifTrue: [''].
	^ (String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 22:00'!
generateProgress: value with: aCharacter negWith: aNegCharacter

	^ value < 0
		ifTrue: [(String new: ((10 * (value negated)) / self class defaultMaxTime) ceiling) collect: [:e | aNegCharacter]]
		ifFalse: [(String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]].! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'mfp 4/29/2009 17:36'!
includesUserStory: userStory

	^ self model userStories noneSatisfy: [ :myStory | myStory id = userStory id ]! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'bs 7/8/2009 22:51'!
initialize

	super initialize.

	self
		borderWidth: 0;
		fillStyle: Color veryVeryLightGray;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		enableDragNDrop;
		gridModulus: self class defaultGridSize;
		griddingOnOff;
		addMorph: self titleMorph.
		
	self addMorphBack: (XpfEstimationCircleMorph nUnits: 60 segmentUnitsComputing: [
		(self submorphs select: [:m | m class = XpfUserStoryMorph]) inject: 0 into: [:sum :storyMorph | sum + storyMorph timeEstimated]]).! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'mfp 4/29/2009 17:29'!
isDuplicateMorph: aUserStoryMorph

	aUserStoryMorph formerOwner ifNotNilDo: [ :o | 
		(o submorphs anySatisfy: [ :s | s model = aUserStoryMorph model ])
		ifTrue: [ ^ true ]].
	^ false! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:51'!
model

	^ model! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:50'!
model: aXpfIteration

	self model ifNotNil: [
		self model removeDependent: self.
		self model userStories removeDependent: self].

	model := aXpfIteration.
		
	self model ifNotNil: [
		self
			removeAllMorphsIn: self userStorySubmorphs;
			buildUserStorySubmorphs;
			updateTitle.
		
		self model addDependent: self.
		self model userStories addDependent: self].
! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/9/2009 18:15'!
mouseDown: evt
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. #doubleClick:. nil. nil}
		threshold: 5.! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mig 7/23/2009 15:24'!
moveToNewIteration: aUserStoryMorph 

	| result |
	result := self model addUserStory: aUserStoryMorph model.
	aUserStoryMorph delete.
	
	result ifNil: [[self model repository reload] forkAndWait]! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mig 7/23/2009 13:30'!
positionUserStory: userStory droppedMorph: aMorph

	userStory deferCommit: [
		userStory
			positionX: (self adjustLeft: aMorph);
			positionY: (self adjustTop: aMorph)].! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mig 7/23/2009 13:30'!
positionUserStory: userStory to: aPoint

	userStory deferCommit: [
		userStory
			positionX: (aPoint x * 10000);
			positionY: (aPoint y * 10000)].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane

	^ scrollPane! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane: anObject

	scrollPane := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 4/29/2009 13:51'!
titleMorph

	titleMorph ifNil: [
		self titleMorph: '' asText asMorph.
		self titleMorph 
			beAllFont: (XpfClient sansFontAt: 18);
			color: Color darkGray;
			lock].
	^ titleMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:19'!
titleMorph: anObject

	titleMorph := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/10/2009 12:04'!
toggleShow

	self scrollPane isNil
		ifTrue: [self
			visible: self visible not;
			disableTableLayout: self visible not]
		ifFalse: [self scrollPane toggleShow].! !

!XpfUserStoryPoolMorph methodsFor: 'updating' stamp: 'mfp 4/29/2009 18:05'!
update: aSymbol

	aSymbol = #title ifTrue: [self updateTitle].
	aSymbol = #timeIdeal ifTrue: [self updateTitle].
	aSymbol = #userStories ifTrue: [self updateTitle].
	aSymbol = #userStoriesLoaded ifTrue: [
		self
			updateTitle;
			updateUserStoryMorphs].
	
	super update: aSymbol.! !

!XpfUserStoryPoolMorph methodsFor: 'updating' stamp: 'mt 10/26/2009 13:33'!
updateTitle
	"Compute and set the contents of the iteration title."

	| iterationTitle idealTime userStoriesTimeActual userStoriesTimeEstimated timeEstimated timeActual |
	iterationTitle := self model title.
	(self model timeIdeal isNil or: [self model isXpfFutureIteration]) ifTrue:
		[self titleMorph contents: ' ', iterationTitle.
		^self].
	idealTime := '(',self model timeIdeal asString,')'.
	
	userStoriesTimeActual := 0.
	userStoriesTimeEstimated := 0.
	self model userStories do: [:us |
		us timeActual ifNotNil: [userStoriesTimeActual := userStoriesTimeActual + us timeActual].
		us timeEstimated ifNotNil: [userStoriesTimeEstimated := userStoriesTimeEstimated + us timeEstimated]].
	
	timeEstimated := (self generateProgress: userStoriesTimeEstimated  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeEstimated) with: $- negWith: $#).
	timeActual := (self generateProgress: userStoriesTimeActual  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeActual) with: $- negWith: $#).
	
	self titleMorph contents: iterationTitle, idealTime, Character cr asString,timeEstimated, Character cr asString, timeActual.! !

!XpfUserStoryPoolMorph methodsFor: 'updating' stamp: 'mt 10/26/2009 13:40'!
updateUserStoryMorphs
	"Aggregate all stories that belong to this iteration and add missing morphs."

	| oldUserStories morphsAtHand |

	morphsAtHand := World hands 
		inject: OrderedCollection new 
		into: [:morphs :hand | 
			morphs, (hand submorphs select: [:m | m isUserStoryMorph and: [m model iteration = self model]])].
	
	oldUserStories := Dictionary newFrom:
		(self userStorySubmorphs, morphsAtHand
			collect: [:morph | morph model -> morph]).
	oldUserStories keys reject: [:story | self model userStories includes: story]
		thenDo: [:story | (oldUserStories at: story) delete].
	self model userStories reject: [:story | oldUserStories keys includes: story]
		thenDo: [:story | self addUserStorySubmorph: story].
! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:34'!
userStoryAddMorph

	^ userStoryAddMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:42'!
userStoryAddMorph: anObject

	userStoryAddMorph := anObject.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/2/2009 15:23'!
userStorySubmorphs

	^ self submorphs select: [:aMorph| aMorph isUserStoryMorph]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:38'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mfp 4/29/2009 14:34'!
withScrollBars

	self scrollPane ifNil: [
		self scrollPane: XpfScrollPane new.
		(self scrollPane)
			scroller addMorph: self;
			maxCellSize: 1040 @ 1450;
			borderWidth: 0.
		self extent: 960 @ 1400;
			vResizing: #rigid;
			hResizing: #rigid].
	^ self scrollPane! !

RestPrefetchProxyCollection subclass: #XpfProxyCollection
	instanceVariableNames: 'updateCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyCollection methodsFor: 'adding' stamp: 'mt 5/7/2009 10:54'!
fill: anObject

	super fill: anObject.
	self updateCounter: self updateInterval.! !

!XpfProxyCollection methodsFor: 'updating' stamp: 'mt 5/7/2009 10:51'!
needsUpdate

	| needsUpdate |
	self updateCounter: self updateCounter - 1.
	needsUpdate := self updateCounter = 0.
	self updateCounter <= 0 ifTrue: [self updateCounter: self updateInterval].
	^ needsUpdate! !

!XpfProxyCollection methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:53'!
revision

	| shortRestUri |
	self isLoaded ifFalse: [^ nil].
	shortRestUri := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | shortRestUri := shortRestUri, each]
		separatedBy: [shortRestUri := shortRestUri, '/'].
	shortRestUri ifEmpty: [^ 0].
	"I am a collection with no parent therefore I have no revision. 0 means always update"
	^ (self repository getObject: '/', shortRestUri) revision! !

!XpfProxyCollection methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:53'!
updateCounter

	^ updateCounter ifNil: [0]! !

!XpfProxyCollection methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:53'!
updateCounter: anObject

	updateCounter := anObject.! !

!XpfProxyCollection methodsFor: 'updating' stamp: 'cs 6/11/2009 14:55'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	| shortRestUri parent |
	self isLoaded ifFalse: [^ nil].
	shortRestUri := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | shortRestUri := shortRestUri, each]
		separatedBy: [shortRestUri := shortRestUri, '/'].
	shortRestUri ifEmpty: [^ 0].
	"I am a collection with no parent therefore I have no revision. 0 means never update"
	parent := self repository getObject: '/', shortRestUri.
	^ parent isLoaded ifTrue: [parent updateInterval] ifFalse: [0]! !

ImageMorph subclass: #XpfDeleteMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfDeleteMorph methodsFor: 'layout' stamp: 'SR 4/17/2009 16:37'!
acceptDroppingMorph: aMorph event: evt 

	(aMorph isUserStoryMorph or: [aMorph isTaskMorph])
		ifTrue: [aMorph model delete. aMorph delete].
! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 17:05'!
acceptsTasks

	^ true! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'topa 3/11/2009 15:46'!
acceptsUserStories

	^ true! !

!XpfDeleteMorph methodsFor: 'initialization' stamp: 'topa 3/19/2009 14:38'!
initialize

	super initialize.
	self image: TrashCanMorph initializeTrashPic.! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model

	^ model! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model: anObject

	model := anObject.! !

!XpfDeleteMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:07'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph | aMorph isTaskMorph! !

ImageMorph subclass: #XpfPluggableImageMorph
	instanceVariableNames: 'model selector formOn formOff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfPluggableImageMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 13:29'!
formOn: formOn formOff: formOff model: model getOnOffSelector: selector

	^ self new
		formOn: formOn;
		formOff: formOff;
		selector: selector;
		model: model! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:23'!
formOff

	^ formOff! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOff: anObject

	formOff := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOn

	^ formOn! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOn: anObject

	formOn := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
model

	^ model! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:28'!
model: anObject

	model ifNotNil: [model removeDependent: self].
	model := anObject.
	model ifNotNil: [
		model addDependent: self.
		self updateImage].! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
selector

	^ selector! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
selector: anObject

	selector := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:26'!
update: aSymbol

	super update: aSymbol.
	aSymbol = self selector ifTrue: [self updateImage].! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:27'!
updateImage

	(self model perform: self selector)
		ifTrue: [self image: self formOn]
		ifFalse: [self image: self formOff].! !

ImageMorph subclass: #XpfSplashScreen
	instanceVariableNames: 'title message currentMessage'
	classVariableNames: 'SplashScreen'
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-Animations'!

XpfSplashScreen class
	instanceVariableNames: 'instance'!

XpfSplashScreen class
	instanceVariableNames: 'instance'!

!XpfSplashScreen class methodsFor: 'instance creation' stamp: 'mt 12/2/2009 10:52'!
appendMessage: aString
	"If there is a splash screen visible, append another message to the current one."
	
	instance ifNotNilDo: [:inst |
		inst appendMessage: aString].! !

!XpfSplashScreen class methodsFor: 'instance creation' stamp: 'mt 12/7/2009 13:02'!
delete

	instance ifNotNilDo: [:morph | morph delete].! !

!XpfSplashScreen class methodsFor: 'as yet unclassified' stamp: 'mt 12/2/2009 09:41'!
reset
	"Resets the splash screen to a new form."
	
	SplashScreen := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self splashScreenContents readStream)! !

!XpfSplashScreen class methodsFor: 'as yet unclassified' stamp: 'mt 12/2/2009 09:38'!
reset: aForm
	"Resets the splash screen to a new form."
	
	SplashScreen := aForm! !

!XpfSplashScreen class methodsFor: 'instance creation' stamp: 'mt 12/2/2009 10:50'!
show: aTitle with: someMessages for: aUnaryBlock
	"Displays a splash screen while evaluating the given block several times with an increasing step number. Update the message according to the step."
	
	instance := self new.
	instance
		title: aTitle;
		showMessage: someMessages first;
		show.
		
	someMessages withIndexDo: [:msg :index |
		instance showMessage: msg.
		aUnaryBlock value: index].

	instance delete.
	instance := nil.! !

!XpfSplashScreen class methodsFor: 'as yet unclassified' stamp: 'mt 12/2/2009 09:43'!
splashScreenContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAAfQAAAEsCAYAAAA1u0HIAAAAGXRFWHRTb2Z0d2FyZQBBZG9i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='! !

!XpfSplashScreen methodsFor: 'actions' stamp: 'mt 12/2/2009 10:55'!
appendMessage: aString
	"Combines the current message with the given one."
	
	self
		message: self currentMessage, ' ', aString;
		comeToFront.
	
	World displayWorldSafely.! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:48'!
currentMessage

	^ currentMessage ifNil: ['']! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:47'!
currentMessage: anObject

	currentMessage := anObject.! !

!XpfSplashScreen methodsFor: 'initialization' stamp: 'mt 12/2/2009 10:11'!
initialize

	super initialize.
	
	SplashScreen ifNil: [self class reset].
	
	self
		image: SplashScreen;
		addMorph: self title;
		addMorph: self message.
		
	self title position: (260@150) + self position.
	self message position: (40@255) + self position.
	
	self title: 'Project Talk'.
	self message: 'Loading...'.! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:09'!
message

	^ message ifNil: [
		message := TextMorph new lock]! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:48'!
message: aString

	self message contents: ( aString asText
		addAttribute: (TextFontReference toFont: (StrikeFont familyName: #BitstreamVeraSans size: 18))).! !

!XpfSplashScreen methodsFor: 'actions' stamp: 'mt 12/2/2009 09:50'!
show

	self
		openInWorld;
		center: World center.! !

!XpfSplashScreen methodsFor: 'actions' stamp: 'mt 12/2/2009 10:50'!
showMessage: aString

	self
		currentMessage: aString;
		message: aString;
		comeToFront.
	
	World displayWorldSafely.
! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:05'!
title

	^ title ifNil: [
		title := TextMorph new lock]! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:07'!
title: aString

	self title contents: ( aString asText
		addAttribute: (TextFontReference toFont: (StrikeFont familyName: #BitstreamVeraSans size: 36));
		addAttribute: TextEmphasis bold;
		addAttribute: (TextColor color: self palette verydark))! !

ImageMorph subclass: #XpfUserStoryAddMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph commentStamp: 'topa 3/9/2009 15:16' prior: 0!
I am a Morph that should behave somehow like a Button, yet are embeddable into
a PasteUpMorph.!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mfp 4/28/2009 10:46'!
emptyUserStory

	^ Dictionary newFrom:	{'title' -> 'Please enter content for new user story'}! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mt 11/7/2009 11:45'!
emptyUserStoryAt: aPoint

	^ Dictionary newFrom: {
		'title' -> 'Please enter content for new user story'.
		'position' -> aPoint}.! !

!XpfUserStoryAddMorph class methodsFor: 'initialize-release' stamp: 'cs 3/11/2009 17:57'!
forProjects: anXpfProject

	^ self new model: anXpfProject! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:53'!
icon

	^ icon ifNil: [icon := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self iconContent readStream) ]! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:41'!
icon: anIcon

	icon := anIcon.! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:39'!
iconContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAFIAAAA2CAYAAABUSc7XAAAAGXRFWHRTb2Z0d2FyZQBBZG9i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'! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'topa 3/11/2009 14:00'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryAddMorph methodsFor: 'initialization' stamp: 'topa 4/20/2009 17:57'!
initialize

	super initialize.
	self
		image: self class icon.! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model

	^ model! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model: anObject

	model := anObject.! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
mouseDown: evt
	
	^ self performAction openInHand! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'mt 4/28/2009 19:20'!
performAction
	"for Button behavior"

	^ XpfUserStoryMorph forUserStory: XpfNewUserStory new! !

MorphicModel subclass: #XpfDraggableCardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfDraggableCardMorph commentStamp: 'mt 9/11/2009 11:20' prior: 0!
This is just a draggable morph that has the dimensions of a user story card. It may become obsolete and is only for development issues. (grid)!

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 12/1/2009 19:19'!
detectAndShowOcclusions! !

!XpfDraggableCardMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 11:04'!
handlesMouseDown: evt

	^ true! !

!XpfDraggableCardMorph methodsFor: 'initialization' stamp: 'mt 9/11/2009 15:09'!
initialize

	super initialize.
	self
		extent: XpfUserStoryMorph defaultWidth @ XpfUserStoryMorph defaultHeight;
		color: Color white;
		borderWidth: 1;
		borderColor: Color red;
		enableDragNDrop.! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 10/7/2009 10:13'!
isNew

	^ false! !

!XpfDraggableCardMorph methodsFor: 'dropping/grabbing' stamp: 'mt 9/11/2009 11:09'!
isUserStoryMorph

	^ true! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 10/24/2009 15:27'!
model

	^ model ifNil: [model := XpfUserStoryModel new positionX: {-5. -4. -3. -2. -1. 0. 1. 2. 3. 4} atRandom; positionY: 5 atRandom]! !

!XpfDraggableCardMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 11:05'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. nil. nil. #startDrag:}
		threshold: 5.
	
	self comeToFront.! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 10/30/2009 12:37'!
moveTo: aTarget

	"Ignored."! !

!XpfDraggableCardMorph methodsFor: 'dropping/grabbing' stamp: 'mt 9/11/2009 11:05'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 11/1/2009 17:12'!
updateModelPosition

	self owner ifNotNilDo: [:iterationMorph |
		| cell |
		cell := iterationMorph gridMorph calculateCell: self topLeft.
		self model
			removeDependent: self;
			positionX: cell x;
			positionY: cell y;
			addDependent: self].! !

!XpfDraggableCardMorph methodsFor: 'dropping/grabbing' stamp: 'mt 9/11/2009 11:09'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

MorphicModel subclass: #XpfTapeMorph
	instanceVariableNames: 'sortedSubmorphs name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfTapeMorph commentStamp: 'mt 10/4/2009 14:16' prior: 0!
I store several morphs and maintain their position. I should be embedded into a scroll pane that recognized my change requests.

Use "MorphicModel" as base class to provide basic model handling.!

XpfTapeMorph subclass: #XpfFixedEndTapeMorph
	instanceVariableNames: 'fixedEndMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfFixedEndTapeMorph commentStamp: 'mt 10/4/2009 13:56' prior: 0!
No matter which morphs you add to me, I will ensure that a special fixed morph is appended at the end.!

!XpfFixedEndTapeMorph class methodsFor: 'constants' stamp: 'mt 10/4/2009 13:57'!
fixedEndClass

	^ Morph! !

!XpfFixedEndTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/4/2009 14:00'!
addMorphs: someMorphs.
	"OVERRIDE: Be sure that the release separator is the last element."

	self fixedEndMorph removeDependent: self.
	self sortedSubmorphs remove: self fixedEndMorph ifAbsent: [].
	self
		expandToRight: self fixedEndMorph width negated;
		changed: #resizedRight with: self fixedEndMorph width negated.
	
	super addMorphs: someMorphs, {self fixedEndMorph}.! !

!XpfFixedEndTapeMorph methodsFor: 'accessing' stamp: 'mt 10/8/2009 09:21'!
contentSubmorphs

	^ self sortedSubmorphs select: [:m | m ~= self fixedEndMorph]! !

!XpfFixedEndTapeMorph methodsFor: 'accessing' stamp: 'mt 10/4/2009 13:58'!
fixedEndMorph

	^ fixedEndMorph ifNil: [fixedEndMorph := self class fixedEndClass new]! !

!XpfFixedEndTapeMorph methodsFor: 'accessing' stamp: 'mt 10/4/2009 13:56'!
fixedEndMorph: anObject

	fixedEndMorph := anObject.! !

!XpfFixedEndTapeMorph methodsFor: 'initialization' stamp: 'mt 10/4/2009 14:01'!
initialize

	super initialize.	
	self
		color: Color transparent;
		initializeFixedEndMorph.! !

!XpfFixedEndTapeMorph methodsFor: 'initialization' stamp: 'mt 10/4/2009 14:01'!
initializeFixedEndMorph
	"This is a little bit tricky due to re-implementation of #addMorphs: here."

	self addMorphs: {}.
	self expandToRight: self fixedEndMorph width.! !

!XpfFixedEndTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 11:01'!
removeAllSubmorphs
	"Overridden to ignore the fixed-end-morph."

	self removeMorphs: self contentSubmorphs.! !

XpfFixedEndTapeMorph subclass: #XpfProjectTapeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfProjectTapeMorph class methodsFor: 'examples' stamp: 'mt 10/4/2009 15:14'!
exampleTape
	"Create an example tape and put it in a scrollable area."
	
	^ (self new
		addMorphs: {
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape})! !

!XpfProjectTapeMorph class methodsFor: 'constants' stamp: 'mt 10/4/2009 16:22'!
fixedEndClass

	^ XpfOpenStoriesMorph! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 10/4/2009 14:07'!
openStoriesMorph

	^ self fixedEndMorph! !

!XpfProjectTapeMorph methodsFor: 'accessing-model' stamp: 'mt 12/2/2009 10:58'!
processModel

	super processModel.
	
	XpfSplashScreen appendMessage: 'Releases...'.

	self addMorph: (XpfReleaseTapeMorph new model: self project).

	XpfSplashScreen appendMessage: 'Open stories...'.
	
	(self openStoriesMorph)
		model: self project iterations last;
		fitToSubmorphs.! !

!XpfProjectTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 10:06'!
project

	^ self model! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:09'!
toggleShowGrid
	"Toggle the visibility of all grids in all iteration morphs in this project tape."
	
	self openStoriesMorph gridMorph toggleShowGrid.
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph gridMorph toggleShowGrid]]! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:23'!
toggleShowHoverEffect
	"Toggle the hover effect of all grids in all iteration morphs in this project tape."
	
	self openStoriesMorph gridMorph toggleShowHoverEffect.
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph gridMorph toggleShowHoverEffect]]! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:49'!
toggleShowOcclusions
	"Toggle the visualization of occluded cards in all iteration morphs in this project tape."
	
	self openStoriesMorph userStoryMorphs do: [:us |
		us toggleShowOcclusions].
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph userStoryMorphs do: [:us |
				us toggleShowOcclusions]]]! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:16'!
toggleSmoothMoving
	"Toggle the smooth moving in all grids in all iteration morphs in this project tape."
	
	self openStoriesMorph gridMorph toggleSmoothMoving.
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph gridMorph toggleSmoothMoving]]! !

XpfFixedEndTapeMorph subclass: #XpfReleaseTapeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfReleaseTapeMorph commentStamp: 'mt 10/4/2009 14:05' prior: 0!
I am a tape that stores a release separator morph with some controls as fixed morph at the end.!

!XpfReleaseTapeMorph class methodsFor: 'examples' stamp: 'mt 8/27/2009 19:50'!
exampleTape
	"Create an example tape and put it in a scrollable area."
	
	^ self new
		addMorphs: {
			XpfIterationMorph exampleIteration.
			XpfIterationMorph exampleIteration.
			XpfIterationMorph exampleIteration.
			XpfIterationMorph exampleIteration}! !

!XpfReleaseTapeMorph class methodsFor: 'constants' stamp: 'mt 10/4/2009 13:58'!
fixedEndClass
	
	^ XpfReleaseSeparatorMorph! !

!XpfReleaseTapeMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 10:40'!
addIterationMorph: anXpfIteration

	self
		showMessage: 'Iteration added.';
		addMorph: (XpfIterationMorph new model: anXpfIteration).! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/28/2009 17:30'!
addNewIteration: aTitleString

	^ self release addNewIteration: (Dictionary newFrom: {'title' -> aTitleString})! !

!XpfReleaseTapeMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 17:30'!
createIteration

	self release ifNil: [^ self addMorph: XpfIterationMorph new].

	(FillInTheBlankMorph
		request: 'Choose a name for the iteration:'
		initialAnswer: '(unnamed)')
			ifNotNilDo: [:title | self addNewIteration: title]	! !

!XpfReleaseTapeMorph methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:01'!
drawSeparatorOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ bb bottom
		width: 1
		color: self palette dark
		stepWidth: 3
		secondWidth: 1
		secondColor: Color transparent
		secondStepWidth: 6! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/28/2009 17:42'!
model: anXpfRelease

	self model ifNotNilDo: [:mod |
		mod removeDependent: self.
		mod iterations removeDependent: self].

	model := anXpfRelease.
		
	self model ifNotNilDo: [:mod |		
		mod addDependent: self.
		mod iterations addDependent: self].
	
	self processModel.! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 12/2/2009 10:57'!
processModel

	super processModel.
	
	XpfSplashScreen appendMessage: 'Iterations...'.

	self addMorphs:
		(self release iterations allButLast collect: [:iteration |
			XpfIterationMorph new model: iteration]).! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/24/2009 14:34'!
release

	^ self model! !

!XpfReleaseTapeMorph methodsFor: 'accessing' stamp: 'mt 10/4/2009 13:58'!
releaseSeparator

	^ self fixedEndMorph! !

!XpfReleaseTapeMorph methodsFor: 'drawing' stamp: 'mt 10/8/2009 09:35'!
sortedSubmorphsForScaling
	"Override to ignore the fixed-end-morph, here: #releaseSeparator."

	^ self contentSubmorphs! !

!XpfReleaseTapeMorph methodsFor: 'updating' stamp: 'mt 10/28/2009 18:33'!
update: aSymbol

	super update: aSymbol.

	aSymbol = #newIterationRequested ifTrue: [
		self createIteration].! !

!XpfReleaseTapeMorph methodsFor: 'updating' stamp: 'mt 10/29/2009 10:33'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.

	aSymbol = #iterationsAdded ifTrue: [self addIterationMorph: anObject].! !

!XpfTapeMorph class methodsFor: 'examples' stamp: 'mt 9/2/2009 14:42'!
exampleTape
	"Create an example tape and put it in a scrollable area."
	
	^ (self new
		addMorphs: {
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape})! !

!XpfTapeMorph class methodsFor: 'constants' stamp: 'mt 9/29/2009 10:24'!
tapeHeight

	^ (XpfUserStoryMorph defaultHeight + XpfUserStoryGridMorph defaultVSpacing) * 5! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 14:43'!
addMorph: aMorph
	"Hint: If you want to add more than one morph at a time, see #addMorphs:."
	
	self addMorphs: {aMorph}.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 15:27'!
addMorphSilent: aMorph

	super addMorph: aMorph.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 16:12'!
addMorphs: someMorphs
	"Keep all submorphs in a sorted list. This is important for their visual appearance."
	
	| additionalWidth |
	self sortedSubmorphs addAll: someMorphs.
	
	additionalWidth := 0.
	someMorphs do: [:m |
		m height: self height.
		m addDependent: self.
		super addMorph: m.
		additionalWidth := additionalWidth + m width].

	self
		expandToRight: additionalWidth;
		updatePositions;
		changed: #resizedRight with: additionalWidth.! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'topa 8/31/2009 14:41'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb

	| shift |
	shift := 0.
	self sortedSubmorphsForScaling do: [:morph | |newShift|
		newShift := shift + (morph width * aFactor x).
		morph
			drawScaledOn: aCanvas
			factor: aFactor
			boundingBox: ((bb topLeft + (shift@0)) corner: (bb topLeft + (newShift @ bb height))).
		shift := newShift]
	separatedBy: [
		self drawSeparatorOn: aCanvas shift: shift boundingBox: bb].! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:01'!
drawSeparatorOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ bb bottom
		color: self palette dark! !

!XpfTapeMorph methodsFor: 'initialization' stamp: 'mt 10/29/2009 10:42'!
initialize

	super initialize.
	
	self
		color: self palette verydark;
		height: XpfTapeMorph tapeHeight;
		borderWidth: 0;
		width: 0.! !

!XpfTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/4/2009 14:17'!
model
	"Override to avoid creating custom models on demand."
	
	^ model! !

!XpfTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 09:47'!
model: aModel

	self model ifNotNilDo: [:mod | mod removeDependent: self].
	model := aModel.
	self model ifNotNilDo: [:mod | mod addDependent: self. self processModel].! !

!XpfTapeMorph methodsFor: 'accessing' stamp: 'mt 10/26/2009 14:39'!
name
	"^ <String>"
	
	^ name ifNil: ['unnamed']! !

!XpfTapeMorph methodsFor: 'accessing' stamp: 'mt 10/26/2009 14:36'!
name: aString
	
	name := aString! !

!XpfTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 10:33'!
processModel
	"Used to read model data, create morphs a.s.o. - Called once after setting the model."

	self removeAllSubmorphs.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 11:00'!
removeAllSubmorphs

	self removeMorphs: self sortedSubmorphs.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 10:59'!
removeMorph: aMorph

	self removeMorphs: {aMorph}.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/28/2009 18:37'!
removeMorphs: someMorphs

	| w |
	w := 0.
	someMorphs do: [:m |
		w := w + m width.
		m removeDependent: self.
		self sortedSubmorphs
			remove: m
			ifAbsent: [w := w - m width].
		super removeMorph: m].
	self
		expandToRight: w negated;
		updatePositions;
		changed: #resizedRight with: w negated.! !

!XpfTapeMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 19:13'!
showMessage: aString

	XpfOverlayMessage showAtAllHands: aString.! !

!XpfTapeMorph methodsFor: 'accessing' stamp: 'mt 8/20/2009 14:13'!
sortedSubmorphs

	sortedSubmorphs ifNil: [sortedSubmorphs := OrderedCollection new].
	^ sortedSubmorphs! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'topa 8/31/2009 14:41'!
sortedSubmorphsForScaling

	^ self sortedSubmorphs! !

!XpfTapeMorph methodsFor: 'updating' stamp: 'mt 9/29/2009 16:14'!
update: aSymbol
	
	aSymbol = #resized ifTrue: [
		self
			updatePositions;
			bounds: self submorphBounds;
			changed: #resized. "to be recursive"
		Notification signal: 'Should not happen!!'].! !

!XpfTapeMorph methodsFor: 'updating' stamp: 'mt 9/29/2009 16:34'!
update: aSymbol with: aNumber
	"React to size change requests due to size grip activities."
	
	aSymbol = #resized ifTrue: [^ self].
	aSymbol = #resizedLeft ifTrue: [
		self expandToLeft: aNumber.
		self left: self left + aNumber.
		self
			changed: #resized
			with: aNumber].
	aSymbol = #resizedRight ifTrue: [
		self expandToRight: aNumber.
		self
			changed: #resized
			with: 0].
	
	self
		updatePositions;
		changed: aSymbol with: aNumber. "to be recursive"! !

!XpfTapeMorph methodsFor: 'updating' stamp: 'mt 8/20/2009 14:14'!
updatePositions
	"Change the positions of all submorphs to appear from left to right without spacing."
	
	| shift |
	shift := 0.
	
	self sortedSubmorphs do: [:m |
		m position: self position + (shift@0).
		shift := shift + m width].! !

!XpfTapeMorph methodsFor: 'initialization' stamp: 'mt 9/29/2009 16:03'!
withScrollBar

	self width = 0 ifTrue: [Error signal: 'Tape width must not be zero to create scroller!!'].
	^ XpfTapeScroller new
		scrollTarget: self! !

!Morph methodsFor: '*xpf-client-override' stamp: 'mt 9/29/2009 16:50'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."
	| layout |
	layout := self layoutPolicy.
	layout ifNil:[^self addMorphFront: aMorph].
	self privateAddMorph: aMorph 
		atIndex: (layout indexForInserting: aMorph at: evt position in: self).! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'mfp 3/19/2009 14:43'!
acceptsTasks

	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'cs 3/10/2009 16:13'!
acceptsUserStories

	^ false! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/18/2009 09:44'!
addPolymorphColumn

	^ self addMorphBack: (self theme newColumnIn: self for: {})! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/18/2009 09:42'!
addPolymorphRow

	^ self addMorphBack: (self theme newRowIn: self for: {})! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/18/2009 11:25'!
allSubmorphsWith: aConditionBlock do: aBlock 
	"Evaluate the given block for all morphs in this composite morph (including the receiver)."

	submorphs do: [:m | aBlock value: m.
		(aConditionBlock value: m)
			ifTrue: [m allSubmorphsWith: aConditionBlock do: aBlock]].! !

!Morph methodsFor: '*xpf-client-geometry' stamp: 'mt 8/6/2009 19:45'!
expandTo: aDirection delta: aNumber
	"private - expand morph to the opposite of the given direction"
	
	| myOrigin submorphOrigins |
	submorphOrigins := OrderedCollection new.
	self submorphs do: [:m | submorphOrigins add: m position].
	myOrigin := self perform: aDirection asSymbol.
	
	(aDirection = #left) | (aDirection = #right)
		ifTrue: [self width: self width + aNumber]
		ifFalse: [self height: self height + aNumber].
		
	self perform: (aDirection, #:) asSymbol with: myOrigin.
	self submorphs withIndexDo: [:m :i | m position: (submorphOrigins at: i)].! !

!Morph methodsFor: '*xpf-client-geometry' stamp: 'mt 8/6/2009 19:42'!
expandToBottom: aNumber

	self expandTo: #top delta: aNumber! !

!Morph methodsFor: '*xpf-client-geometry' stamp: 'mt 8/6/2009 19:42'!
expandToLeft: aNumber

	self expandTo: #right delta: aNumber! !

!Morph methodsFor: '*xpf-client-geometry' stamp: 'mt 8/6/2009 19:42'!
expandToRight: aNumber

	self expandTo: #left delta: aNumber! !

!Morph methodsFor: '*xpf-client-geometry' stamp: 'mt 8/6/2009 19:43'!
expandToTop: aNumber

	self expandTo: #bottom delta: aNumber! !

!Morph methodsFor: '*xpf-client' stamp: 'mt 10/7/2009 09:15'!
formerOwnerStillUsesModel
	"You can use all morphs that understand #model here."

	self formerOwner ifNotNilDo: [ :o | 
		^ (o submorphs anySatisfy: [ :s | s model = self model ])].
	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'mfp 3/19/2009 16:14'!
isEntityMorphContent

	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'topa 3/19/2009 14:53'!
isTaskMorph

	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'SR 4/14/2009 21:04'!
isXpfTaskTitleContent

	^ false! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'mfp 3/19/2009 16:15'!
isXpfUserStoryTitleContent

	^ false! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/30/2009 13:43'!
newColumnFor: controls
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/30/2009 13:44'!
newRowFor: controls
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!Morph methodsFor: '*xpf-client-colors' stamp: 'mt 9/17/2009 10:59'!
palette

	^ XpfDefaultColorPalette! !

!Morph methodsFor: '*xpf-client-testing' stamp: 'mt 10/9/2009 11:17'!
submorphOverlapsWith: anotherMorph

	self submorphs do: [:m |
		(m topLeft = anotherMorph topLeft and: [m ~= anotherMorph])
			ifTrue: [^ true]].
	^ false! !

Morph subclass: #XpfEstimationCircleMorph
	instanceVariableNames: 'nUnits radius segmentUnitsComputing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfEstimationCircleMorph class methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:23'!
nUnits: anInteger segmentUnitsComputing: aBlock
	^ self new nUnits: anInteger; segmentUnitsComputing: aBlock; yourself! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 18:32'!
diameter
	^ self radius * 2! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 17:36'!
drawOn: aCanvas

	| nPolygons nSegmentPolygons gamma vertices deltaY deltaX segmentColor delta nSegmentsUnit |
	
	aCanvas fillOval: self bounds color: Color veryVeryLightGray borderWidth: 0 borderColor: nil.
	
	nSegmentsUnit := self segmentUnitsComputing value.
	(nSegmentsUnit > 0) ifTrue: [		
		nPolygons := self nUnits.
		nSegmentPolygons := nSegmentsUnit.
		gamma := 360 / nPolygons.
		vertices := OrderedCollection new.
		vertices addAll: {self center. self center + (self radius @ 0)}.

		1 to: nSegmentPolygons do: [:i |
			deltaY := (gamma*i) degreeSin * self radius.
			deltaX := ((self radius * self radius) - (deltaY*deltaY)) sqrt.
			delta := (deltaX rounded * (gamma*i+90) degreeSin sign)@(deltaY rounded).
			vertices add: (self center + delta).
		].
		segmentColor := Color r: 1.0 g: 0.725 b: 0.482.
		aCanvas drawPolygon: vertices color: segmentColor borderWidth: 0 borderColor: nil.		
	].! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 18:32'!
initialize
	super initialize.
	self radius: 30.
	self extent: self diameter @ self diameter.! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
nUnits
	^nUnits ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:24'!
nUnits: anObject
	nUnits := anObject ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
radius
	^ radius  ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 19:44'!
radius: anInteger
	radius := anInteger. ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
segmentUnitsComputing
	^ segmentUnitsComputing! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:22'!
segmentUnitsComputing: aBlock
	segmentUnitsComputing := aBlock.! !

Morph subclass: #XpfGridMorph
	instanceVariableNames: 'parentMorph margin hSpacing vSpacing smoothMoving showGrid showHoverEffect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfGridMorph commentStamp: 'mt 9/11/2009 11:25' prior: 0!
I am a morph that helps its parent morph to layout in a grid.!

!XpfGridMorph class methodsFor: 'instance creation' stamp: 'mt 9/11/2009 11:27'!
forMorph: aMorph

	^ self basicNew
		parentMorph: aMorph;
		initialize! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 11/6/2009 20:37'!
calculateCell: aGlobalPoint
	"Use the given point to calculate the resulting cell."
	
	| row col tl |
	tl := self localPointToGlobal: self topLeft.
	row := aGlobalPoint y.
	col := aGlobalPoint x.
	
	row := (row - tl y - self margin top) // self vStep.
	col := (col - tl x - self margin left) // self hStep.
			
	^ col @ row! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:37'!
cellHeight

	^ 50! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:37'!
cellWidth

	^ 50! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 10/8/2009 15:25'!
columnCount

	^ (self width - self margin left - self margin right) // self hStep! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:03'!
columnSpan

	^ 1! !

!XpfGridMorph methodsFor: 'drawing' stamp: 'mt 12/1/2009 16:14'!
drawGridOn: aCanvas
	"Just show the grid."

	| offset tw th|
	offset := self topLeft + self margin topLeft.
	tw := self width - self margin left - self margin right.
	th := self height - self margin top - self margin bottom.
	
	[offset := offset + (self hStep @ 0). offset x < self right]
		whileTrue: [
			aCanvas
				line: offset
				to: offset + (0 @ th)
				width: 1 "self hSpacing"
				color: self palette middark
				stepWidth: 3
				secondWidth: 1
				secondColor: Color transparent
				secondStepWidth: 6.
				
			[offset := offset + (0 @ self vStep). offset y < self bottom]
				whileTrue: [
					aCanvas
						line: offset
						to: offset - (self hStep @ 0)
						width: 1 "self vSpacing"
						color: self palette middark
						stepWidth: 3
						secondWidth: 1
						secondColor: Color transparent
						secondStepWidth: 6].
			
			offset := offset x @ (self margin top + self top)].	! !

!XpfGridMorph methodsFor: 'drawing' stamp: 'mt 9/29/2009 09:52'!
drawHoverEffectOn: aCanvas 
	"Highlight the current sector in the grid. Use current mouse position."
	
	| cursorPos targetRect |
	cursorPos := self globalPointToGridPoint: World hands first position.
	targetRect := cursorPos
		corner: cursorPos + ((self cellWidth * self columnSpan) @ (self cellHeight * self rowSpan)).
		
	(targetRect left >= (self left + self margin left)
		and: [targetRect right <= (self right - self margin right)])
		ifTrue: [aCanvas
			fillRectangle: targetRect
			color: self palette mid].! !

!XpfGridMorph methodsFor: 'drawing' stamp: 'mt 12/1/2009 16:25'!
drawOn: aCanvas
	"Highlight the current sector in the grid. Use current mouse position."
	
	self showHoverEffect
		ifTrue: [self drawHoverEffectOn: aCanvas].
	
	self showGrid
		ifTrue: [self drawGridOn: aCanvas].! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 9/11/2009 14:20'!
fixMorphPosition: aMorph

	self fixMorphPosition: aMorph targetPoint: aMorph center! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 10/26/2009 15:22'!
fixMorphPosition: aMorph targetCell: aPoint
	"Let the morph snap into the grid. Use logic coordinates (column, row)."
	
	self
		fixMorphPosition: aMorph
		targetPoint: (self localPointToGlobal: (((aPoint x * self hStep) + self margin left)@((aPoint y * self vStep) + self margin top))
			+ self topLeft)! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 11/1/2009 14:02'!
fixMorphPosition: aMorph targetPoint: aGlobalPoint
	"Let the morph snap into the grid."
	
	self smoothMoving
		ifTrue: [XpfSmoothMorphMover moveMorph: aMorph toTopLeft: (self globalPointToGridPoint: aGlobalPoint)]
		ifFalse: [aMorph topLeft: (self globalPointToGridPoint: aGlobalPoint)]	! !

!XpfGridMorph methodsFor: 'private' stamp: 'mt 9/17/2009 12:16'!
globalPointToGridPoint: aPoint
	"Map the given point to be in the grid (topLeft in sector)"

	| pt |
	pt := (self globalPointToLocal: aPoint) - (self left @ 0).

	^ ((((pt x - self margin left) // self hStep) * self hStep)
			+ self left + self margin left + (self hSpacing / 2))
		@
		((((pt y - self margin top) // self vStep) * self vStep)
			+ self margin top + (self vSpacing / 2))! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 13:16'!
hSpacing

	hSpacing ifNil: [hSpacing := 4].
	^ hSpacing! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:21'!
hSpacing: anObject

	hSpacing := anObject.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:04'!
hStep

	^ self cellWidth + (self hSpacing // self columnSpan)! !

!XpfGridMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 14:54'!
handleMouseLeave: evt
	"Force a redraw."
	
	self changed.! !

!XpfGridMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 13:34'!
handleMouseMove: evt
	"Force a redraw."
	
	self changed.! !

!XpfGridMorph methodsFor: 'initialization' stamp: 'mt 9/11/2009 11:27'!
initialize

	super initialize.
	self updateExtent.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:08'!
margin
	"Create a default margin if margin is not set already."

	margin ifNil: [margin := 5@5 corner: 5@5].
	^ margin! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:07'!
margin: anObject

	margin := anObject.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 9/11/2009 11:25'!
parentMorph

	^ parentMorph! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 9/11/2009 11:25'!
parentMorph: anObject

	parentMorph := anObject.! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 10/8/2009 11:19'!
proposeNewExtent: aPoint
	"Suggest a better value for a new extent to fit the grid exactly."
	
	| newWidth newHeight |
	newWidth := (aPoint x - self margin left - self margin right) max: 0.
	
	(newWidth \\ self hStep) > 0
		ifTrue: [newWidth := (((newWidth // self hStep) + 1) * self hStep)].
	newWidth := newWidth + self margin left + self margin right.
	
	newHeight := aPoint y.
	
	^ newWidth @ newHeight! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 10/8/2009 15:25'!
rowCount

	^ (self height - self margin top - self margin bottom) // self vStep! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:06'!
rowSpan

	^ 1! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:05'!
showGrid

	^ showGrid ifNil: [false]! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:05'!
showGrid: anObject

	showGrid := anObject.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:23'!
showHoverEffect

	^ showHoverEffect ifNil: [true]! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:22'!
showHoverEffect: anObject

	showHoverEffect := anObject.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:03'!
smoothMoving
	"^ <Boolean>"

	^ smoothMoving ifNil: [smoothMoving := false]! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:03'!
smoothMoving: aBoolean

	smoothMoving := aBoolean.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:11'!
toggleShowGrid

	self showGrid: self showGrid not.
	self changed. "force a redraw"! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:23'!
toggleShowHoverEffect

	self showHoverEffect: self showHoverEffect not.
	self changed. "force redraw"! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:16'!
toggleSmoothMoving

	self smoothMoving: self smoothMoving not.! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 9/11/2009 12:04'!
updateExtent
	"Change my own extent to my parent morph's extent."
	
	self parentMorph ifNil: [^ self].
	self extent: self parentMorph extent.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 13:18'!
vSpacing

	vSpacing ifNil: [vSpacing := 4].
	^ vSpacing! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:22'!
vSpacing: anObject

	vSpacing := anObject.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:04'!
vStep

	^ self cellHeight + (self vSpacing // self rowSpan)! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:43'!
virtualHeight

	^ self height - self margin top - self margin bottom! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:43'!
virtualWidth

	^ self width - self margin left - self margin right! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 11/7/2009 11:57'!
withoutSmoothMoving: aBlock

	| state |
	state := self smoothMoving.
	self smoothMoving: false.
	
	aBlock value.
	
	self smoothMoving: state.! !

XpfGridMorph subclass: #XpfUserStoryGridMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfUserStoryGridMorph commentStamp: 'mt 9/17/2009 11:33' prior: 0!
I am a grid that is specialized to user story morphs.!

!XpfUserStoryGridMorph class methodsFor: 'constants' stamp: 'mt 9/29/2009 10:23'!
defaultHSpacing

	^ 4! !

!XpfUserStoryGridMorph class methodsFor: 'constants' stamp: 'mt 9/29/2009 10:24'!
defaultVSpacing

	^ 4! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:43'!
cellHeight

	^ XpfUserStoryMorph defaultHeight // 2! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:37'!
cellWidth

	^ XpfUserStoryMorph defaultWidth! !

!XpfUserStoryGridMorph methodsFor: 'updating' stamp: 'mt 11/6/2009 20:02'!
fixMorphPosition: aUserStoryMorph
	"OVERRIDE: Use logic coordinates (row, column) of the user story."

	self
		fixMorphPosition: aUserStoryMorph
		targetCell: aUserStoryMorph model position.
	
	"self owner ifNotNilDo: [:o |
		(o submorphOverlapsWith: aUserStoryMorph)
			ifTrue: [aUserStoryMorph borderWidth: 5]
			ifFalse: [aUserStoryMorph borderWidth: 1]]."! !

!XpfUserStoryGridMorph methodsFor: 'updating' stamp: 'mt 12/1/2009 19:13'!
fixMorphPosition: aUserStoryMorph targetCell: aPoint

	super
		fixMorphPosition: aUserStoryMorph
		targetCell: aPoint.
		
	aUserStoryMorph detectAndShowOcclusions.! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/29/2009 10:25'!
hSpacing
	"OVERRIDE: Use a constant value."
	
	^ self class defaultHSpacing! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:07'!
rowSpan

	^ 2! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/29/2009 10:25'!
vSpacing
	"OVERRIDE: Use a constant value."

	^ self class defaultVSpacing! !

Morph subclass: #XpfPagingAreaMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfPagingAreaMorph commentStamp: 'mt 8/29/2009 10:12' prior: 0!
I should only be used in a scrollable area where the #scrollTarget is a 2-level-tape.!

!XpfPagingAreaMorph methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:00'!
drawOn: aCanvas
	"Depends on a 2-Level-Tape."

	| tape |
	self model ifNil: [^ self].
	
	aCanvas
		fillRectangle: self bounds
		color: self palette light.
	
	tape := self model model scrollTarget.
	
	tape 
		drawScaledOn: aCanvas 
		factor: (self width asFloat / tape fullBounds width) @ (self height asFloat / tape height)
		boundingBox: self bounds.
	
	
	"self model drawAnchorsOn: aCanvas".! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 18:34'!
model
	"The scrollbar that uses this paging area. See XpfNavigationBar."
	
	^ model! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 18:33'!
model: anObject

	model := anObject.! !

Morph subclass: #XpfReleaseSeparatorMorph
	instanceVariableNames: 'addIterationButton editReleaseButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfReleaseSeparatorMorph commentStamp: 'mt 8/20/2009 13:40' prior: 0!
I can be used as a visual border between two iterations belonging to different releases.
My buttons provide editing facilities like adding a new iteration.
I represent one release and you should position me beside an iteration that belongs to me.!

!XpfReleaseSeparatorMorph methodsFor: 'accessing' stamp: 'topa 10/7/2009 11:11'!
addIterationButton

	addIterationButton ifNil: [
		addIterationButton := IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfAddIteration;
		actionSelector: #requestNewIteration;
		extent: 16@16;
		setBalloonText: 'Add new iteration' translated].
	^ addIterationButton! !

!XpfReleaseSeparatorMorph methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:00'!
drawOn: aCanvas

	aCanvas
		drawPolygon: {
			self topLeft.
			self topRight + (0 @ self width).
			self bottomRight - (0 @ self width).
			self bottomLeft}
		fillStyle: (SolidFillStyle color: self palette mid).! !

!XpfReleaseSeparatorMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 17:59'!
editReleaseButton

	editReleaseButton ifNil: [
		editReleaseButton := IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfPencil;
		actionSelector: nil;
		extent: 16@16;
		setBalloonText: 'Edit release' translated].
	^ editReleaseButton! !

!XpfReleaseSeparatorMorph methodsFor: 'initialization' stamp: 'mt 10/8/2009 09:36'!
initialize

	super initialize.
	self
		extent: 18@100;
		color: Color black;
		addMorph: self addIterationButton;
		addMorph: self editReleaseButton.

	self addIterationButton
		position: self position + (1 @ (self width + 1 * 3)).
	self editReleaseButton 
		position: self position + (1 @ (self width + 1 * 4)).! !

!XpfReleaseSeparatorMorph methodsFor: 'actions' stamp: 'topa 10/7/2009 11:18'!
requestNewIteration

	self changed: #newIterationRequested.! !

Morph subclass: #XpfReloadIndicator
	instanceVariableNames: 'count max bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Taskbar'!

!XpfReloadIndicator methodsFor: 'accessing' stamp: 'mt 12/8/2009 16:35'!
bar

	^ bar ifNil: [bar := Morph new
		extent: self extent;
		color: self palette mid]! !

!XpfReloadIndicator methodsFor: 'accessing' stamp: 'mt 12/8/2009 15:46'!
count

	^ count! !

!XpfReloadIndicator methodsFor: 'accessing' stamp: 'mt 12/8/2009 15:46'!
count: anObject

	count := anObject.! !

!XpfReloadIndicator methodsFor: 'initialization' stamp: 'mt 12/8/2009 16:35'!
initialize

	super initialize.
	self
		borderWidth: 0;
		color: Color transparent;
		extent: 8@20;
		borderColor: self palette mid;
		addMorph: self bar;
		reset.! !

!XpfReloadIndicator methodsFor: 'accessing' stamp: 'mt 12/8/2009 15:47'!
max

	^ max! !

!XpfReloadIndicator methodsFor: 'accessing' stamp: 'mt 12/8/2009 15:47'!
max: anObject

	max := anObject.! !

!XpfReloadIndicator methodsFor: 'initialization' stamp: 'mt 12/8/2009 16:37'!
reset

	self assureExtension balloonText: 'Updating stopped.'.
	self
		count: nil;
		stopStepping;
		color: self palette verydark;
		borderWidth: 1.
		
	self bar hide.! !

!XpfReloadIndicator methodsFor: 'initialization' stamp: 'mt 12/8/2009 16:37'!
reset: aNumber
	"Reset the indicator with the time to the next update."
	
	self
		startStepping;
		max: aNumber;
		count: aNumber.
		
	self bar show.! !

!XpfReloadIndicator methodsFor: 'stepping and presenter' stamp: 'mt 12/30/2009 15:42'!
step

	(count isNil | max isNil or: [count <= 0])
		ifTrue: [^ self].
			
	self assureExtension balloonText:
		'Repository login: ', XpfTaskbarExtension instance connection repository login, String cr,
		self count asString, ' secs until update'.
	
	self bar height: (self height * (self count / self max)).
	self bar bottom: self bottom.
		
	self count: self count - 1.! !

!XpfReloadIndicator methodsFor: 'testing' stamp: 'mt 12/8/2009 15:45'!
stepTime

	^ 1000! !

!XpfReloadIndicator methodsFor: 'updating' stamp: 'mt 12/8/2009 15:56'!
update: aSymbol

	aSymbol = #reloadStopped ifTrue: [self reset].! !

!XpfReloadIndicator methodsFor: 'updating' stamp: 'mt 12/8/2009 15:44'!
update: aSymbol with: aNumber

	aSymbol = #nextReload ifTrue: [self reset: aNumber].! !

Morph subclass: #XpfResizeGrip
	instanceVariableNames: 'orientation origin overlay isHighlighted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfResizeGrip commentStamp: 'mt 8/6/2009 19:52' prior: 0!
I recognize mouse drags in the horizontal axis.!

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 10:59'!
doubleClick: evt

	self changed: #fitToSubmorphs with: {self. 0}.! !

!XpfResizeGrip methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:04'!
drawOn: aCanvas

	| len shift1 shift2 tmp dcolor |
	len := self width - 4.
	
	shift1 := self isHighlighted
		ifTrue: [(self left + 1) @ ((((self globalPointToLocal: World hands first position) y - self width max: self top) min: self bottom))]
		ifFalse: [self topLeft + (1 @ (self height / 2 - (self width * 1.5)))].
	
	shift2 := shift1 + (0 @ self width).
	
	dcolor := self isHighlighted
		ifTrue: [self palette verydark]
		ifFalse: [self palette mid].

	self orientation = #toRight
		ifTrue: [tmp := shift1. shift1 := shift2. shift2 := tmp].

	aCanvas
		drawPolygon: {
			(0 @ len) + shift1.
			(len @ 0) + shift1.
			(len @ (len * 2)) + shift1}
		fillStyle: (SolidFillStyle color: dcolor).

	aCanvas
		drawPolygon: {
			(len @ len) + shift2.
			(0 @ 0) + shift2.
			(0 @ (len * 2)) + shift2}
		fillStyle: (SolidFillStyle color: dcolor).! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/27/2009 16:38'!
handleMouseMove: evt

	origin ifNil: [^ self].
	self left: evt targetPoint x.
	self overlay bounds: (origin quickMerge: self bounds).! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/6/2009 11:39'!
handlesMouseDown: evt

	^ true	! !

!XpfResizeGrip methodsFor: 'initialization' stamp: 'mt 8/6/2009 12:36'!
initialize

	super initialize.
	self
		extent: 10@300;
		color: Color gray muchLighter;
		borderStyle: BorderStyle raised;
		borderWidth: 1.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/27/2009 15:57'!
isHighlighted

	isHighlighted ifNil: [self isHighlighted: false].
	^ isHighlighted.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/29/2009 09:43'!
isHighlighted: aBoolean

	isHighlighted := aBoolean.
	self changed.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 11:02'!
mouseDown: evt

	self comeToFront.
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. #doubleClick:. nil. #startDrag:}
		threshold: 1.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 10:54'!
mouseUp: evt

	origin = nil ifTrue: [^ self].
	
	self
		changed: #resized
		with: {self. self orientation = #toLeft
			ifTrue:  [(origin center - self center) x]
			ifFalse: [(self center - origin center) x]}.
			
	origin := nil.
	self overlay hide.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 20:10'!
orientation

	orientation ifNil: [self orientation: #toLeft].
	^ orientation! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 20:11'!
orientation: anObject
	"Used to decide the sign of the move operation delta.
	#toLeft ... origin - position
	#toRight ... position - origin"
	
	orientation := anObject.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 12:16'!
overlay

	overlay ifNil: [
		overlay := Morph new.
		overlay color: (Color gray alpha: 0.2).
		self addMorph: overlay].
	^ overlay! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 13:32'!
overlayColor: aColor

	self overlay color: ((aColor mixed: 0.7 with: Color white) alpha: 0.8).
	self color: aColor.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/6/2009 12:38'!
show

	super show.
	self overlay hide.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 11:02'!
startDrag: evt

	origin := self bounds.
	(self overlay)
		bounds: self bounds;
		show.! !

Morph subclass: #XpfToolbarMorph
	instanceVariableNames: 'commandProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfToolbarMorph commentStamp: 'mt 9/6/2009 18:53' prior: 0!
I provide buttons for actions delivered by a "command provider". This provider object should understand #availableCommands and return a list of XpfCommand objects.!

!XpfToolbarMorph methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:18'!
commandProvider

	^ commandProvider! !

!XpfToolbarMorph methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:44'!
commandProvider: anObject

	commandProvider := anObject.
	self updateButtons.! !

!XpfToolbarMorph methodsFor: 'initialize-update' stamp: 'mt 9/2/2009 14:22'!
createButtonForCommand: aCommand

	^ IconicButton new
		color: Color transparent;
		target: aCommand target;
		borderWidth: 0;
		labelGraphic: aCommand icon;
		actionSelector: aCommand selector;
		extent: 16@16;
		setBalloonText: aCommand name translated! !

!XpfToolbarMorph methodsFor: 'initialize-update' stamp: 'mt 9/17/2009 11:01'!
initialize

	super initialize.
	self
		extent: 22@100;
		color: self palette mid;
		updateButtons.! !

!XpfToolbarMorph methodsFor: 'initialize-update' stamp: 'mt 12/1/2009 16:03'!
updateButtons

	| offset |
	self removeAllMorphs.
	self commandProvider ifNil: [^ self]. "No provider -> no commands -> no buttons."
	
	offset := 5@2.
	self commandProvider availableCommands do: [:command | | btn |
		btn := self createButtonForCommand: command.
		self addMorph: btn.
		btn position: self position + offset.
		offset := offset + (0 @ (btn height + 5))].! !

Morph subclass: #XpfUserStoryModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk-New'!

!XpfUserStoryModel commentStamp: 'mt 10/8/2009 15:11' prior: 0!
This model can be used in cases where a real user story (data model) is needed.!

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionX

	^ self x! !

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionX: aNumber

	self x: aNumber! !

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionY

	^ self y! !

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionY: aNumber

	self y: aNumber! !
XpfScrollBar initialize!
SSHTunnel initialize!
XpfLoginProcessor initialize!
